#include "mex.h"
#include <stdio.h>
#include <stdlib.h>
/* ----------------------------------------------------------------------
   process a single input command. 
   command=lammps_command(lmp_pointer,'insert command');
------------------------------------------------------------------------- */
char * lammps_command(void* lmp, char* command);

void mexFunction( int nlhs, mxArray *plhs[],
int nrhs,  const mxArray *prhs[])
{
    char * result;
    long lmp1;
    double *lmp;
    char * command;
    if (nlhs != 1 && nlhs !=0)
    {
        mxErrMsgTxt("Error in lammps_command: One or Zero output arguments expected.");
    }
    if (nrhs != 2 || !mxIsChar(prhs[1]))
    {
        mxErrMsgTxt("Invalid syntax. Should be like so: lammps_command(lmp_pointer,'insert lammps command'");
    }
    command=(char *)mxMalloc(mxGetN(prhs[1]) * sizeof(char));
    mxGetString(prhs[1],command,mxGetN(prhs[1])+1);
    lmp = mxGetPr(prhs[0]);
    lmp1 = (long)*lmp;
    result = (char *)mxMalloc(100*sizeof(char));
    *result = lammps_command((void *)lmp1,command);
    plhs[0] = mxCreateString(result);
}