#include "mex.h"
#include <stdio.h>
#include <stdlib.h>
/* ----------------------------------------------------------------------
   extract an internal LAMMPS global entity
   name = desired quantity, e.g. 'dt' or 'boxyhi' or 'natoms'.
   global_data=lammps_extract_global(lmp_pointer,name);
------------------------------------------------------------------------- */

/*function prototype necessary to avoid truncation to 32 bits*/
void * lammps_extract_global(void * lmp1,char * command);

void mexFunction( int nlhs, mxArray *plhs[],
int nrhs,  const mxArray *prhs[])
{
    double *lmp;
    long lmp1;
    long data;
    double *x;
    char *command;
    if (nlhs != 1)
    {
        mxErrMsgTxt("One output argument required.");
    }
    if (nrhs != 2 || !mxIsChar(prhs[1]))
    {
        mxErrMsgTxt("Invalid synatx: Should be like so:\n global_data=lammps_extract_global(lmp_pointer,data type).\n    data types: boxxlo,boxxhi,boxylo,boxyhi,boxzlo,boxzhi,dt,natoms,nlocal.");
    }
    command=(char *)mxMalloc(mxGetN(prhs[1]) * sizeof(char));
    mxGetString(prhs[1],command,mxGetN(prhs[1])+1);
    lmp = mxGetPr(prhs[0]);
    lmp1 = (long)*lmp;
    data = (long)lammps_extract_global((void *)lmp1,command);
    if (data==NULL)
    {
        mxErrMsgTxt("Invalid data type");
    }
    plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
    x = mxGetPr(plhs[0]);
    if (strcmp(command,"dt")==0 || strcmp(command,"natoms")==0 || strcmp(command,"nlocal")==0)
    {
        x[0] = (double)(*(int *)data);
    }
    else
    {
        x[0] = *(double *)data;
    }
}
