#include "mex.h"
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
/* ----------------------------------------------------------------------
   create an instance of LAMMPS and return pointer to it
   caller doesn't know MPI communicator, so use MPI_COMM_WORLD
   intialize MPI if needed. 
   lmp_pointer=lammps_open('-var','example','0');
------------------------------------------------------------------------- */

void mexFunction( int nlhs, mxArray *plhs[1],
int nrhs,  const mxArray *prhs[])
{
    int i;
    long ** lmp;
    char **Args;
    int j;
    char *mex = {"mex"};
	double *ptr;
    if (nlhs != 1)
    {
        mexErrMsgTxt("One output argument required. All standard lammps command-line input arguments are supported. Separate arguments by commas rather than spaces as in command-line.");
    }
    for (i=0;i<nrhs;i++)
    {
        if (!mxIsChar(prhs[i]))
        {
            mexErrMsgTxt("All input arguments should be expressed as MATLAB strings");
        }
    }
	Args = mxMalloc((nrhs+1) * sizeof(char));
    lmp=mxMalloc(1 * sizeof(long));
    *lmp = mxMalloc(1 * sizeof(long));
    Args[0] = (char *)mxMalloc(4 * sizeof(char));
    mxGetString(mxCreateString(mex),Args[0],4);
    for (i = 1;i<=nrhs;i++)
    {
        Args[i] = (char *)mxMalloc(mxGetN(prhs[i-1]) * sizeof(char));
        mxGetString(prhs[i-1],Args[i],mxGetN(prhs[i-1])+1);
    }
    lammps_open_no_mpi(nrhs+1, (char **)Args, (void **)lmp);
    plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
    ptr = mxGetPr(plhs[0]);
    ptr[0] = (long)*lmp;
}

