#include "mex.h"
#include <stdio.h>
#include <stdlib.h>
/* ----------------------------------------------------------------------
   scatter the named atom-based entity across all processors
   name = desired quantity, e.g. x or charge
   type = 0 for integer values, 1 for double values
   count = # of per-atom values, e.g. 1 for type or charge, 3 for x or f
   data = atom-based values in data, ordered by count, then by atom ID
     e.g. x[0][0],x[0][1],x[0][2],x[1][0],x[1][1],x[1][2],x[2][0],...
   data=lammps_scatter_atoms(lmp_pointer,name,type,count);
------------------------------------------------------------------------- */
void mexFunction( int nlhs, mxArray *plhs[],
int nrhs,  const mxArray *prhs[])
{
    double *lmp;
    char *command;
    double *count,*type;
    long lmp1;
    if (nlhs != 1 || nrhs != 4 || !mxIsChar(prhs[1]) || !mxIsDouble(prhs[2]) || !mxIsDouble(prhs[3]))
    {
        mxErrMsgTxt("Invalid synatx: Should be like so:\n data=lammps_scatter_atoms(lmp_pointer,name,type,count).\n    type==0 for double values and type==1 for integer variables. Count is the number of per-atom values.");
    }
    command=(char *)mxMalloc(mxGetN(prhs[1]) * sizeof(char));
    mxGetString(prhs[1],command,mxGetN(prhs[1])+1);
    lmp = mxGetPr(prhs[0]);
    type = mxGetPr(prhs[1]);
    count = mxGetPr(prhs[2]);
    lmp1 = (long)*lmp;
    if ((int)*type==1)
    {
        plhs[0] = mxCreateDoubleMatrix(lammps_get_natoms((void *)lmp1),(int)*count, mxREAL);
        lammps_scatter_atoms((void *)lmp1,command,(int)*type,(int)*count,mxGetPr(plhs[0]));
    }
    else if ((int)*type==0)
    {
        plhs[0] = mxCreateNumericMatrix(lammps_get_natoms((void *)lmp1),(int)*count, mxINT32_CLASS, mxREAL);
        lammps_scatter_atoms((void *)lmp1,command,(int)*type,(int)*count,mxGetPr(plhs[0]));
    }
}