function varargout = MPCv4(varargin)
% MPCv4 MATLAB code for MPCv4.fig
%      MPCv4, by itself, creates a new MPCv4 or raises the existing
%      singleton*.
%
%      H = MPCv4 returns the handle to a new MPCv4 or the handle to
%      the existing singleton*.
%
%      MPCv4('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MPCv4.M with the given input arguments.
%
%      MPCv4('Property','Value',...) creates a new MPCv4 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MPCv4_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MPCv4_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MPCv4

% Last Modified by GUIDE v2.5 20-Aug-2015 09:57:12

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MPCv4_OpeningFcn, ...
                   'gui_OutputFcn',  @MPCv4_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MPCv4 is made visible.
function MPCv4_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MPCv4 (see VARARGIN)

% uicontrol positions
handles.UIpositions = Remember_Positions(hObject);

% Choose default command line output for MPCv4
handles.output = hObject;

handles.program_tag = 'MPCv4';
handles.program_name = 'MEAM Parameter Calibration';
handles.author = 'CAVS-MSU';
handles.contact = 'Ricolindo L Carino (Carino@CAVS.MsState.Edu)';


set(hObject, 'Name', [handles.program_name ' by ' handles.author])

% library entries: 1=GUI handle, 2=structure field name, 3=default, 4=min, 5=max, 
%    6=enable if 1 element, 7=enable if 2 elements, 8=enable if 3 or more elements
%    9=fit1, 10=fit2, 11=fit3, 12=description
%   1               2           3          4          5          6    7    8    9    10   11
library_strings = { ... % Bounds from Mike Baskes, 2014-07-11
    'lib_elt',      'elt',      'Al',      'Al',      'Al',      '0', '0', '0', '0', '0', '0', 'elt - Element';  ...
    'lib_lat',      'lat',      'fcc',     'fcc',     'fcc',     '0', '0', '0', '0', '0', '0', 'lat - Lattice structure of reference configuration'; ...
    'lib_z',        'z',        '12',      '12',      '12',      '0', '0', '0', '0', '0', '0', 'z - Number of nearest neighbors in the reference structure'; ...
    'lib_ielement', 'ielement', '13',      '13',      '13',      '0', '0', '0', '0', '0', '0', 'ielement - Atomic number'; ...
    'lib_atwt',     'atwt',     '26.9815', '26.9815', '26.9815', '0', '0', '0', '0', '0', '0', 'atwt - Atomic weight'; ...
    'lib_alpha',    'alpha',    '4.61',    '0',       '10',      '1', '0', '0', '1', '0', '0', 'alpha - Exponential decay factor for the universal energy'; ...
    'lib_b0',       'b0',       '2.21',    '0',       '5',       '1', '0', '0', '1', '0', '0', 'b0 - Exponential decay factor for atomic density'; ...
    'lib_b1',       'b1',       '2.20',    '0',       '10',      '1', '0', '0', '1', '0', '0', 'b1 - Exponential decay factor for atomic density'; ...
    'lib_b2',       'b2',       '6.0',     '0',       '10',      '1', '0', '0', '1', '0', '0', 'b2 - Exponential decay factor for atomic density'; ...
    'lib_b3',       'b3',       '2.20',    '0',       '10',      '1', '0', '0', '1', '0', '0', 'b3 - Exponential decay factor for atomic density'; ...
    'lib_alat',     'alat',     '4.05',    '1',       '5',       '1', '0', '0', '1', '0', '0', 'alat - Lattice constant of reference structure'; ...
    'lib_esub',     'esub',     '3.58',    '0',       '10',      '1', '0', '0', '1', '0', '0', 'esub - Energy per atom (eV) in the reference structure at equilibrium'; ...
    'lib_asub',     'asub',     '1.07',    '0.5',     '2',       '1', '0', '0', '1', '0', '0', 'asub - Scaling factor for the embedding energy'; ...
    'lib_t0',       't0',       '1.0',     '-20',     '20',      '1', '0', '0', '1', '0', '0', 't0 - Weighting factor for atomic density'; ...
    'lib_t1',       't1',       '-1.78',   '-20',     '20',      '1', '0', '0', '1', '0', '0', 't1 - Weighting factor for atomic density'; ...
    'lib_t2',       't2',       '-2.21',   '-20',     '20',      '1', '0', '0', '1', '0', '0', 't2 - Weighting factor for atomic density'; ...
    'lib_t3',       't3',       '8.01',    '-20',     '20',      '1', '0', '0', '1', '0', '0', 't3 - Weighting factor for atomic density'; ...
    'lib_rozero',   'rozero',   '0.6',     '0.55',    '0.65',    '1', '0', '0', '0', '0', '0', 'rozero - Element-dependent density scaling that weights the reference background density'; ...
    'lib_ibar',     'ibar',     '0',       '0',       '0',       '1', '0', '0', '0', '0', '0', 'ibar - Form of the function G(Gamma) used to compute the electron density'; ...
    };

handles.library_gui_field = library_strings(:,1);
handles.library_field_label = library_strings(:,2);

% make a template for library entries
for idx=1:length(handles.library_field_label)
    label = handles.library_field_label{idx};
    if isempty(label), continue, end

    % default value
    tval = char(library_strings(idx,3));
    tnum = str2double(tval);
    if isnan(tnum) % assume characters
        % try changing 'D' exponent to 'E'
        tnum = str2double(Utility_ExponentD2E(tval));
        if isnan(tnum) % really characters
            handles.library_default.(label) = tval;
        else
            handles.library_default.(label) = tnum;
        end
    else
        handles.library_default.(label) = tnum;
    end
    
    gui_tag = handles.library_gui_field{idx};

    % mininum value
    tval = char(library_strings(idx,4));
    tnum = str2double(tval);
    if isnan(tnum) % assume characters
        % try changing 'D' exponent to 'E'
        tnum = str2double(Utility_ExponentD2E(tval));
        if ~isnan(tnum)
            handles.minval.(gui_tag) = tnum;
        end
    else
        handles.minval.(gui_tag) = tnum;
    end
    
    % maximum value
    tval = char(library_strings(idx,5));
    tnum = str2double(tval);
    if isnan(tnum) % assume characters
        % try changing 'D' exponent to 'E'
        tnum = str2double(Utility_ExponentD2E(tval));
        if ~isnan(tnum) 
            handles.maxval.(gui_tag) = tnum;
        end
    else
        handles.maxval.(gui_tag) = tnum;
    end
    
    % enable switch: (1)=no elements selected, (2)=1 element, (3)=2 elements (4)=3 or more elements
    tval = { '0', char(library_strings(idx,6)), char(library_strings(idx,7)), char(library_strings(idx,8)) };
    handles.enable.(gui_tag) = str2double(tval);
    
    % fitted switch: (1)=no elements selected, (2)=1 element, (3)=2 elements (4)=2 or more elements
    tval = { '0', char(library_strings(idx,9)), char(library_strings(idx,10)), char(library_strings(idx,11)) };
    handles.fitted.(gui_tag) = str2double(tval);

    handles.description.(gui_tag) = char(library_strings(idx,12));

end

% set field descriptions as tips
for i=1:length(handles.library_gui_field)
    gui_field_name = handles.library_gui_field{i};
    if isempty(gui_field_name), continue, end
    if isfield(handles, ['label_' gui_field_name])
        set(handles.(['label_' gui_field_name]), ...
            'ToolTipString', sprintf('%s\n', ...
            handles.description.(gui_field_name), ...
            'Right-click for other applicable actions, if any.') )
    end
end

% parameter file: 1=GUI handle, 2=structure field name, 
%   3=description
%   4=default, 5=min, 6=max, 7=enable1, 8=enable2, 9=enable3, 10=fitted1, 11=fitted2, 12=fitted3
parameter_strings =  { ...
    'param_Cmax', 'Cmax', ...
        'Cmax screening parameter when I-J pair is screened by K (I<=J)', ...
        '(1,1,1) = 2.8', '1.9', '2.8',     '1', '1', '1', '1', '1', '1'; ...
    'param_Cmin', 'Cmin', ...
        'Cmin screening parameter when I-J pair is screened by K (I<=J)', ...
        '(1,1,1) = 2.0', '0.68', '2.0',    '1', '1', '1', '1', '1', '1'; ...
    'param_Ec', 'Ec', ...
        'Ec(I,J) - cohesive energy of reference structure for I-J mixture', ...
        '(1,1) = 0', '1.51', '4.63',       '0', '1', '0', '0', '1', '1'; ...
    'param_delta', 'delta', ...
        'delta(I,J) - heat of formation for I-J alloy (overrides library esub)', ...
        '(1,1) = 0', '1.51', '4.63',       '0', '1', '0', '0', '1', '1'; ...
    'param_alpha', 'alpha', ...
        'alpha(I,J) - alpha parameter for pair potential between I and J (overrides library alpha)', ...
        '(1,1) = 0', '4.24', '5.52',       '0', '1', '0', '0', '1', '1'; ...
    'param_re', 're', ...
        're(I,J) - equilibrium distance between I and J in the reference structure (overrides library alat)', ...
        '(1,1) = 0', '2.851', '5.431',     '0', '1', '0', '0', '1', '1'; ...
    'param_lattce', 'lattce', ...
        'lattce(I,J) - lattice structure of I-J reference structure: dia/fcc/bcc/dim/b1/hcp/c11/l12/b2', ...
        '(1,1) = fcc', 'fcc', 'fcc',       '0', '1', '0', '0', '0', '0'; ...
    'param_nn2', 'nn2', ...
        'nn2(I,J) - turn on second-nearest neighbor MEAM formulation for I-J pair', ...
        '(1,1) = 0', '0', '1',             '1', '1', '0', '0', '0', '0'; ...
    'param_attrac', 'attrac', ...
        'attrac(I,J) - additional cubic attraction term in Rose energy I-J pair potential', ...
        '(1,1) = 0', '0.0', '1.0',         '1', '1', '0', '1', '1', '1'; ...
    'param_repuls', 'repuls', ...
        'repuls(I,J) - additional cubic repulsive term in Rose energy I-J pair potential', ...
        '(1,1) = 0', '0.0', '1.0',         '1', '1', '0', '1', '1', '1'; ...
    'param_zbl', 'zbl', ...
        'zbl(I,J) - blend the MEAM I-J pair potential with the ZBL potential for small atom separations', ...
        '(1,1) = 1', '1', '1',             '0', '1', '0', '0', '0', '0'; ...
    'param_rho0', 'rho0', ...
        'rho0(I) - relative density for element I', ...
        '(1) = 1.0', '0.63', '2.2',          '0', '1', '0', '0', '0', '0'; ...
    'param_rc', 'rc', ...
        'rc - cutoff radius for cutoff function', ...
        '4.0', '4.0', '6.0',               '1', '1', '1', '0', '0', '0'; ...
    'param_delr', 'delr', ...
        'delr - length of smoothing distance for cutoff function', ...
        '0.1', '0.001', '0.15',            '1', '1', '1', '0', '0', '0'; ...
    'param_gsmooth_factor', 'gsmooth_factor', ...
        'gsmooth_factor - factor determining the length of the G-function smoothing region; only significant for ibar=0 or ibar=4', ...
        '99.0', '99.0', '99.0',            '1', '1', '1', '0', '0', '0'; ...
    'param_augt1', 'augt1', ...
        'integer flag for whether to augment t1 parameter by 3/5*t3 to account for old vs. new meam formulations', ...
        '1', '1', '1',                     '1', '1', '1', '0', '0', '0'; ...
    'param_ialloy', 'ialloy', ...
        'ialloy - integer flag to use alternative averaging rule for t parameters, for comparison with the DYNAMO MEAM code', ...
        '0', '0', '0',                     '1', '1', '1', '0', '0', '0'; ...
    'param_mixture_ref_t', 'mixture_ref_t', ...
        'mixture_ref_t - integer flag to use mixture average of t to compute the background', ...
        '0', '0', '0',                     '1', '1', '1', '0', '0', '0'; ...
    'param_erose_form', 'erose_form', ...
        'erose_form - integer value to select the form of the Rose energy function', ...
        '0', '0', '0',                     '1', '1', '1', '0', '0', '0'; ...
    'param_emb_lin_neg', 'emb_lin_neg', ...
        'emb_lin_neg - integer value to select embedding function for negative densities', ...
        '0', '0', '0',                     '1', '1', '1', '0', '0', '0'; ...
    'param_bkgd_dyn', 'bkgd_dyn', ...
        'bkgd_dyn - integer value to select background density formula', ...
        '0', '0', '0',                     '1', '1', '1', '0', '0', '0'; ...
    };
% parameter file: 1=GUI handle, 2=structure field name, 
%   3=description
%   4=default, 5=min, 6=max, 7=enable1, 8=enable2, 9=enable3, 10=fitted1, 11=fitted2, 12=fitted3

handles.parameter_gui_field = parameter_strings(:,1);
handles.parameter_field_label = parameter_strings(:,2);
% make a template for datasets
for idx=1:length(handles.parameter_field_label)
    label = handles.parameter_field_label{idx};
    if isempty(label), continue, end
    
    % default value
    tval = char(parameter_strings(idx,4));
    tnum = str2double(tval);
    if isnan(tnum) % assume characters
        % try changing 'D' exponent to 'E'
        tnum = str2double(Utility_ExponentD2E(tval));
        if isnan(tnum) % really characters
            handles.parameter_default.(label) = tval;
        else
            handles.parameter_default.(label) = tnum;
        end
    else
        handles.parameter_default.(label) = tnum;
    end
    
    gui_tag = handles.parameter_gui_field{idx};
        
    % mininum value
    tval = char(parameter_strings(idx,5));
    tnum = str2double(tval);
    if isnan(tnum) % assume characters
        % try changing 'D' exponent to 'E'
        tnum = str2double(Utility_ExponentD2E(tval));
        if ~isnan(tnum) 
            handles.minval.(gui_tag) = tnum;
        end
    else
        handles.minval.(gui_tag) = tnum;
    end
    
    % maximum value
    tval = char(parameter_strings(idx,6));
    tnum = str2double(tval);
    if isnan(tnum) % assume characters
        % try changing 'D' exponent to 'E'
        tnum = str2double(Utility_ExponentD2E(tval));
        if isnan(tnum) 
            handles.maxval.(gui_tag) = tnum;
        end
    else
        handles.maxval.(gui_tag) = tnum;
    end
    
    % enable switch: (1)=no elements selected, (2)=1 element, (3)=2 elements, (4)=3 or more elements
    tval = { '0', char(parameter_strings(idx,7)), char(parameter_strings(idx,8)), char(parameter_strings(idx,9))  };
    handles.enable.(gui_tag) = str2double(tval);
    
    % fitted switch: (1)=no elements selected, (2)=1 element, (3)=2 elements, (4)=3 or more elements
    tval = { '0', char(parameter_strings(idx,10)), char(parameter_strings(idx,11)), char(parameter_strings(idx,12))  };
    handles.fitted.(gui_tag) = str2double(tval);

    % description
    handles.description.(gui_tag) = char(parameter_strings(idx,3));
    
end

% set field descriptions as tips
for i=1:length(handles.parameter_gui_field)
    gui_field_name = handles.parameter_gui_field{i};
    if isempty(gui_field_name), continue, end
    s = sprintf('%s\n', ...
            handles.description.(gui_field_name), ...
            'Right-click for other applicable actions, if any.');
    if isfield(handles, ['label_' gui_field_name])
        set(handles.(['label_' gui_field_name]), 'TooltipString', s)
    elseif isfield(handles, gui_field_name)
        set(handles.(gui_field_name), 'TooltipString', s)
    end
end

% lattices
handles.lattices = { ...
    'FCC'; 'BCC'; 'HCP';  'DC'; 'SC'; ...
    };

handles.BLattices = { ... % 'A1'; 'A2'; 'A3'; 'A4'; ...
    'B1'; 'B2'; 'B3'; 'B4'; 'Bf'; ...
    'C1'; 'C2'; 'C3'; 'C4'; 'C8'; 'C9'; 'C11b'; 'C16'; ... % 'C15'; 'C21'; 
    'D03'; 'D024'; 'D8b'; ...
    'L10'; 'L12'; ...
    };


% structure names
handles.structName = { ...
    ' Primary structure ', ...
    ' Secondary 1 structure ', ...
    ' Secondary 2 structure ', ...
    };

% single element calculations
handles.SingleElementCalculation = { ...
    ' Primary EV Curve Calculation ', ...
    ' Secondary 1 EV Curve Calculation ', ...
    ' Secondary 2 EV Curve Calculation', ...
    ' Elastic Constants Calculation ', ...
    ' Vacancy Energy Calculation ', ...
    ' Interstitital Energy Calculations ', ...
    ' Surface Energy Calculations ', ...
    ' Generalized Stacking Fault Energy Calculations ', ...
    };

% Binay calculations
handles.BinaryCalculation = { ...
    ' Binary EV Curve Calculation ', ...
    ' Binary Elastic Constants Calculation ', ...
    ' Substitution Energy Calculation ', ...
    ' Interstitial Substitution Energy Calculation ', ...
    };

% Ternary calculations
handles.TernaryCalculation = { ...
    ' Binding Energy Calculation ', ...
    };


% pointer to LAMMPS
handles.LAMMPS_open_args = {'-screen','none'};
try
    handles.LAMMPS_ptr = lammps_open(handles.LAMMPS_open_args{1}, handles.LAMMPS_open_args{2});
    % handles.LAMMPS_ptr = lammps_open('-log','none');
catch
    handles.LAMMPS_ptr = [];
end

% optimization method & options
handles.optimization_names = ...
    {'(not set)', 'fminsearch()', 'lsqnonlin()', 'fmincon()'};
handles.optimization_method = 2; % fminsearch
handles.optimization_options = optimset( ...
    'TolFun', 1.0e-3, 'TolX', 1.0e-3);
handles.isParallel = false;

try
    handles.pswarm_options = optimoptions ( @particleswarm, ...
        'HybridFcn', @fminsearch, ...
        'TolFun', 1.0e-3, ...
        'StallTimeLimit', Inf, ...
        'StallIterLimit', Inf, ...
        'MaxTime', Inf);
    handles.optimization_names{end+1} = 'particleswarm()';
catch
    handles.pswarm_options = [];
end

try
    handles.ga_options = gaoptimset( ...
        'PopulationSize', 20, ...
        'Generations', 100, ...
        'TolFun', 1.0e-3, ...
        'StallGenLimit', 10, ...
        'StallTimeLimit', Inf, ...
        'TimeLimit', Inf);
    handles.optimization_names{end+1} = 'ga()';
    handles.optimization_names{end+1} = 'gamultiobj()';
catch
    handles.ga_options = [];
end
handles.gamultiobj_options = handles.ga_options;


try
    handles.ps_options = psoptimset( ...
        'TolFun', 1.0e-3, 'TolX', 1.0e-3, 'TolMesh', 1.0e-4');
    handles.optimization_names{end+1} = 'patternsearch()';
catch
    handles.ps_options = [];
end

handles.calibration_target = {};
handles.calibration_parameter = {};

% fontsize for handles.text_Display
handles.text_Display_Fontsize = 8;

% Update handles structure
guidata(hObject, handles);


MPC_Initialize(handles)

% UIWAIT makes MPCv4 wait for user response (see UIRESUME)
% uiwait(handles.MPCv4);



% --- Outputs from this function are returned to the command line.
function varargout = MPCv4_OutputFcn(hObject, eventdata, handles)  %#ok<*INUSL>
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes when user attempts to close MPCv4.
function MPCv4_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to MPCv4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isempty(handles.LAMMPS_ptr)
    try
        lammps_close(handles.LAMMPS_ptr);
    catch
        display('Connection to LAMMPS not open.')
    end
end

hFig = figure(1);
delete(hFig)

% Hint: delete(hObject) closes the figure
delete(hObject);



% Do nothing
function MPC_DoNothing(hObject, eventdata, handles) %#ok<*INUSD>
% function does nothing




function MPC_Initialize(handles)

% LAMMPS scratch directory
run_dir = fullfile(pwd, 'scratch');
if ~exist(run_dir, 'dir'), mkdir(run_dir), end
set(handles.File_LAMMPS_WorkDirectory_Select, 'UserData', run_dir, ...
    'Label', ['LAMMPS scratch directory is : ' run_dir])

% the list set of elements, binaries, ternaries, etc
set([handles.label_Library, handles.label_Parameters], 'UserData', [])
Library_Entry_Redisplay(handles, [], 0)
Parameter_Entries_Redisplay(handles, [], [], 0)

set(handles.text_Display, 'String', '')


% try loading the default library.meam
filename = fullfile('examples', 'library.meam');
library = MEAM_Library_Load(handles, pwd, filename);
if ~isempty(library)
    meam_data = [];
    meam_data.library = library;
    meam_data.library_is_fixed = false;
    meam_data.library_entry_on_focus = 1;
    meam_data.MEAM_elements = [];
    meam_data.LAMMPS_atom_types = [];
    set(handles.File_Library_Load, 'UserData', meam_data, ...
        'Label', ['MEAM library file is "' filename '"'])
    MEAM_Library_Redisplay(handles, meam_data)
else
    set(handles.File_Library_Load, 'UserData', [])
end

% % parameters to fit not yet specified
% set(handles.Parameters_to_Fit, 'UserData', {})


% context menu for 'Calibration'
cmenu = uicontextmenu;
uimenu(cmenu, ...
    'Label', 'Clear calibration targets and parameters', ...
    'Callback', {@Optimization_Configure, 'clear'});
uimenu(cmenu, ...
    'Label', 'Use fminsearch', 'Separator', 'On', ...
    'Callback', {@Optimization_Configure, 'fminsearch'});
if ~isempty(handles.pswarm_options)
        uimenu(cmenu, ...
        'Label', 'Use particleswarm', 'Separator', 'On', ...
        'Callback', {@Optimization_Configure, 'particleswarm'});
end
% uimenu(cmenu, ...
%     'Label', 'Use lsqnonlin', 'Separator', 'On', 'Enable', 'On', ...
%     'Callback', {@Optimization_Configure, 'lsqnonlin'});
% uimenu(cmenu, ...
%     'Label', 'Use fmincon', 'Separator', 'On', 'Enable', 'On', ...
%     'Callback', {@Optimization_Configure, 'fmincon'});
if ~isempty(handles.ps_options)
    uimenu(cmenu, ...
        'Label', 'Use patternsearch', 'Separator', 'On', 'Enable', 'on', ...
        'Callback', {@Optimization_Configure, 'patternsearch'});
end
% if ~isempty(handles.ga_options)
%     uimenu(cmenu, ...
%         'Label', 'Use ga', 'Separator', 'On', 'Enable', 'On', ...
%         'Callback', {@Optimization_Configure, 'ga'});
% end
% if ~isempty(handles.gamultiobj_options)
%     uimenu(cmenu, ...
%         'Label', 'Use gamultiobj()', 'Enable', 'on', 'Separator', 'On',...
%         'Callback', {@Optimization_Configure, 'gamultiobj'});
% end

set(handles.label_Parameters_to_fit, 'Visible', 'On', 'UserData', {}, ...
    'UIContextMenu', cmenu) %, ... 
    %'ToolTipString', sprintf('%s\n', ...
    %'Right-click here for help on fitting and to select an optimization method' ) )
set(handles.Calibration_Run, 'Visible', 'On', 'Enable', 'Off')

% Parameter history
set(handles.Calibration_History, 'UserData', {}, ...
    'String', 'none', 'Value', 1, 'Visible', 'On', 'Enable', 'Off')

set(handles.Plot_Position, 'Enable', 'On', 'Userdata', cell(1,1), ...
            'String', {'subplot(1,1,1)'}, 'Value', 1 )

Plot_Control_Enable('Off')

axes('Parent', handles.panel_Plots)
subplot(1,1,1)
plot(0,0)
axis off

% print GUI context menu on panel_plots
cmenu = uicontextmenu;
uimenu(cmenu, 'Label', 'Send to printer', 'Separator', 'Off', ...
    'Callback', {@MPC_Help, 'Send to printer'});
uimenu(cmenu, 'Label', 'Help topics', 'Separator', 'On', ...
    'Callback', {@MPC_Help, 'Help topics'});
uimenu(cmenu, 'Label', [handles.program_tag ' License'], ...
    'Callback', {@MPC_Help, [handles.program_tag ' License']});
uimenu(cmenu, 'Label', ['About ' handles.program_tag], ...
    'Callback', {@MPC_Help, ['About ' handles.program_tag]});
set(handles.panel_Plots, 'UIContextMenu', cmenu)


% context menu on text_display
cmenu = uicontextmenu;
uimenu(cmenu, 'Label', 'Bigger font', ...
    'Callback', {@Text_Display_Menu, 'Bigger'});
uimenu(cmenu, 'Label', 'Smaller font', ...
    'Callback', {@Text_Display_Menu, 'Smaller'});
uimenu(cmenu, 'Label', 'Write to file', 'Separator', 'On', ...
    'Callback', {@Text_Display_Menu, 'Write'});
set(handles.text_Display, 'UIContextMenu', cmenu)


% context menu on text_Includes
cmenu = uicontextmenu;
uimenu(cmenu, 'Label', 'Clear ALL lists', ...
    'Callback', {@Text_Includes_Menu, 'ALL'});
uimenu(cmenu, 'Label', 'Clear RUN lists', ...
    'Callback', {@Text_Includes_Menu, 'RUN'});
uimenu(cmenu, 'Label', 'Clear DISPLAY list', ...
    'Callback', {@Text_Includes_Menu, 'DISPLAY'});
set(handles.text_Includes, 'UIContextMenu', cmenu)

MPC_Toggle_Menus(handles)



function MPC_Help(hObject, eventdata, topic)
% miscellaneous 

handles = guidata(hObject);

switch topic

    case 'Send to printer'
        printpreview

    case 'Help topics'
        fname = [handles.program_tag '-Help.htm']; 
        if exist (fname, 'file') % help exists?
            try
                web(['file:///' pwd '/' fname]) % , '-browser')
            catch
                msgbox(['Please see the file ' fname], ...
                    topic, 'Help', 'modal')
            end
            
        else
            display(['Not found: ' fname])
            msgbox(sprintf('%s\n', ...
                'Hover mouse pointer over a GUI item to display a tip regarding that item.', ...
                ' ', ...
                'Go to https://icme.hpc.msstate.edu/mediawiki/index.php/MPC for a user guide', ...
                ' ', ...
                'Go to http://lammps.sandia.gov/doc/pair_meam.html for help on the "pair_style meam" command in LAMMPS'), ...
                topic, 'Help', 'modal')
        end
        
    case [handles.program_tag ' License']
        fname = 'MSU-CAVS-Software-License.txt';
        if exist (fname, 'file') % license file exists?
            try
                web(['file:///' pwd '/' fname]) % , '-browser')
            catch
                msgbox(['Please see the file ' fname], ...
                    topic, 'Help', 'modal')
            end
            
        else
            display(['Not found: ' fname])
            msgbox({ ...
                [handles.program_name ' is a MSU-CAVS pre-publication research code. ' ...
                'Use of the code (including possession, copying, execution, revision) ' ...
                'by non-MSU-CAVS persons may be a copyright violation. ' ...
                'Contact Mark F. Horstemeyer (mfhorst@cavs.msstate.edu) to obtain permission.']; ...
                }, topic, 'warn', 'modal')
        end
        
    case ['About ' handles.program_tag]
        msgbox(sprintf('%s\n', ...
                handles.program_name, ...
                ' ', ...
                ['Send suggestions & bug reports to ' handles.contact]), ...
            topic, 'help', 'modal')

    otherwise
        
end



% --------------------------------------------------------------------
function File_Plot_Data_Callback(hObject, eventdata, handles)
% hObject    handle to File_Plot_Data (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

stat = get(hObject, 'Checked');
if strcmpi(stat, 'On')
    set(hObject, 'Checked', 'Off')
else
    set(hObject, 'Checked', 'On')
end



% --------------------------------------------------------------------
function File_Calibration_Data_Template_Callback(hObject, eventdata, handles)
% hObject    handle to File_Calibration_Data_Template (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

stat = get(hObject, 'Checked');
if strcmpi(stat, 'On')
    set(hObject, 'Checked', 'Off')
else
    set(hObject, 'Checked', 'On')
end



function tLine = Utility_ExponentD2E(tLine)
% convert D exponents to E (numbers in tLine may be from Fortran)

tLine = strrep(tLine, 'D', 'E');
tLine = strrep(tLine, 'd', 'E');




% --------------------------------------------------------------------
function File_LAMMPS_WorkDirectory_Select_Callback(hObject, eventdata, handles)
% hObject    handle to File_LAMMPS_WorkDirectory_Select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

dlgTitle = 'LAMMPS scratch directory';
if ispc
    run_dir = uigetdir('wrk', ['Select ' dlgTitle]);
else
    run_dir = uigetdir(pwd, ['Select ' dlgTitle]);
end
if ~run_dir, return, end

% attempt to create a run directory
t_dir = fullfile(run_dir, datestr(now,30));
[status, mesg] = mkdir(t_dir);
if ~status
    msgbox(['Cannot write to ' run_dir ' ?'], dlgTitle, 'Error', 'modal')
    return
elseif isempty(mesg)
    rmdir(t_dir);
end
set(hObject, 'UserData', run_dir, ...
    'Label', [dlgTitle ' is : ' run_dir])

MPC_Toggle_Menus(handles)

msgbox([dlgTitle ' is ' run_dir], dlgTitle, 'none', 'modal')



% --------------------------------------------------------------------
function File_Library_Load_Callback(hObject, eventdata, handles)
% hObject    handle to File_Library_Load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

dlgTitle = 'MEAM library file';

[filename, pathname] = uigetfile('*library.meam', ['Select ' dlgTitle]);
if ~filename
   disp([dlgTitle ' - User selected Cancel'])
   return
end
% disp(['User selected ', fullfile(pathname, filename)])

meam_data = [];
meam_data.library = MEAM_Library_Load(handles, pathname, filename);
meam_data.library_is_fixed = false;

focus = 1; % automatically display 1st entry
meam_data.library_entry_on_focus = focus;
meam_data.MEAM_elements = [];
meam_data.LAMMPS_atom_types = [];

% remember
set(hObject, 'UserData', meam_data, ...
    'Label', [dlgTitle ' is "' filename '"'])

% reset MEAM objects
set([handles.label_Library, handles.label_Parameters], 'UserData', [])
Library_Entry_Redisplay(handles, [], 0)
Parameter_Entries_Redisplay(handles, [], [], 0)

set([handles.text_Display,handles.text_Includes], 'String', '')

% Calibration label
set(handles.label_Parameters_to_fit, 'Visible', 'On', 'UserData', {})

% set(handles.Parameters_to_Fit, 'String', '')

set(handles.Calibration_Run, 'Visible', 'On', 'Enable', 'Off')

% Parameter history
set(handles.Calibration_History, 'UserData', {}, ...
    'String', 'none', 'Value', 1, 'Visible', 'On', 'Enable', 'Off')

handles.calibration_target = [];
handles.calibration_parameter = [];
guidata(hObject, handles)

% clear plots
axes('Parent', handles.panel_Plots)
subplot(1,1,1)
plot(0,0)
axis off

MEAM_Library_Redisplay(handles, meam_data)
MPC_Toggle_Menus(handles)



% --------------------------------------------------------------------
function File_Library_Parameter_Write_Callback(hObject, eventdata, handles)
% hObject    handle to File_Library_Parameter_Write (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

MEAM_Object = get(handles.label_Library, 'UserData');
numElements = max(MEAM_Object{end,1});
% type = MEAM_Object{idxObject,1};
% ntype=size(type,2);
% tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5}; % BLattices
% runData = MEAM_Object{idxObject,6};

element_list = Elements_List(MEAM_Object);
baseFileName = strrep(element_list, ' ', '');
libFile = [baseFileName '.library.meam'];
paramFile = [baseFileName '.parameter.meam'];

% directory
save_dir = baseFileName;
[~, ~, ~] = mkdir(save_dir);
display(['Write dir is ' save_dir])

% write the library file 
library = cell(1,numElements);
for idx=1:numElements
    library{idx} = MEAM_Object{idx,4};
end
meam_lib = fullfile(save_dir, libFile);
mesg = File_Library_Write(handles, meam_lib, ...
    library, [1:numElements], ...
    ['Generated by MPC on ' datestr(now,30)]);
if ~isempty(mesg)
    display(mesg)
    return
end
display(['Library file is ' meam_lib])

% copy the parameter file 
parameters = get(handles.label_Parameters, 'UserData');
meam_param = fullfile(save_dir, paramFile);
mesg = File_Parameters_Write( meam_param, parameters );
% mesg = Parameter_File_Write_From_Display(handles, meam_param, '');
if ~isempty(mesg)
    display(mesg)
    return
end
display(['Parameter file is ' meam_param])

msgbox(['MEAM library file is ' meam_lib ' and MEAM parameter file is ' meam_param], ...
    'Write MEAM library and parameter files', 'none', 'modal')






% --------------------------------------------------------------------
function File_Parameters_Load_Callback(hObject, eventdata, handles)
% hObject    handle to File_Parameters_Load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% display('Parameter_File_Callback()')
dlgTitle = 'MEAM parameter file';
[filename, pathname] = uigetfile('*.meam', ['Select ' dlgTitle], 'MultiSelect', 'Off');
if ~filename
   disp([dlgTitle ' - User selected Cancel'])
   return
end

% read file
[parameterEntry, mesg] = File_Parameters_Read_Raw(fullfile(pathname, filename));

if ~isempty(parameterEntry)

    set(hObject, 'Label', [dlgTitle ' is : ' filename])
    
    set(handles.label_Parameters, 'UserData', parameterEntry)

    Calculations_Reset(handles)

    Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)

    % initialize history ?
    history = get(handles.Calibration_History, 'UserData');
    meam_data = get(handles.File_Library_Load, 'UserData');

    if isempty(history)
        history{1} = {meam_data.library, parameterEntry, ...
            '(Initial values)'};
        history_display{1} = history{1}{3};
        set(handles.Calibration_History, 'UserData', history, ...
            'String', history_display, 'Value', 1)
    end

else
    msgbox(mesg, dlgTitle, 'error', 'modal')
end




% --------------------------------------------------------------------
function File_Use_tempname_Callback(hObject, eventdata, handles)
% hObject    handle to File_Use_tempname (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


stat = get(hObject, 'Checked');
if strcmpi(stat, 'On')
    set(hObject, 'Checked', 'Off')
else
    set(hObject, 'Checked', 'On')
end


% --- Executes on selection change in Library_Entry_Select.
function Library_Entry_Select_Callback(hObject, eventdata, handles)
% hObject    handle to Library_Entry_Select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns Library_Entry_Select contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Library_Entry_Select

% display('Library_Entry_Select_Callback()')
idxObject = get(hObject, 'Value');

if isempty(get(handles.label_Library, 'UserData')) % use meam_data
    meam_data = get(handles.File_Library_Load, 'UserData');
    if isempty(meam_data), return, end
    meam_data.library_entry_on_focus = idxObject;
    set(handles.File_Library_Load, 'UserData', meam_data)
    MEAM_Library_Redisplay(handles, meam_data)
    
else
    % synchronize parameter file display
    set(handles.Parameter_Entries_Select, 'Value', idxObject)
    Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)
end




function MEAM_Library_Edit(hObject, eventdata, handles)
% hObject    handle to library entry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of library entry as text
%        str2double(get(hObject,'String')) returns contents of library entry as a double

% display('MEAM_Library_Edit()')
if isempty(get(handles.label_Library, 'UserData'))
    MEAM_Library_Redisplay(handles, get(handles.File_Library_Load, 'UserData'))
    return
end

displayStr = get(hObject,'String');
% whos('displayStr')
[~, remain] = strtok(get(hObject,'Tag'), '_');
keyword = remain(2:end);
value = str2double(displayStr);

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');
idxObject = get(handles.Library_Entry_Select, 'Value');

% numElements = size(MEAM_Object{end,1},2);
% elementIdx = MEAM_Object{idxObject,1};
% objType = size(elementIdx,2);
tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
% runData = MEAM_Object{idxObject,6};

%dlgTitle = ['Edit library entry ' tag];
display(sprintf('%s.%s = %s', tag, keyword, displayStr) )

switch keyword

    case {'elt'}
        libEntry.(keyword) = displayStr;
        
    case {'lat'}
        if ~any(strcmpi(displayStr, handles.lattices))
            display(['Invalid lattice code "' displayStr '"'])
        else
            libEntry.(keyword) = upper(displayStr);
        end
        
    otherwise
        if isnan(value)
            display(['"' displayStr '" is not a valid number.'] )
        else
            libEntry.(keyword) = value;
        end
end

MEAM_Object{idxObject,4} = libEntry;
% clear results
for i=1:size(MEAM_Object,1)
    MEAM_Object{i,6} = []; 
end

set(handles.label_Library, 'UserData', MEAM_Object)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)




% --- Executes on selection change in Parameter_Entries_Select.
function Parameter_Entries_Select_Callback(hObject, eventdata, handles)
% hObject    handle to Parameter_Entries_Select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns Parameter_Entries_Select contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Parameter_Entries_Select

% display('Parameter_Entries_Select_Callback()')
% contents = cellstr(get(hObject,'String'));
% tag = contents{get(hObject,'Value')};
MEAM_Object = get(handles.label_Library, 'UserData');
idxObject = get(hObject,'Value'); % find(strncmp({MEAM_Object{1:end,2}}, tag, length(tag)));

if ~isempty(MEAM_Object)
    parameterEntry = get(handles.label_Parameters, 'UserData');
    Parameter_Entries_Redisplay(handles, parameterEntry, MEAM_Object, idxObject)
    
    % synchronize
    set(handles.Library_Entry_Select, 'Value', idxObject)
    Library_Entry_Redisplay(handles, MEAM_Object, idxObject)
    
    Text_Display_Object(handles, MEAM_Object, idxObject)
    MPC_Toggle_Menus(handles)

else
    Library_Entry_Select_Callback(handles.Library_Entry_Select, eventdata, handles)    
end




% --- Executes on selection change in select_indexed_parameter.
function Parameter_Indexed_Select(hObject, eventdata, handles)
% hObject    handle to select_indexed_parameter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns select_indexed_parameter contents as cell array
%        contents{get(hObject,'Value')} returns selected item from select_indexed_parameter

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)




function Parameter_Scalar_Edit(hObject, eventdata, handles)
% hObject    handle to parameter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of parameter as text
%        str2double(get(hObject,'String')) returns contents of parameter as a double

displayStr = get(hObject,'String');
% whos('displayStr')
[~, remain] = strtok(get(hObject,'Tag'), '_');
keyword = remain(2:end);
value = str2double(displayStr);
display(sprintf('Parameter_Scalar_Edit(%s = %g)', keyword, value) )

loc = 0;
parameterEntry = get(handles.label_Parameters, 'UserData');
for i=1:length(parameterEntry)
    % find matching keyword
    tKeyword = parameterEntry{i}{1};
    tKeyword = strtrim(tKeyword);
    if strcmp(keyword, tKeyword)
        loc = i;
        break
    end
end

if isnan(value) % not a number
    if loc~=0 % present in parameter file
        if iscell(displayStr) % erase from parameter file
            parameterEntry(loc) = [];
        end
    end
else % a number
    if loc==0 % not set previously; add
        parameterEntry{end+1} = {keyword, {[]}, value};
    else % update previous value
        parameterEntry{loc}{3} = value;
    end
end

set(handles.label_Parameters, 'UserData', parameterEntry)

Calculations_Reset(handles)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)


function Calculations_Reset(handles)
% clear all LAMMPS calculation results

MEAM_Object = get(handles.label_Library, 'UserData');
for i=1:size(MEAM_Object,1)
    MEAM_Object{i,6} = []; % clear results
end
set(handles.label_Library, 'UserData', MEAM_Object)
    
Text_Display_Object(handles, MEAM_Object, ...
    get(handles.Library_Entry_Select, 'Value') )



function Calibration_Data_Curve(hObject, eventdata, idxObject, varName, row, col, hyt, latticeName)
% accept input of a calibration data curve from file, to be stored in
% row=0  : MEAM_Object{idxObject,7}.varname, MEAM_Object{idxObject,7}.file+varname
% row~=0 : MEAM_Object{idxObject,7}.varname{row}, MEAM_Object{idxObject,7}.file+varname{row}

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');

% numElements = max(MEAM_Object{end,1});
% elementIdx = MEAM_Object{idxObject,1};
% objType = size(elementIdx,2);
tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
runData = MEAM_Object{idxObject,6};
calibrationData = MEAM_Object{idxObject,7};

dlgTitle = 'User input';
oldValue = '';
if isempty(latticeName)
    if row==0 % E1, E2, E3
        if ~isempty(calibrationData.(varName))
            oldValue = calibrationData.(varName).file;
        end
        prompt = ['Calibration data curve for ' tag  '.' varName];
    else % GSFes
        if isfield(calibrationData, varName) && ~isempty(calibrationData.(varName))  && ~isempty(calibrationData.(varName){row})
            oldValue = calibrationData.(varName){row}.file;
        end
        prompt = ['Calibration data curve for ' tag  '.' varName '( ' runData.SingleElement.planes{row} ' )'];
    end
else % Binary EV1
    if ~isempty(calibrationData.(varName).(latticeName){row,col,hyt}.file)
        oldValue = calibrationData.(varName).(latticeName){row,col,hyt}.file;
    end
    prompt = ['Calibration data for ' tag  ' : ' strrep(latticeName, '_','-') '.' varName];
end
if isempty(oldValue), oldValue = '*'; end

% display(prompt)


if strcmpi(get(hObject, 'Checked'), 'On') % clear
    
    choice = questdlg(['RESET ' prompt '?'], ...
        'Reset target', 'Yes','No','Cancel','No');
    if ~strcmpi(choice, 'Yes'), return, end
    
    pos = Calibration_Target_Find(handles, ...
        {idxObject, varName, row, col, hyt, 'Curve', '', latticeName, 0, 0});
    if pos
        handles.calibration_target(pos) = [];
    end
    guidata(hObject, handles)

    
    if isempty(latticeName)
        if row==0
            calibrationData.(varName) = [];
        else
            calibrationData.(varName){row} = [];
        end
    else
        calibrationData.(varName).(latticeName){row,col,hyt}.xdata = '';
        calibrationData.(varName).(latticeName){row,col,hyt}.ydata = '';
        calibrationData.(varName).(latticeName){row,col,hyt}.left = 0;
        calibrationData.(varName).(latticeName){row,col,hyt}.right = 0;
        calibrationData.(varName).(latticeName){row,col,hyt}.file = '';
        calibrationData.(varName).(latticeName){row,col,hyt}.dir = '';

    end
    MEAM_Object{idxObject,7} = calibrationData;
    set(handles.label_Library, 'UserData', MEAM_Object)
    set(hObject, 'Checked', 'Off')

    Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)
    return    
end


% prompt for file
[t_fname, t_path] = uigetfile({oldValue}, prompt);
if ~t_fname
    disp([dlgTitle ' - User selected Cancel'])
    return

else
    filename = fullfile(t_path, t_fname);
    [fid,message] = fopen(filename, 'r');
    if fid == -1
        msgbox(['Cannot read ' filename ...
            ' due to error "' message '"'], dlgTitle, 'error', 'modal')
        return
    end
    
    % assume 2-column format
    tvals = textscan(fid, '%n %n');
    fclose(fid);
    
    curve.xdata = tvals{1};
    curve.ydata = tvals{2};
    curve.left = 1;
    curve.right = length(tvals{1});
    curve.file = t_fname;
    curve.dir = t_path;
        
    if isempty(latticeName)
        if row==0
            calibrationData.(varName) = curve;
        else
            calibrationData.(varName){row} = curve;
        end
    else
        calibrationData.(varName).(latticeName){row,col,hyt} = curve;
    end
    
    MEAM_Object{idxObject,7} = calibrationData;
    set(handles.label_Library, 'UserData', MEAM_Object)
    set(hObject, 'Checked', 'On')

    Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)
    
end




function Calibration_Data_Elastic_Tensor(hObject, eventdata, idxObject, row, col)
% accept input of C_row_col calibration data from file containing 6x6 matrix

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');

% numElements = max(MEAM_Object{end,1});
% elementIdx = MEAM_Object{idxObject,1};
% objType = size(elementIdx,2);
tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
% runData = MEAM_Object{idxObject,6};
calibrationData = MEAM_Object{idxObject,7};

dlgTitle = 'User input';

% prompt for file
[t_fname, t_path] = uigetfile('*.*', ...
    ['Select elastic tensor file for ' tag ' (must contain 6x6 numbers)']);
if ~t_fname
    disp([dlgTitle ' - User selected Cancel'])
    return

else
    filename = fullfile(t_path, t_fname);
    elastic_tensor = load(filename, '-ascii');
    for i=1:length(row)
        calibrationData.C{row(i),col(i)} = elastic_tensor(row(i),col(i));
    end
    MEAM_Object{idxObject,7} = calibrationData;
    set(handles.label_Library, 'UserData', MEAM_Object)
    set(hObject, 'Checked', 'On')
    Text_Display_Object(handles, MEAM_Object, idxObject)
    
end


function Calibration_Data_From_File(hObject, eventdata, idxObject)

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');

% numElements = max(MEAM_Object{end,1});
elementIdx = MEAM_Object{idxObject,1};
objType = size(elementIdx,2);
tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
runData = MEAM_Object{idxObject,6};
calibrationData = MEAM_Object{idxObject,7};

dlgTitle = 'User input';

% prompt for file
[t_fname, t_path] = uigetfile('*.*', ...
    ['Select file for ' tag ' calibration data']);
if ~t_fname
    disp([dlgTitle ' - User selected Cancel'])
    return

else
    [fid, message] = fopen(fullfile(t_path, t_fname), 'rt');
    if fid==-1
        display(message)
        return
    end
    while ~feof(fid)
        tline = fgetl(fid);
        if isempty(tline) || strncmp(tline, '#', 1) % empty/comment line
            continue
        end
        tokenList = regexp(tline, ', ', 'split');
        
        switch tokenList{1}
            case 'E0'
                switch objType
                    case 1
                        tVals = str2double(tokenList);
                        calibrationData.(tokenList{1}) = tVals(5);
                    case 2
                        tVals = str2double(tokenList);
                        BLattices = runData.Alloy.BLattices{tVals(2), tVals(3), tVals(4)};
                        if ~isempty(BLattices)
                            latticeName = strrep(BLattices, '-', '_');
                            calibrationData.(tokenList{1}).(latticeName){tVals(2), tVals(3), tVals(4)} = tVals(5);
                        end
                    case 3
                end

            case {'E1', 'E2', 'E3'}
                tVals = str2double(tokenList);
                curve.dir = t_path;
                curve.file = t_fname;
                curve.xdata = zeros(1,tVals(5));
                curve.ydata = zeros(1,tVals(5));
                curve.left = 1;
                curve.right = tVals(5);
                for i=1:tVals(5)
                    tline = fgetl(fid);
                    strVal = regexp(tline, ', ', 'split');
                    curve.xdata(i) = str2double(strVal{1});
                    curve.ydata(i) = str2double(strVal{2});
                end
                switch objType
                    case 1
                        calibrationData.(tokenList{1}) = curve;
                    case 2
                        if strcmp(tokenList{1}, 'E1')
                            BLattices = runData.Alloy.BLattices{tVals(2), tVals(3), tVals(4)};
                            if ~isempty(BLattices)
                                calibrationData.(tokenList{1}).(latticeName){tVals(2), tVals(3), tVals(4)} = curve;
                            end                                
                        end
                    case 3
                end
                
            case 'C'
                switch objType
                    case 1
                        tVals = str2double(tokenList);
                        calibrationData.(tokenList{1}){tVals(5), tVals(6)} = tVals(7);
                    case 2
                        tVals = str2double(tokenList);
                        BLattices = runData.Alloy.BLattices{tVals(2), tVals(3), tVals(4)};
                        if ~isempty(BLattices)
                            latticeName = strrep(BLattices, '-', '_');
                            calibrationData.(tokenList{1}).(latticeName){tVals(2), tVals(3), tVals(4)}{tVals(5), tVals(6)} = tVals(7);
                        end
                    case 3
                end
                
            case 'Evac'
                switch objType
                    case 1
                        tVals = str2double(tokenList);
                        calibrationData.(tokenList{1}) = tVals(2);
                    case 2
                    case 3
                end
                
            case {'Einterstitials', 'ESurfaces'}
                switch objType
                    case 1
                        tVals = str2double(tokenList);
                        calibrationData.(tokenList{1}){tVals(2)} = tVals(3);
                    case 2
                    case 3
                end
                
            case 'GSFEs'
                switch objType
                    case 1
                        tVals = str2double(tokenList);
                        curve.dir = t_path;
                        curve.file = t_fname;
                        curve.xdata = zeros(1,tVals(3));
                        curve.ydata = zeros(1,tVals(3));
                        curve.left = 1;
                        curve.right = tVals(3);
                        for i=1:tVals(3)
                            tline = fgetl(fid);
                            strVal = regexp(tline, ', ', 'split');
                            curve.xdata(i) = str2double(strVal{1});
                            curve.ydata(i) = str2double(strVal{2});
                        end
                        calibrationData.(tokenList{1}){tVals(2)} = curve;
                    case 2
                    case 3
                end
                
            case {'H', 'Nx'}
                switch objType
                    case 1
                    case 2
                        tVals = str2double(tokenList);
                        BLattices = runData.Alloy.BLattices{tVals(2), tVals(3), tVals(4)};
                        if ~isempty(BLattices)
                            latticeName = strrep(BLattices, '-', '_');
                            calibrationData.(tokenList{1}).(latticeName){tVals(2), tVals(3), tVals(4)} = tVals(5);
                        end
                    case 3
                end
                               
            case {'Substitution', 'ISubstitution'}
                switch objType
                    case 1
                    case 2
                        tVals = str2double(tokenList);
                        calibrationData.(tokenList{1}){tVals(2), tVals(3)} = tVals(4);
                    case 3
                end

            case 'BindingEnergy'
                switch objType
                    case 1
                    case 2
                    case 3
                        tVals = str2double(tokenList);
                        calibrationData.(tokenList{1}){tVals(2), tVals(3), tVals(4)} = tVals(5);
                end
                
        end
        
    end
    fclose(fid);
    MEAM_Object{idxObject,7} = calibrationData;
    set(handles.label_Library, 'UserData', MEAM_Object)
    Text_Display_Object(handles, MEAM_Object, idxObject)
    
end


function Calibration_Data_Single_Value(hObject, eventdata, idxObject, varName, row, col, hyt, ...
    latticeName, Ci, Cj)
% accept input of a scalar calibration target, to be stored in
% latticeName~='', Ci~=0, Cj~=0, row~=0, col=~0, hyt~=0: MEAM_Object{idxObject,7}.varname.latticeName{row,col,hyt}{Ci,Cj}
% latticeName~='', Ci==0, Cj==0, row~=0, col=~0: MEAM_Object{idxObject,7}.varname.latticeName{row,col}
% latticeName=='', row=0, col=0   : MEAM_Object{idxObject,7}.varname
% latticeName=='', row~=0, col=0  : MEAM_Object{idxObject,7}.varname{row}
% latticeName=='', row~=0, col=~0 : MEAM_Object{idxObject,7}.varname{row,col}
% latticeName=='', row~=0, col=~0, hyt~=0 : MEAM_Object{idxObject,7}.varname{row,col,hyt}

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');

% numElements = max(MEAM_Object{end,1});
elementIdx = MEAM_Object{idxObject,1};
objType = size(elementIdx,2);
tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
runData = MEAM_Object{idxObject,6};
calibrationData = MEAM_Object{idxObject,7};

% fieldnames(calibrationData)

dlgTitle = 'User input';
oldValue = [];

switch objType
    
    case 1
        if Ci~=0 && Cj~=0  % Elastics Cij
            prompt = ['Calibration data for ' tag  '.' varName num2str(Ci) num2str(Cj)];
            if isfield(calibrationData, varName)
                oldValue = calibrationData.(varName){Ci,Cj};
            end
        elseif row+col==0
            prompt = ['Calibration data for ' tag  '.' varName];
            if isfield(calibrationData, varName)
                oldValue = calibrationData.(varName);
            end
        elseif col==0 % Interstitial, Surface
            switch varName
                case 'Einterstitials'
                    prompt = ['Calibration data for ' tag  '.' varName '( ' runData.SingleElement.interstials{row} ' )'];
                case 'ESurfaces'
                    prompt = ['Calibration data for ' tag  '.' varName '( ' runData.SingleElement.Surfaces{row} ' )'];
            end
            if isfield(calibrationData, varName)
                oldValue = calibrationData.(varName){row};
            end
        end
        
    case 2
        if ~isempty(latticeName)
            if Ci~=0 && Cj~=0
                prompt = ['Calibration data for ' tag  ' : ' strrep(latticeName, '_','-') '.' ...
                    varName num2str(Ci) num2str(Cj)];
                oldValue = calibrationData.(varName).(latticeName){row,col,hyt}{Ci,Cj};
            else
                prompt = ['Calibration data for ' tag  ' : ' strrep(latticeName, '_','-') '.' varName];
                oldValue = calibrationData.(varName).(latticeName){row,col,hyt};
            end
        else
            switch varName
                case 'Substitution'
                    prompt = ['Calibration data for ' tag  '.' varName '( ' runData.Alloy.SubsLabel{row,col} ' )'];
                case 'ISubstitution'
                    prompt = ['Calibration data for ' tag  '.' varName '( ' runData.Alloy.ISubsLabel{row,col} ' )'];
            end
            oldValue = calibrationData.(varName){row,col};
        end
    
    case 3 % Binding energy
        prompt = ['Calibration data for ' tag '( ' runData.Alloy.BindingLabel{row,col,hyt} ' )'];
            if isfield(calibrationData, varName)
                oldValue = calibrationData.(varName){row,col,hyt};
            end
end


display(prompt)

if strcmpi(get(hObject, 'Checked'), 'On') % clear
    
    choice = questdlg(['RESET ' prompt '?'], ...
        'Reset target', 'Yes','No','Cancel','No');
    if ~strcmpi(choice, 'Yes'), return, end

    pos = Calibration_Target_Find(handles, ...
        {idxObject, varName, row, col, hyt, 'Scalar', '', latticeName, Ci, Cj});
    if pos
        handles.calibration_target(pos) = [];
    end
    guidata(hObject, handles)


    switch objType
        
        case 1
            if Ci~=0 && Cj~=0  % Elastics Cij
                calibrationData.(varName){Ci,Cj} = [];
            elseif row+col==0
                calibrationData.(varName) = [];
            elseif col==0
                calibrationData.(varName){row} = [];
            end
            
        case 2
            if ~isempty(latticeName)
                if Ci~=0 && Cj~=0  % Elastics Cij
                    calibrationData.(varName).(latticeName){row,col,hyt}{Ci,Cj} = [];
                else
                    calibrationData.(varName).(latticeName){row,col,hyt} = [];
                end
            else
                calibrationData.(varName){row,col} = [];
            end
            
        
        case 3 % Binding energy
            calibrationData.(varName){row,col,hyt} = [];
            
    end
    
    MEAM_Object{idxObject,7} = calibrationData;
    set(handles.label_Library, 'UserData', MEAM_Object)
    set(hObject, 'Checked', 'Off')
    
    Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)
    return
end

% prompt for a scalar
options.Resize = 'on';
options.WindowStyle = 'normal';
options.Interpreter = 'none';
numlines = 1;
if ~isempty(oldValue)
    defaultanswer = {num2str(oldValue)};
else
    defaultanswer = {''};
end
answer = inputdlg(prompt, dlgTitle, numlines, defaultanswer, options);

if isempty(answer)
    disp([dlgTitle ' - User selected Cancel'])

else
    vals = str2double(answer);
    if any(isnan(vals))
        msgbox([prompt ' : invalid input'], dlgTitle, 'error', 'modal')
    
    else
        switch objType

            case 1
                if Ci~=0 && Cj~=0  % Elastics Cij
                    calibrationData.(varName){Ci,Cj} = vals(1);
                elseif row+col==0
                    calibrationData.(varName) = vals(1);
                elseif col==0
                    calibrationData.(varName){row} = vals(1);
                end

            case 2
                if ~isempty(latticeName)
                    if Ci~=0 && Cj~=0  % Elastics Cij
                        calibrationData.(varName).(latticeName){row,col,hyt}{Ci,Cj} = vals(1);
                    else
                        calibrationData.(varName).(latticeName){row,col,hyt} = vals(1);
                    end
                else
                    calibrationData.(varName){row,col} = vals(1);
                end


            case 3 % Binding energy
                calibrationData.(varName){row,col,hyt} = vals(1);

        end
        
        MEAM_Object{idxObject,7} = calibrationData;
        set(handles.label_Library, 'UserData', MEAM_Object)
        set(hObject, 'Checked', 'On')

        Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)
    end
    
end



% --- Executes on selection change in Calibration_History.
function Calibration_History_Callback(hObject, eventdata, handles)
% hObject    handle to Calibration_History (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns Calibration_History contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Calibration_History


history = get(hObject, 'UserData');
if isempty(history)
    set(hObject, 'String', {'none'}, 'Value', 1, ...
        'UIContextMenu', [], 'Enable', 'Off')

else
    history_len = length(history);
    pos = get(hObject, 'Value');

    MEAM_Object = get(handles.label_Library, 'UserData');
    numElements = max(MEAM_Object{end,1});
    % copy library entries
    for i=1:numElements
        MEAM_Object{i,4} = history{pos}{1}{i}; 
    end
    % clear results
    for i=1:size(MEAM_Object,1)
        MEAM_Object{i,6} = []; 
    end

    % update 
    set(handles.label_Library, 'UserData', MEAM_Object)
    set(handles.label_Parameters, 'UserData', history{pos}{2})
    set(handles.Run_calculations_Selected, 'Userdata', get(handles.Library_Entry_Select, 'Value'))

    % run for object on focus
    Run_calculations_Callback(handles.Run_calculations_Selected, eventdata, handles)
    
    cmenu = uicontextmenu;
    uimenu(cmenu, ...
        'Label', 'Delete this result', ...
        'Callback', {@Calibration_History_Delete, 'ONLY'});
    if pos<history_len
        uimenu(cmenu, ...
            'Label', 'Delete THIS and LATER results', 'Separator', 'On', ...
            'Callback', {@Calibration_History_Delete, 'FROMHERE'});
    end
    if history_len>1
        uimenu(cmenu, ...
            'Label', 'Delete ALL results', 'Separator', 'On', ...
            'Callback', {@Calibration_History_Delete, 'ALL'});
    end
    set(handles.Calibration_History, 'UIContextMenu', cmenu, 'Enable', 'On')
end

MPC_Toggle_Menus(handles)



function Calibration_History_Delete(hObject, eventdata, target)
% delete parameter set(s) from history

handles = guidata(hObject);
history = get(handles.Calibration_History, 'UserData');
pos = get(handles.Calibration_History, 'Value');
if pos==1
    msgbox('Cannot delete initla library and parameter entries.', ...
        get(hObject, 'Label'), 'error', 'modal') 
    return
end

% which sets
switch target
    case 'ONLY'
        first = pos; last = pos;
    case 'FROMHERE'
        first = pos; last = length(history);
    case 'ALL'
        first = 2; last = length(history);
end

% delete
history(first:last) = [];

% update
history_len = length(history);
history_display = {};
for i=1:history_len
    history_display{i} = history{i}{3};
end
pos = min(pos,history_len);

set(handles.Calibration_History, 'UserData', history, ...
    'String', history_display, 'Value', pos)
Calibration_History_Callback(handles.Calibration_History, [], handles)



function pos = Calibration_Parameter_Add(hObject, eventdata, idxObject, keyword)
% add a calibration parameter

handles = guidata(hObject);
% handles.calibration_parameter{.} = {idxObject, keyword, {idx}, [tval(2) tval(1) tval(3)]};

% already in handles.calibration_parameter ?
pos = Calibration_Parameter_Find(handles, idxObject, keyword);
if pos>0
    display(sprintf('Already #%d in list: %d, %s', pos, idxObject, keyword))
    return
end

options.Resize = 'on';
options.WindowStyle = 'normal';
options.Interpreter = 'none';
name = ['Add ' keyword ' to calibration parameter list'];
numlines = 1;

fmt = {'%s', '%s(%d)', '%s(%d,%d)', '%s(%d,%d,%d)'};

% suppress 'lib_' or 'param_' in keyword
tKeyword = keyword;
if strncmp(tKeyword, 'lib_', 4)
    tKeyword(1:4) = [];
    idx = [];
    tValue = str2double(get(handles.(keyword), 'String'));
    if isnan(tValue)
        msgbox(['Initial value for ' tKeyword ' is not numeric.'], ...
            name, 'error', 'modal')
        return
    end
    
else  % "param_"
    displayStr = get(handles.(keyword), 'String');
    if isempty(displayStr)
        msgbox(['Initial value for ' keyword(7:end) ' is not specified.'], ...
            name, 'error', 'modal')
        return
    end
    valueIndex = get(handles.(keyword), 'Value');
    [tKeyword, tIdx, tValue] = Parameter_String_Parse(displayStr{valueIndex});
    if isempty(tKeyword)
        msgbox(displayStr, name, 'error', 'modal')
        return
    else
        idx = tIdx{1};
        if isempty(idx) % non-indexed param_
            tKeyword = keyword(7:end);
            tValue = str2double(get(handles.(keyword), 'String'));
            if isnan(tValue)
                msgbox(['Initial value for ' tKeyword ' is not numeric.'], ...
                    name, 'error', 'modal')
                return
            end
        end
    end
    % whos('tKeyword', 'idx', 'value')
    % tKeyword, idx, tValue
    
end

fidx = length(idx)+1;
switch keyword

    case {'param_Cmax', 'param_Cmin'} % (I,J,K)
        prompt = { ...
            sprintf(fmt{fidx}, ['Initial value for ' tKeyword], idx(1), idx(2), idx(3)); ...
            sprintf(fmt{fidx}, ['Minimum value for ' tKeyword], idx(1), idx(2), idx(3)); ...
            sprintf(fmt{fidx}, ['Maximum value for ' tKeyword], idx(1), idx(2), idx(3)) };

    case {'param_Ec','param_delta','param_alpha','param_re','param_lattce', 'param_nn2','param_attrac','param_repuls','param_zbl'}
        prompt = { ...
            sprintf(fmt{fidx}, ['Initial value for ' tKeyword], idx(1), idx(2) ); ...
            sprintf(fmt{fidx}, ['Minimum value for ' tKeyword], idx(1), idx(2) ); ...
            sprintf(fmt{fidx}, ['Maximum value for ' tKeyword], idx(1), idx(2) ) };

    case 'param_rho0'
        prompt = { ...
            sprintf(fmt{fidx}, ['Initial value for ' tKeyword], idx(1) ); ...
            sprintf(fmt{fidx}, ['Minimum value for ' tKeyword], idx(1) ); ...
            sprintf(fmt{fidx}, ['Maximum value for ' tKeyword], idx(1) ) };

    otherwise
        prompt = { ...
            sprintf(fmt{fidx}, ['Initial value for ' tKeyword] ); ...
            sprintf(fmt{fidx}, ['Minimum value for ' tKeyword] ); ...
            sprintf(fmt{fidx}, ['Maximum value for ' tKeyword] ) };
end


prompt{1} = sprintf('%s\n\n%s', handles.description.(keyword), prompt{1});
defaultanswer = { num2str(tValue); ...
    num2str(handles.minval.(keyword)); ...
    num2str(handles.maxval.(keyword)) };

answer = inputdlg(prompt, name, numlines, defaultanswer, options);
if isempty(answer), return, end % Cancelled
% whos('answer')

tval = str2double(answer);
if any(isnan(tval))
    msgbox('At least one input is not a valid number.', ...
        name, 'error', 'modal')
    return
end

% tval = [init min max]
% if tval(2)>tval(1) || tval(2)>tval(3) || tval(1)>tval(3)
%     msgbox(['Range of values for ' tKeyword ' is invalid.'], ...
%         name, 'error', 'modal')
%     return
% end
if tval(2)>tval(3)
    t = tval(2);
    tval(2) = tval(3);
    tval(3) = t;
end
if tval(2)>tval(1), tval(2) = tval(1); end
if tval(1)>tval(3), tval(3) = tval(1); end

% add entry to 'Calibration parameter'
handles.calibration_parameter{end+1} = {idxObject, keyword, {idx}, [tval(2) tval(1) tval(3)]};
pos = length(handles.calibration_parameter);

if strncmp(keyword, 'lib_', 4)
    handles.minval.(keyword) = tval(2);
    handles.maxval.(keyword) = tval(3);
end

guidata(hObject, handles)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)



function Calibration_Parameter_Delete(hObject, eventdata, idxObject, keyword)
% delete a calibration parameter

handles = guidata(hObject);
pos = Calibration_Parameter_Find(handles, idxObject, keyword);
if pos>0
    handles.calibration_parameter(pos) = [];
    guidata(hObject, handles)
% else
%     for i=1:length(handles.calibration_parameter)
%         display(sprintf('%d: %d, %s', i, handles.calibration_parameter{i}{1}, handles.calibration_parameter{i}{2}) )
%     end
%     display(sprintf('Not in list: %d, %s', idxObject, keyword))
end
Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)




function Calibration_Parameter_Edit(hObject, eventdata, idxObject, keyword)
% edit a calibration parameter

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');
pos = Calibration_Parameter_Find(handles, idxObject, keyword);
% handles.calibration_parameter{.} = {idxObject, keyword, {idx}, [tval(2) tval(1) tval(3)]};

idx     = handles.calibration_parameter{pos}{3}{1};
value   = handles.calibration_parameter{pos}{4};

% suppress 'lib_' or 'param_' in keyword
tKeyword = keyword;
if strncmp(tKeyword, 'lib_', 4)
    tKeyword(1:4) = [];
    qualifier = [MEAM_Object{idxObject,2} '.'];
else
    tKeyword(1:6) = [];
    qualifier = '';
end

options.Resize = 'on';
options.WindowStyle = 'normal';
options.Interpreter = 'none';
name = ['Edit ' tKeyword ' calibration parameter'];
numlines = 1;

fmt = {'%s', '%s(%d)', '%s(%d,%d)', '%s(%d,%d,%d)'};
fidx = length(idx)+1;

switch keyword

    case {'param_Cmax', 'param_Cmin'} % (I,J,K)
        prompt = { ...
            sprintf(fmt{fidx}, ['Initial value for ' tKeyword], idx(1), idx(2), idx(3)); ...
            sprintf(fmt{fidx}, ['Minimum value for ' tKeyword], idx(1), idx(2), idx(3)); ...
            sprintf(fmt{fidx}, ['Maximum value for ' tKeyword], idx(1), idx(2), idx(3)) };

    case {'param_Ec','param_delta','param_alpha','param_re','param_lattce','param_nn2','param_attrac','param_repuls','param_zbl'}
        prompt = { ...
            sprintf(fmt{fidx}, ['Initial value for ' tKeyword], idx(1), idx(2) ); ...
            sprintf(fmt{fidx}, ['Minimum value for ' tKeyword], idx(1), idx(2) ); ...
            sprintf(fmt{fidx}, ['Maximum value for ' tKeyword], idx(1), idx(2) ) };

    case 'param_rho0'
        prompt = { ...
            sprintf(fmt{fidx}, ['Initial value for ' tKeyword], idx(1) ); ...
            sprintf(fmt{fidx}, ['Minimum value for ' tKeyword], idx(1) ); ...
            sprintf(fmt{fidx}, ['Maximum value for ' tKeyword], idx(1) ) };

    otherwise
        prompt = { ...
            sprintf(fmt{fidx}, ['Initial value for ' qualifier tKeyword] ); ...
            sprintf(fmt{fidx}, ['Minimum value for ' qualifier tKeyword] ); ...
            sprintf(fmt{fidx}, ['Maximum value for ' qualifier tKeyword] ) };

end
defaultanswer = {num2str(value(2)); ...
    num2str(value(1)); ...
    num2str(value(3))};
prompt{1} = sprintf('%s\n\n%s', ...
    handles.description.(keyword), prompt{1});

answer = inputdlg(prompt, name, numlines, defaultanswer, options);
if isempty(answer), return, end % Cancelled
% whos('answer')

tval = str2double(answer);
if any(isnan(tval))
    msgbox('At least one input is not a valid number.', ...
        name, 'error', 'modal')
    return
end

tval = sort(tval);
if tval(1)==tval(2) && tval(2)==tval(3) 
    msgbox('Range of values for parameter is invalid.', ...
        name, 'error', 'modal')
    return
end

% replace old value
handles.calibration_parameter{pos}{4} = tval;
guidata(hObject, handles)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)




function pos = Calibration_Parameter_Find(handles, idxObject, keyword)
% find position of a parameter in the list of calibration parameters

pos = 0; % not found
if isempty(handles.calibration_parameter), return, end
% handles.calibration_parameter{.} = {idxObject, keyword, {idx}, [tval(2) tval(1) tval(3)]};

if strncmp(keyword, 'lib_', 4) % library file keyword    
    for i=1:length(handles.calibration_parameter)
        if strcmp(keyword, handles.calibration_parameter{i}{2}) && ...
                idxObject==handles.calibration_parameter{i}{1}
            pos = i;
            return
        end
    end
    
else % parameter file keyword; may need an index
    pos = 0;
    displayStr = get(handles.(keyword), 'String');
%     if isempty(displayStr) % non-indexed param_*; an error since it has no value
%         for i=1:length(handles.calibration_parameter)
%             if strcmp(keyword, handles.calibration_parameter{i}{2})
%                 pos = i;
%                 return
%             end
%         end
%     end
%     % whos('displayStr')
    
    valueIndex = get(handles.(keyword), 'Value');
    [tKeyword, tIdx, tValue] = Parameter_String_Parse(displayStr{valueIndex});
    if isempty(tKeyword)  % cannot be found
        return
    else
        pos = 0; % not found
        idx = tIdx{1};
%         if isempty(idx) % non-indexed param_
%             for i=1:length(handles.calibration_parameter)
%                 if strcmp(keyword, handles.calibration_parameter{i}{2})
%                     pos = i;
%                     return
%                 end
%             end
%         else % find matching index
            for i=1:length(handles.calibration_parameter)
                if ~strcmp(keyword, handles.calibration_parameter{i}{2}), continue, end
                diff = abs(idx-handles.calibration_parameter{i}{3}{1});
                if ~any(diff)
                    pos = i;
                    return
                end
            end
%         end
    end

end



function Calibration_Target_Clear(hObject, eventdata, idxObject)
% remove calibration targets associated with idxObject

handles = guidata(hObject);
for i=length(handles.calibration_target):-1:1
    if handles.calibration_target{i}{1} == idxObject, handles.calibration_target(i) = []; end
end
guidata(hObject, handles)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)




function pos = Calibration_Target_Find(handles, target)
% find the position of a calibration target in the list of targets
% target = {idxObject, varname, row, col, hyt, targetType, remark, latticeName, Ci, Cj};
%              1          2      3    4    5       6          7        8        9   10                


pos = 0;
for i=1:length(handles.calibration_target)
    if handles.calibration_target{i}{1} ~= target{1}, continue, end
    if ~strcmp(handles.calibration_target{i}{2}, target{2}), continue, end
    if handles.calibration_target{i}{3} ~= target{3}, continue, end
    if handles.calibration_target{i}{4} ~= target{4}, continue, end
    if handles.calibration_target{i}{5} ~= target{5}, continue, end
    if ~strcmp(handles.calibration_target{i}{6}, target{6}), continue, end
    if strcmp(target{2}, 'C') 
        if ~isempty(target{8}) && ~strcmp(handles.calibration_target{i}{8}, target{8}), continue, end
        if handles.calibration_target{i}{9} ~= target{9}, continue, end
        if handles.calibration_target{i}{10} ~= target{10}, continue, end
    end
    pos = i;

    break
end



function Calibration_Target_Toggle(hObject, eventdata, target)
% add/delete a calibration target

handles = guidata(hObject);
checkStatus = get(hObject, 'Checked');
if strcmpi(checkStatus, 'Off') % add to list of targets

    if ~strcmp(target{6}, 'Curve')
        handles.calibration_target{end+1} = target;
    
    else % user specifies range of target points
        MEAM_Object = get(handles.label_Library, 'UserData');
        idxObject = target{1};
        varName = target{2};
        row = target{3};
        col = target{4};
        hyt = target{5};
        latticeName = target{8};
        
        options.Resize = 'on';
        options.WindowStyle = 'normal';
        options.Interpreter = 'none';
        numlines = 1;
        name = 'User input';
        prompt = { 'Index to left end point'; 'Index to right end point'};
        toUpdate = false;
        
        if isempty(latticeName) % Single element E1, E2, E3, GFSEs
            if row==0
                [~, locTargetMin] = min(MEAM_Object{idxObject,7}.(varName).ydata);
                idxLeft = MEAM_Object{idxObject,7}.(varName).left;
                idxRight = MEAM_Object{idxObject,7}.(varName).right;
                nPoints = length(MEAM_Object{idxObject,7}.(varName).ydata);
                prompt{1} = sprintf('Calibration target points for %s: %s\n(Index to minimum point is %d of %d)\n\n%s', ...
                    MEAM_Object{idxObject,2}, target{7}, locTargetMin, nPoints, prompt{1});            
                defaultanswer = {num2str(idxLeft); num2str(idxRight)};
                answer = inputdlg(prompt, name, numlines, defaultanswer, options);
                if isempty(answer), return, end % Cancelled
                tval = str2double(answer);
                if ~(isnan(tval(1)) || tval(1)<1 || tval(1)>nPoints )
                    MEAM_Object{idxObject,7}.(varName).left = tval(1);
                    toUpdate = true;
                end
                if ~(isnan(tval(2)) || tval(2)>nPoints || tval(2)<1)
                    MEAM_Object{idxObject,7}.(varName).right = tval(2);
                    toUpdate = true;
                end
            else
                nPoints = length(MEAM_Object{idxObject,7}.(varName){row}.ydata);
                idxLeft = MEAM_Object{idxObject,7}.(varName){row}.left;
                idxRight = MEAM_Object{idxObject,7}.(varName){row}.right;
                prompt{1} = sprintf('Calibration target points for %s: %s (%d)\n\n%s', ...
                    MEAM_Object{idxObject,2}, target{7}, nPoints, prompt{1});            
                defaultanswer = {num2str(idxLeft); num2str(idxRight)};
                answer = inputdlg(prompt, name, numlines, defaultanswer, options);
                if isempty(answer), return, end % Cancelled
                tval = str2double(answer);
                if ~(isnan(tval(1)) || tval(1)<1 || tval(1)>nPoints)
                    MEAM_Object{idxObject,7}.(varName){row}.left = tval(1);
                    toUpdate = true;
                end
                if ~(isnan(tval(2)) || tval(2)>nPoints || tval(2)<1)
                    MEAM_Object{idxObject,7}.(varName){row}.right = tval(2);
                    toUpdate = true;
                end
            end
            
        else % Binary E1
            [~, locTargetMin] = min(MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.ydata);
            nPoints = length(MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.ydata);
            idxLeft = MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.left;
            idxRight = MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.right;
            prompt{1} = sprintf('Calibration target points for %s: %s\n(Index to minimum point is %d or %d)\n\n%s', ...
                strrep(latticeName, '_', '-'), target{7}, locTargetMin, nPoints, prompt{1});
            defaultanswer = {num2str(idxLeft); num2str(idxRight)};
            answer = inputdlg(prompt, name, numlines, defaultanswer, options);
            if isempty(answer), return, end % Cancelled
            tval = str2double(answer);
            if ~(isnan(tval(1)) || tval(1)<1|| tval(1)>nPoints)
                MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.left = tval(1);
                toUpdate = true;
            end
            if ~(isnan(tval(2)) || tval(2)>nPoints || tval(2)<1)
                MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.right = tval(2);
                toUpdate = true;
            end
        end
        
        if toUpdate, set(handles.label_Library, 'UserData', MEAM_Object), end
        handles.calibration_target{end+1} = target;

    end
    
else % delete from list of targets
    pos = Calibration_Target_Find(handles, target);
    if pos
        handles.calibration_target(pos) = [];
    end
end
guidata(hObject, handles)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)



function [parameterStr, targetStr] = Calibration_Selections(handles, MEAM_Object)

parameterStr = '';
fmt = {'%s=[%g,%g,%g]', '%s(%d)=[%g,%g,%g]', ...
    '%s(%d,%d)=[%g,%g,%g]', '%s(%d,%d,%d)=[%g,%g,%g]'};
for i=1:length(handles.calibration_parameter)
    idxObject  = handles.calibration_parameter{i}{1};
    keyword = handles.calibration_parameter{i}{2};
    idx     = handles.calibration_parameter{i}{3}{1};
    value   = handles.calibration_parameter{i}{4};
    % suppress 'lib_' or 'param_' in keyword
    if strncmp(keyword, 'lib_', 4)
        keyword(1:4) = [];
        parameterStr = [parameterStr ' ' sprintf(fmt{1}, ...
            [MEAM_Object{idxObject,2} ':' keyword], value)];
    else
        keyword(1:6) = [];
        fidx = length(idx)+1;
        switch fidx
            case 1
                parameterStr = [parameterStr ' ' sprintf(fmt{fidx}, keyword, ...
                    value)];
            case 2
                parameterStr = [parameterStr ' ' sprintf(fmt{fidx}, keyword, ...
                    idx(1), value)];
            case 3
                parameterStr = [parameterStr ' ' sprintf(fmt{fidx}, keyword, ...
                    idx(1), idx(2), value)];
            case 4
                parameterStr = [parameterStr ' ' sprintf(fmt{fidx}, keyword, ...
                    idx(1), idx(2), idx(3), value)];
        end
    end

end

% parameterStr = { ...
%     ['Parameters= {' parameterStr ' }']; ...
%     ['Optimization method is ' handles.optimization_names{handles.optimization_method} ...
%     '. Right-click a LIBRARY label or PARAMETER entry to add to calibration parameter list.']; ...
%     };
parameterStr = ['Parameters= {' parameterStr '}'];

targetStr = '';
for i=1:length(handles.calibration_target)
    idxObject  = handles.calibration_target{i}{1};
    varName = handles.calibration_target{i}{2};
    row = handles.calibration_target{i}{3};
    col = handles.calibration_target{i}{4};
    hyt = handles.calibration_target{i}{5};
    latticeName  = handles.calibration_target{i}{8};
    if isempty(latticeName)
        targetStr = [targetStr '; ' MEAM_Object{idxObject,2}  ...
            ':' handles.calibration_target{i}{7}];
        if strcmp(handles.calibration_target{i}{6}, 'Curve')
            if row==0
                targetStr = [targetStr '(' num2str(MEAM_Object{idxObject,7}.(varName).left) ':' ...
                    num2str(MEAM_Object{idxObject,7}.(varName).right) ')'];
            else
                targetStr = [targetStr '(' num2str(MEAM_Object{idxObject,7}.(varName){row}.left) ':' ...
                    num2str(MEAM_Object{idxObject,7}.(varName){row}.right) ')'];
            end
        end
    else
        targetStr = [targetStr '; ' strrep(latticeName,'_','-')  ...
            ':' handles.calibration_target{i}{7}];
        if strcmp(handles.calibration_target{i}{6}, 'Curve')
            targetStr = [targetStr '(' num2str(MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.left) ':' ...
                num2str(MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.right) ')'];
        end
    end
end
targetStr = ['Targets= {' targetStr(2:end) '}'];



function [library_out, parameter_out, library_changes, parameter_changes, ...
    outOfBounds] = Copy_values(x, calibration_parameter, library_in, parameter_in)
% make a working copy of library & parameter, updated from x()
% interpret x() using calibration_parameter

library_out = library_in;
parameter_out = parameter_in;
library_changes = 0;
parameter_changes = 0;
outOfBounds = 0;
n2fit = length(calibration_parameter);
for i=1:n2fit
    idxObject = calibration_parameter{i}{1};
    keyword   = calibration_parameter{i}{2};
    idx       = calibration_parameter{i}{3}{1};
    value     = calibration_parameter{i}{4};
    % suppress 'lib_' or 'param_' in keyword
    if strncmp(keyword, 'lib_', 4)
        keyword(1:4) = [];
        library_out{idxObject}.(keyword) = x(i);
        library_changes = library_changes+1;
        if x(i)<value(1) || x(i)>value(3)
            outOfBounds = outOfBounds+1;
        end
        
    else
        keyword(1:6) = [];
        % find entry in parameter file
        for j=1:length(parameter_out)

            % find matching keyword
            if ~strcmp(keyword, parameter_out{j}{1}), continue, end

            % find matching index
            tIdx = parameter_out{j}{2};
            % whos('tIdx')
            if any(reshape(tIdx{1},size(idx))~=idx), continue, end

            % set value 
            parameter_out{j}{3} = x(i);
            parameter_changes = parameter_changes+1;
            if x(i)<value(1) || x(i)>value(3)
                outOfBounds = outOfBounds+1;
            end
            break;
        end

    end
end



function Elements_Fix(hObject, event, list)
% fix entries in library to be those selected by user

% the original list
handles = guidata(hObject);
meam_data = get(handles.File_Library_Load, 'UserData');

% the pruned list
library = meam_data.library(list);
numElements = length(list);
meam_data.library = library;
meam_data.library_is_fixed = true;
meam_data.MEAM_elements = 1:numElements; 
meam_data.LAMMPS_atom_types = meam_data.MEAM_elements;

elementList = cell(numElements,1);
% eltstring = '';
for i=1:numElements
    elementList{i} = meam_data.library{i}.elt;
%     eltstring = [eltstring ' ' meam_data.library{i}.elt];
end

% how many objects in all?
nObjects = zeros(1,numElements);
if numElements>1
    for grpSize=1:min(3,numElements)
        nObjects(grpSize) = nchoosek(numElements,grpSize);
        display(sprintf('Group size %d has %d objects', grpSize, nObjects(grpSize)) )
    end
    allObjects = sum(nObjects);
    % if numElements>3, allObjects = allObjects+1; end
else
    nObjects(1) = 1;
    allObjects = sum(nObjects);
end
% nObjects
display(sprintf('Total no. of objects is %d', allObjects) )

% initial focus
meam_data.library_entry_on_focus = 1;

% create structure for objects
% {:,1} - [], index to element(s) in library 
% {:,2} - 'string', object tag 
% {:,3} - include flag, plot + plot flag
% {:,4} - cell, library file entries
% {:,5} - [], lattices
% {:,6} - struct, lammps_MPC() output
% {:,7} - struct, calibration targets
MEAM_Object = cell(allObjects, 8);
% initialize elements
idxObject = 0;
for i=1:numElements
    idxObject = idxObject + 1;

    MEAM_Object{idxObject,1} = i; % index to MEAM_elements
    MEAM_Object{idxObject,2} = meam_data.library{i}.elt;
    % include in run = 1; include in plot = 2; include in run+plot = 3
    MEAM_Object{idxObject,3} = 2; 
    MEAM_Object{idxObject,4} = meam_data.library{i}; % library file entries
    
    idxLattice = find(strcmpi(handles.lattices, meam_data.library{i}.lat));
    if isempty(idxLattice), idxLattice = 0; end
    MEAM_Object{idxObject,5} = [idxLattice, 0, 0]; % lattice1, lattice2, lattice3

    % lammps_MPC() output structure
    MEAM_Object{idxObject,6} = []; 
    
    % calibration targets, like the lammps_MPC() output structure
    MEAM_Object{idxObject,7}.E0 = [];
    MEAM_Object{idxObject,7}.E1 = [];
    MEAM_Object{idxObject,7}.E2 = [];
    MEAM_Object{idxObject,7}.E3 = [];
    MEAM_Object{idxObject,7}.C = cell(6,6);
    MEAM_Object{idxObject,7}.Evac = [];
    MEAM_Object{idxObject,7}.Einterstitials = {};
    MEAM_Object{idxObject,7}.ESurfaces = {};
    MEAM_Object{idxObject,7}.GSFEs = {};
    
end


% initialize binaries
if numElements>1
    Binary = nchoosek(1:numElements,2);
    numBinaries = size(Binary,1);
    for i=1:numBinaries
        idxObject = idxObject + 1;
        Ei = Binary(i,1);
        Ej = Binary(i,2);
        MEAM_Object{idxObject,1} = [Ei, Ej]; % index to MEAM_elements
        MEAM_Object{idxObject,2} = [elementList{Ei} '+' elementList{Ej}];
        % include in run = 1; include in plot = 2; include in run+plot = 3
        MEAM_Object{idxObject,3} = 2; 
        MEAM_Object{idxObject,4} = {}; % library file entries
        MEAM_Object{idxObject,5} = find(strcmpi(handles.BLattices, 'B1')); % binary lattices
        MEAM_Object{idxObject,6} = []; % lammps_MPC() output structure

        % calibration targets, like the lammps_MPC() output structure
        MEAM_Object{idxObject,7}.E0 = [];
        MEAM_Object{idxObject,7}.E1 = [];
        MEAM_Object{idxObject,7}.H  = []; 
        MEAM_Object{idxObject,7}.Nx = [];
        MEAM_Object{idxObject,7}.C  = [];
        MEAM_Object{idxObject,7}.Substitution  = cell(2,2);
        MEAM_Object{idxObject,7}.ISubstitution = cell(2,2);
        
    end
end

% initialize ternaries
if numElements>2
    Ternary = nchoosek(1:numElements,3);
    numTernaries = size(Ternary,1);
    for i=1:numTernaries
        idxObject = idxObject + 1;
        Ei = Ternary(i,1);
        Ej = Ternary(i,2);
        Ek = Ternary(i,3);
        MEAM_Object{idxObject,1} = [Ei, Ej, Ek]; % index to MEAM_elements
        MEAM_Object{idxObject,2} = [elementList{Ei} '+' elementList{Ej} '+' elementList{Ek}];
        % include in run = 1; include in plot = 2; include in run+plot = 3
        MEAM_Object{idxObject,3} = 2; 
        MEAM_Object{idxObject,4} = {}; % library file entries
        MEAM_Object{idxObject,5} = []; % binary lattices
        MEAM_Object{idxObject,6} = []; % lammps_MPC() output structure

        MEAM_Object{idxObject,7}.BindingEnergy = cell(3, 3, 3);

    end
end

set(handles.label_Library, 'UserData', MEAM_Object)

set(handles.File_Library_Load, 'UserData', meam_data)

choices = cell(allObjects,1);
for i=1:allObjects
    choices{i} = [num2str(MEAM_Object{i,1},'%d') ':' MEAM_Object{i,2}];
end
set(handles.Parameter_Entries_Select, ...
    'String', choices, ...
    'Value', 1)

set(handles.Library_Entry_Select, ...
    'String', choices, ...
    'Value', 1, ...
    'UIContextMenu', [], ...
    'ToolTipString', '')

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, event, handles)

element_list = Elements_List(MEAM_Object);
displayStr{1} = ['Element(s): '  element_list ...
    '. Reload a *.library.meam to reselect.'];

displayStr{end+1} = '-----';
displayStr{end+1} = ['To proceed, click menu File | Load MEAM parameter file for ' element_list];

set(handles.text_Display, 'String', sprintf('%s\n', displayStr{:}))


function elementList = Elements_List(MEAM_Object)
% make a space-delimited list of element names

numElements = max(MEAM_Object{end,1});
elementList = sprintf('%s ', MEAM_Object{1:numElements,2});

% remove leading/trailing spaces
elementList = strtrim( elementList );



function mesg = File_Library_Write(handles, libFile, library, target, comment)
% write libFile consisting of the target entries

[fid, mesg] = fopen(libFile, 'wt');
if fid==-1, return, end

if ~isempty(comment)
    fprintf(fid, '#\n# %s\n#\n', comment);
end

fprintf(fid, '#\n%s\n%s\n%s\n#\n', ...
    '# elt        lat     z       ielement     atwt', ...
    '# alpha      b0      b1      b2           b3    alat    esub    asub', ...
    '# t0         t1              t2           t3            rozero  ibar');
formatDisp = '\n''%s'' ''%s'' %d %d %f\n%f %f %f %f %f %f %f %f\n%f %f %f %f %f %d\n';
for i=1:length(target)
    entry = library{target(i)};
    fprintf(fid, formatDisp, ...
        entry.elt, ... % elt
        entry.lat, ... % lat
        entry.z, entry.ielement, entry.atwt, ... % z       ielement     atwt
        entry.alpha, ... % alpha
        entry.b0, entry.b1, entry.b2, entry.b3, ... % b[0-3]
        entry.alat, entry.esub, entry.asub, ... % alat    esub    asub
        entry.t0, entry.t1, entry.t2, entry.t3, ... % t[0-3]
        entry.rozero, entry.ibar); % rozero  ibar
end
fclose(fid);


function [p, message] = File_Parameters_Read_Raw(fname)
% retrieve parameter file

p = {};

[fid, message] = fopen(fname, 'rt');
if fid==-1
    display(message)
end

% disp(fullfile(pathname, fname{i}));
while ~feof(fid)
    tline = fgetl(fid);
    [keyword, idx, value] = Parameter_String_Parse(tline);        
    if ~isempty(keyword)
        p{end+1} = {keyword, idx, value};
    end
end
fclose(fid);

if isempty(p)
    message = ['No parameter file entries recognized in ' fname];
end


function mesg = File_Parameters_Write( paramFile, parameterEntry )
% write MEAM parameter file from parameters structure 

[fid, mesg] = fopen(paramFile, 'wt');
if fid==-1, return, end

% collect values to be displayed for each parameter
numEntries = length(parameterEntry);
fmt0 = {'%s=', '%s(%d)=', '%s(%d,%d)=', '%s(%d,%d,%d)='};
for i=1:numEntries
    keyword = parameterEntry{i}{1};
    keyword = strtrim(keyword);
    idx = parameterEntry{i}{2}{1};
    fidx = length(idx)+1;
    value = parameterEntry{i}{3};
    if ischar(value)
        fmt = [fmt0{fidx} '%s\n'];
    else
        fmt = [fmt0{fidx} '%f\n'];
    end
    
    switch fidx
        case 1
            fprintf(fid, fmt, keyword, value);
        case 2
            fprintf(fid, fmt, keyword, idx(1), value);
        case 3
            fprintf(fid, fmt, keyword, idx(1), idx(2), value);
        case 4
            fprintf(fid, fmt, keyword, idx(1), idx(2), idx(3), value);
    end
end

fclose(fid);


function mesg = File_Parameters_Write_From_Display(handles, paramFile, comment)
% write parameter file

[fid, mesg] = fopen(paramFile, 'wt');
if fid==-1, return, end
if ~isempty(comment)
    fprintf(fid, '#\n# %s\n#\n', comment);
end

% collect from Parameter section of GUI
for i=1:length(handles.parameter_field_label)
    keyword = handles.parameter_field_label{i};
    gui_tag = handles.parameter_gui_field{i};

    if isfield(handles, gui_tag)

        fprintf(fid, '\n# %s\n', handles.description.(gui_tag));
        displayStr = get(handles.(gui_tag), 'String');
        % keyword, displayStr
        if ~iscell(displayStr), continue, end
        
        switch keyword
            
            case {'Cmax', 'Cmin'}
                for j=1:length(displayStr)
                    [tKeyword, ~, value] = Parameter_String_Parse(displayStr{j});
                    if ~isempty(tKeyword)
                        fprintf(fid, '%s\n', displayStr{j});
                    end
                end
                
            case {'Ec','delta','alpha','re','lattce','nn2','attrac','repuls','zbl'}
                for j=1:length(displayStr)
                    [tKeyword, ~, value] = Parameter_String_Parse(displayStr{j});
                    if ~isempty(tKeyword)
                        fprintf(fid, '%s\n', displayStr{j});
                    end
                end
                
            case 'rho0'
                for j=1:length(displayStr)
                    [tKeyword, ~, value] = Parameter_String_Parse(displayStr{j});
                    if ~isempty(tKeyword)
                        fprintf(fid, '%s\n', displayStr{j});
                    end
                end
                
            otherwise
                value = str2double(displayStr);
                if ~isnan(value)
                    fprintf(fid, '%s=%g\n', keyword, value);
                end
        end
        
    end

end
fclose(fid);



function File_Parameters_Write_Now(hObject, eventdata, outFile)
% write parameter file

handles = guidata(hObject);
meam_data = get(handles.File_Library_Load, 'UserData');
if isempty(meam_data), return, end
if isempty(outFile)
    eltstring = MEAM_Elements_String(meam_data);
    if ~isempty(eltstring)
        fName = [strrep(eltstring, ',', '') '.parameter.meam'];
    else
        fName = [handles.program_tag '.parameter.meam'];
    end
else
    fName = outFile;
end
% write parameter file
mesg = File_Parameters_Write_From_Display(handles, fName, ...
    ['Generated by MPC on ' datestr(now,30)]);
if ~isempty(mesg), return, end
msgbox(['Wrote ' fName], 'Write parameter file', 'none', 'modal')


% --------------------------------------------------------------------
function File_Restart(hObject, eventdata, handles)
% hObject    handle to MPC_Restart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

dlg_title = get(hObject, 'Label');
action = get(hObject, 'Tag');

switch action

    case 'File_Restart_Write'
        [t_fname, t_path] = uiputfile([handles.program_tag '-restart.mat'], dlg_title);
        
    case 'File_Restart_Load'
        [t_fname, t_path] = uigetfile([handles.program_tag '-restart.mat'], dlg_title);

    otherwise
        return
end
% cancelled ?
if isequal(t_fname, 0), return, end
filename = fullfile(t_path, t_fname);

% data in handles
handleFields = { ...
    'optimization_method', ...
    'optimization_options', ...
    'isParallel', ...
    'pso_options', ...
    'ga_options', ...
    'gamultiobj_options', ...
    'ps_options', ...     
    'program_tag', ...
    'calibration_parameter', ...
    'calibration_target', ...
    };

% UserData in edit & text controls, and menu items
objList = findobj('Style', 'pushbutton', ...
    '-or', 'Style', 'text', ...
    '-or', 'Style', 'edit', ...
    '-or', 'Style', 'popupmenu', ...
    '-or', 'Type', 'uimenu');

% labels of menu items
labelList = findobj('Type', 'uimenu');

% strings
stringList = findobj( ...
    '-or', 'Style', 'text', ...
    '-or', 'Style', 'edit', ...
    '-or', 'Style', 'popupmenu');

switch action

    case 'File_Restart_Write'
    
        % collect into a single structure
        restart_data = [];
        
        for i=1:length(handleFields)
            tag = handleFields{i};
            restart_data.(tag) = handles.(tag);
        end
        
        for i=1:length(objList)
            tag = get(objList(i), 'Tag');
            if ~isempty(tag)
                data = get(objList(i), 'UserData');
                if ~isempty(data)
                    restart_data.(tag) = data;
                end
            end
        end
        
        for i=1:length(labelList)
            tag = get(labelList(i), 'Tag');
            if ~isempty(tag)
                data = get(labelList(i), 'Label');
                if ~isempty(data)
                    restart_data.label.(tag) = data;
                end
                restart_data.checked.(tag) = get(labelList(i), 'Checked');
            end
        end

        for i=1:length(stringList)
            tag = get(stringList(i), 'Tag');
            if ~isempty(tag)
                data = get(stringList(i), 'String');
                if ~isempty(data)
                    restart_data.string.(tag) = data;
                end
            end
        end
        % fieldnames(restart_data)

        % write
        save(filename, 'restart_data')
        

    case 'File_Restart_Load'
        
        t = load (filename, 'restart_data');
        tag = 'program_tag';
        if ~strcmp(handles.(tag), t.restart_data.(tag))
            msgbox(['Version mismatch in ' filename '; expecting ' ...
                handles.(tag) ...
                ', but restart file has ' t.restart_data.(tag)], ...
                dlg_title, 'error', 'modal')
            return
        end
        
        tagList = fieldnames(t.restart_data);
        for i=1:length(handleFields)
            tag = handleFields{i};
            if isempty(tag), continue, end
            if any(strcmp(tag, tagList))
                handles.(tag) = t.restart_data.(tag);
            end
        end
        for i=1:length(objList)
            tag = get(objList(i), 'Tag');
            if isempty(tag), continue, end
            if any(strcmp(tag, tagList))
                set(objList(i), 'UserData', t.restart_data.(tag));
            end
        end

        tagList = fieldnames(t.restart_data.label);
        for i=1:length(labelList)
            tag = get(labelList(i), 'Tag');
            if isempty(tag), continue, end
            if any(strcmp(tag, tagList))
                set(labelList(i), 'Label', t.restart_data.label.(tag));
            end
        end

        tagList = fieldnames(t.restart_data.checked);
        for i=1:length(labelList)
            tag = get(labelList(i), 'Tag');
            if isempty(tag), continue, end
            if any(strcmp(tag, tagList))
                set(labelList(i), 'Checked', t.restart_data.checked.(tag));
            end
        end
        
        tagList = fieldnames(t.restart_data.string);
        for i=1:length(stringList)
            tag = get(stringList(i), 'Tag');
            if isempty(tag), continue, end
            if any(strcmp(tag, tagList))
                set(stringList(i), 'String', t.restart_data.string.(tag));
            end
        end
        
        % close LAMMPS connetion
        if ~isempty(handles.LAMMPS_ptr)
            try
                lammps_close(handles.LAMMPS_ptr);
            catch
                display('Connection to LAMMPS not open.')
            end
        end
        
        % re-open LAMMPS connection
        try
            % handles.LAMMPS_ptr = lammps_open('-log','none');
            handles.LAMMPS_ptr = lammps_open(handles.LAMMPS_open_args{1}, handles.LAMMPS_open_args{2});
        catch
            handles.LAMMPS_ptr = [];
        end

        % update handles
        guidata(hObject, handles)
        
        tag = 'Calibration_History';
        if any(strcmp(tag, tagList)) && isfield(t.restart_data, tag) 
            history = t.restart_data.(tag);
            history_len = length(history);
            history_display = {};
            for i=1:history_len
                history_display{i} = history{i}{3};
            end
            set(handles.Calibration_History, 'UserData', history, 'Enable', 'On', ...
                'Value', history_len, 'String', history_display)
            Calibration_History_Callback(handles.Calibration_History, [], handles)

            MPC_Toggle_Menus(handles)

        else
            history = {};
            set(handles.Calibration_History, 'UserData', history)
            Calibration_History_Callback(handles.Calibration_History, [], handles)
            Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)

        end
               
end

msgbox([dlg_title ' ' filename ' done!'], dlg_title, 'none', 'modal')



function Lattice_Select_Binary(hObject, eventdata, idxObject)
% select binary lattices

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');
% numElements = size(MEAM_Object{end,1},2);
% elementIdx = MEAM_Object{idxObject,1};
tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
% runData = MEAM_Object{idxObject,6};

dlgTitle = ['Select binary lattice(s) for ' tag];

[idxSelection, ok] = listdlg( ...
    'PromptString', dlgTitle,...
    'ListSize', [175 400], ...
    'Name', 'User input', ...
    'SelectionMode','Multiple',...
    'InitialValue', 1, ...
    'ListString', handles.BLattices);
if ~ok, return, end
% idxSelection

MEAM_Object{idxObject,5} = idxSelection;
MEAM_Object{idxObject,6} = [];
set(handles.label_Library, 'UserData', MEAM_Object)

Text_Display_Object(handles, MEAM_Object, idxObject)

MPC_Toggle_Menus(handles)


function Lattice_Select_SingleElement(hObject, eventdata, idxObject, structIdx)
% select primary/secondary1/secondary2 structure for MEAM element

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');
% numElements = size(MEAM_Object{end,1},2);
% elementIdx = MEAM_Object{idxObject,1};
tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
lattice = MEAM_Object{idxObject,5};
% runData = MEAM_Object{idxObject,6};

dlgTitle = ['Select ' tag handles.structName{structIdx}];
hasChanges = false;
structures = handles.lattices;
switch structIdx

    case 1
        [idxSelection, ok] = listdlg( ...
            'PromptString', dlgTitle,...
            'ListSize', [300 200], ...
            'Name', 'User input', ...
            'SelectionMode','single',...
            'InitialValue', 1, ...
            'ListString', structures);
        if ~ok, return, end
        lattice = [find(strcmp(handles.lattices, structures{idxSelection})), 0, 0];
        hasChanges = true;
        
    case 2

        if ~lattice(1)
            msgbox(['The' handles.structName{1} 'for ' tag ' must be specified first.'], ...
                dlgTitle, 'error', 'modal')
            return
        else
            %display([elementStr handles.structName{1} 'is ' handles.lattices{lattice(1)} '.'])
            structures(lattice(1)) = [];
        end
        [idxSelection, ok] = listdlg( ...
            'PromptString', dlgTitle,...
            'ListSize', [300 200], ...
            'Name', 'User input', ...
            'SelectionMode','single',...
            'InitialValue', 1, ...
            'ListString', structures);
        if ~ok, return, end
        %display([elementStr handles.structName{structIdx} 'is ' structures{idxSelection} '.'])
        lattice = [lattice(1), ...
            find(strcmp(handles.lattices, structures{idxSelection})), ...
            0];
        hasChanges = true;
       
    case 3
        if ~lattice(1)
            msgbox(['The' handles.structName{1} 'for ' tag ' must be specified first.'], ...
                dlgTitle, 'error', 'modal')
            return
        end
        if ~lattice(2)
            msgbox(['The' handles.structName{2} 'for ' tag ' must be specified first.'], ...
                dlgTitle, 'error', 'modal')
            return
        end
        %display([elementStr handles.structName{1} 'is ' handles.lattices{lattice(1)} '.'])
        %display([elementStr handles.structName{2} 'is ' handles.lattices{lattice(2)} '.'])
        structures([lattice(1), lattice(2)]) = [];
        [idxSelection, ok] = listdlg( ...
            'PromptString', dlgTitle,...
            'ListSize', [300 200], ...
            'Name', 'User input', ...
            'SelectionMode','single',...
            'InitialValue', 1, ...
            'ListString', structures);
        if ~ok, return, end
        %display([elementStr handles.structName{structIdx} 'is ' structures{idxSelection} '.'])
        lattice = [lattice(1),...
            lattice(2), ...
            find(strcmp(handles.lattices, structures{idxSelection})) ];
        hasChanges = true;
        
end

if hasChanges
    MEAM_Object{idxObject,5} = lattice;
    MEAM_Object{idxObject,6} = [];
    set(handles.label_Library, 'UserData', MEAM_Object)
end

Text_Display_Object(handles, MEAM_Object, idxObject)
MPC_Toggle_Menus(handles)


function Parameter_Entries_Redisplay(handles, parameterEntry, MEAM_Object, objectIdx)
% display parameter file entries

if isempty(parameterEntry)
    set(findobj('-regexp', 'Tag', '^param_'), ...
        'String', ' ', ...
        'Value', 1, ...
        'Enable', 'Off', ...
        'UIContextMenu', [])
    set(findobj('-regexp', 'Tag', '^label_param_'), ...
        'UIContextMenu', [])
    set(handles.label_Parameters, 'UIContextMenu', [])
    return
end

numElements = max(MEAM_Object{end,1});
elementIdx = MEAM_Object{objectIdx,1};

toExclude = 1:numElements;
toExclude(elementIdx) = [];

toIncludeStr = '';
for i=elementIdx
    toIncludeStr = sprintf('%s; %d for %s', toIncludeStr, i, MEAM_Object{i,2});
end
toIncludeStr = toIncludeStr(3:end);

displayStr = Parameter_Strings_Collect(handles, parameterEntry, toExclude);

% edit display according to enable & fitted switches
for i=1:length(handles.parameter_field_label)
    keyword = handles.parameter_field_label{i};
    gui_tag = handles.parameter_gui_field{i};
    if ~isfield(handles, gui_tag), continue, end
    
    hasIndex = strfind(handles.parameter_default.(keyword), '(') * ...
        strfind(handles.parameter_default.(keyword), ')') > 0;    
    current = 1;

    % context menu
    cmenu = uicontextmenu;

    % indexed or non-indexed parameter?
    if hasIndex

        % keyword in {Cmax, Cmin, attrac, repuls, Ec, delta, alpha, re, lattce, nn2, zbl, rho0}
        current = get(handles.(gui_tag), 'Value');
        enableStat = 'On';

        if isempty(displayStr.(keyword))
            displayStr.(keyword){end+1} = ['# ' keyword];
            uimenu(cmenu, 'Label', ['Add ' keyword], ...
                'Callback', {@Parameter_Indexed_Add, keyword, toIncludeStr});

            % update 'String'
            current = max(1,min(current, length(displayStr.(keyword))));
            set(handles.(gui_tag), ...
                'String', displayStr.(keyword), ...
                'Value', current, ...
                'Enable', enableStat, ...
                'UIContextMenu', cmenu)

        else
            % update 'String'
            current = max(1,min(current, length(displayStr.(keyword))));
            set(handles.(gui_tag), ...
                'String', displayStr.(keyword), ...
                'Value', current)

            uimenu(cmenu, ...
                'Label', ['Edit this ' keyword ' value'], ...
                'Callback', {@Parameter_Indexed_Edit, keyword, toIncludeStr});
            uimenu(cmenu, ...
                'Label', ['Delete this ' keyword ' value'], ...
                'Callback', {@Parameter_Indexed_Delete, keyword});
            uimenu(cmenu, 'Label', ['Add another ' keyword], 'Separator', 'On', ...
                'Callback', {@Parameter_Indexed_Add, keyword, toIncludeStr});
            
            % menu for add to/edit/del from 'Calibration parameter'
            index2fittedlist = Calibration_Parameter_Find(handles, 0, gui_tag);
            if index2fittedlist>0
                uimenu(cmenu, 'Separator', 'On', ...
                    'Label', 'Edit initial value & range in calibration parameter list', ...
                    'Callback', {@Calibration_Parameter_Edit, 0, gui_tag});
                uimenu(cmenu, ...
                    'Label', 'Remove from calibration parameter list', ...
                    'Callback', {@Calibration_Parameter_Delete, 0, gui_tag});
            else
                uimenu(cmenu, 'Separator', 'On', ...
                    'Label', 'Add to calibration parameter list', ...
                    'Callback', {@Calibration_Parameter_Add, 0, gui_tag} );
            end
%             uimenu(cmenu, ...
%                 'Label', 'Parameteric study', 'Separator', 'On', ...
%                 'Callback', {@Parameter_Study, gui_tag} );            
            set(handles.(gui_tag), ...
                'Enable', enableStat, ...
                'UIContextMenu', cmenu)

        end        

    else % non-indexed 
        
        % keyword in {rc, delr, gsmooth_factor, augt1, ialloy, mixture_ref_t, erose_form, emb_lin_neg, bkgd_dyn}
        enableStat = 'On';
        
        % update 'String'
        set(handles.(gui_tag), ...
            'String', displayStr.(keyword), ...
            'Value', current, ...
            'Enable', enableStat, ...
            'UIContextMenu', cmenu)
        
    end
   
end


function displayStr = Parameter_Strings_Collect(handles, parameterEntry, toExclude)
% initialize strings for parameter entries

% MEAM_Object = get(handles.label_Library, 'UserData');
% numElements = max(MEAM_Object{end,1});
% elementIdx = MEAM_Object{objectIdx,1};
% toExclude = 1:numElements;
% toExclude(elementIdx) = [];
% 
numEntries = length(parameterEntry);
fmt0 = {'', '%s(%d)=', '%s(%d,%d)=', '%s(%d,%d,%d)='};
displayStr = [];
for i=1:length(handles.parameter_field_label)
    keyword = handles.parameter_field_label{i};
    displayStr.(keyword) = {};
end
% collect values to be displayed
for i=1:numEntries
    keyword = parameterEntry{i}{1};
    keyword = strtrim(keyword);
    idx = parameterEntry{i}{2}{1};
    
    exclude = false;
    for j=toExclude
        if ~isempty(find(idx==j,1))
            %display([num2str(idx') '  contains excluded ' num2str(j)])
            exclude = true; 
        end
    end
    if exclude, continue, end
    fidx = length(idx)+1;
    value = parameterEntry{i}{3};
    if isempty(value)
        if fidx==1
            displayStr.(keyword){end+1} = '';
        else
            displayStr.(keyword){end+1} = ['# ' keyword];
        end
        continue
    elseif ischar(value)
        fmt = [fmt0{fidx} '%s'];
    else
        fmt = [fmt0{fidx} '%g'];
    end

    switch fidx
        case 1
            displayStr.(keyword){end+1} = sprintf(fmt, value);
        case 2
            displayStr.(keyword){end+1} = sprintf(fmt, keyword, idx(1), value);
        case 3
            displayStr.(keyword){end+1} = sprintf(fmt, keyword, idx(1), idx(2), value);
        case 4
            displayStr.(keyword){end+1} = sprintf(fmt, keyword, idx(1), idx(2), idx(3), value);
    end
end


function Library_Entry_Redisplay(handles, MEAM_Object, idxObject)

% numElements = size(MEAM_Object{end,1},2);
% elementIdx = MEAM_Object{idxObject,1};
% objType = size(elementIdx,2);
% tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
% runData = MEAM_Object{idxObject,6};

if isempty(MEAM_Object) || idxObject==0 || isempty(MEAM_Object{idxObject,4})
    % nothing to display
    set(findobj('-regexp', 'Tag', '^lib_'), ...
        'String', '', ...
        'Enable', 'Off')
    set(findobj('-regexp', 'Tag', '^label_lib_'), ...
        'UIContextMenu', [])
    set(handles.label_Library, 'UIContextMenu', [])
    return
end

% an element/binary/ternary was selected
libEntry = MEAM_Object{idxObject,4};
elementIdx = MEAM_Object{idxObject,1};
objType = size(elementIdx,2);
switchIndex = min(1+objType, 3);

for i=1:length(handles.library_gui_field)
    gui_field_name = handles.library_gui_field{i};
    if isempty(gui_field_name), continue, end
    if ~isfield(handles, gui_field_name), continue, end
    library_field = handles.library_field_label{i};
    if isempty(library_field), continue, end
    value = libEntry.(library_field);
    if ischar(value)
        tstr = value;
    else
        tstr = num2str(value, '%g');
    end
    set(handles.(gui_field_name), 'String', tstr)
    
    % the context menu
    cmenu = uicontextmenu;

    if handles.enable.(gui_field_name)(switchIndex)
        enableStat = 'On';
    else
        enableStat = 'Off';
    end

    if handles.fitted.(gui_field_name)(switchIndex)
        index2fittedlist = Calibration_Parameter_Find(handles, idxObject, gui_field_name);
        if index2fittedlist>0
            uimenu(cmenu, ...
                'Label', 'Edit initial value & range in calibration parameter list', ...
                'Callback', {@Calibration_Parameter_Edit, idxObject, gui_field_name});
            uimenu(cmenu, ...
                'Label', 'Remove from calibration parameter list', ...
                'Callback', {@Calibration_Parameter_Delete, idxObject, gui_field_name});
        else
            uimenu(cmenu, ...
                'Label', 'Add to calibration parameter list', ...
                'Callback', {@Calibration_Parameter_Add, idxObject, gui_field_name} );
        end
%         uimenu(cmenu, ...
%             'Label', 'Parameteric study', 'Separator', 'On', ...
%             'Callback', {@Parameter_Study, idxObject, gui_field_name} );
    end

    set(handles.(gui_field_name), 'Enable', enableStat)

    if isfield(handles, ['label_' gui_field_name])
        set(handles.(['label_' gui_field_name]), 'UIContextMenu', cmenu)
    end
    
end



function MEAM_Element_Add(hObject, event, focus)
% add library entry on focus as MEAM element

% focus
handles = guidata(hObject);
meam_data = get(handles.File_Library_Load, 'UserData');

if ~isempty(find(meam_data.MEAM_elements==focus,1)), return, end
meam_data.MEAM_elements(end+1) = focus;

% automatically add as atom type if it is the first element
% if length(meam_data.MEAM_elements)==1
    meam_data.LAMMPS_atom_types(end+1) = focus;
% end
set(handles.File_Library_Load, 'UserData', meam_data)
MEAM_Library_Redisplay(handles, meam_data)


function MEAM_Element_Delete(hObject, event, focus)
% delete library entry on focus as MEAM element

handles = guidata(hObject);
meam_data = get(handles.File_Library_Load, 'UserData');

ind = find(meam_data.MEAM_elements==focus,1);
meam_data.MEAM_elements(ind) = [];

ind = find(meam_data.LAMMPS_atom_types==focus);
if ~isempty(ind)
    meam_data.LAMMPS_atom_types(ind) = [];
end

set(handles.File_Library_Load, 'UserData', meam_data)
MEAM_Library_Redisplay(handles, meam_data)


function eltstring = MEAM_Elements_String(meam_data)
% the MEAM elements string

eltstring = '';
numelt = length(meam_data.MEAM_elements);

if length(meam_data.library)>numelt
    for idx=1:numelt
        eltidx = meam_data.MEAM_elements(idx);
        eltstring = [eltstring ',' meam_data.library{eltidx}.elt '(' num2str(eltidx) ')'];
    end
    eltstring = eltstring(2:end);
else
    for idx=1:numelt
        eltidx = meam_data.MEAM_elements(idx);
        eltstring = [eltstring ',' meam_data.library{eltidx}.elt];
    end
    eltstring = eltstring(2:end);
end



function library = MEAM_Library_Load(handles, pathname, filename)
% read MEAM library file

library = {};

[fid, message] = fopen(fullfile(pathname, filename), 'rt');
if fid==-1
    msgbox([fullfile(pathname, filename) ' : ' message], ...
        'Load MEAM library', 'error', 'modal')
    return
end

% # meam data from vax files fcc,bcc,dia    11/4/92
% # elt        lat     z       ielement     atwt
% # alpha      b0      b1      b2           b3    alat    esub    asub
% # t0         t1              t2           t3            rozero  ibar
% 
% 'AlS'        'fcc'   12.     13           26.9815
% 4.64        2.04    3.00    6.0          1.50  4.05    3.353    1.07
% 1.0         +4.50           -2.30        8.01          1.0    -5
% 'SiS'        'dia'   4.      14           28.086
% 4.87        4.4     5.5     5.5          5.5   5.431   4.63    1.
% 1.0         2.05            4.47         -1.80         2.2    -5

formatStr = '%s %s %d %d %n\n %n %n %n %n %n %n %n %n\n %n %n %n %n %n %n';
C = textscan(fid, formatStr, 'commentstyle', '#');
fclose(fid);
% how many entries?
numEntries = size(C{1,1}(:),1);

% t = C{1,1}{1}
% whos('t')

% move to library
for j=1:numEntries
    entry = handles.library_default;
    %entry.file = filename;
    %entry.dir = pathname;
    entry.elt = strrep(C{1,1}{j}, '''', '');
    entry.lat = strrep(C{1,2}{j}, '''', '');
    for i=3:length(handles.library_field_label)
        library_field = handles.library_field_label{i};
        entry.(library_field) = C{1,i}(j);
        % display(sprintf('%s = %g', library_field, C{1,i}(j)) )
    end
    % entry
    library{end+1} = entry;
end



function MEAM_Library_Redisplay(handles, meam_data)
% display library associated with dataset on focus

if isempty(meam_data) || ~isfield(meam_data, 'library')
    Library_Entry_Redisplay(handles, [], 0)
    set(handles.Library_Entry_Select, ...
        'String', ' ', ...
        'Value', 1, ...
        'UIContextMenu', [], ...
        'ToolTipString', '' )
    return
end

% collect elements in library
nloaded = length(meam_data.library);
dsList = cell(nloaded,1);
for idx=1:nloaded
    dsList{idx} = [num2str(idx) ') ' meam_data.library{idx}.elt];
end

% the MEAM elements string
numelt = length(meam_data.MEAM_elements);
focus = meam_data.library_entry_on_focus;
eltstring = MEAM_Elements_String(meam_data);

for i=1:length(handles.library_gui_field)
    gui_field_name = handles.library_gui_field{i};
    if isempty(gui_field_name), continue, end
    if ~isfield(handles, gui_field_name), continue, end
    library_field = handles.library_field_label{i};
    if isempty(library_field), continue, end
    value = meam_data.library{focus}.(library_field);
    if ischar(value)
        tstr = value;
    else
        tstr = num2str(value, '%g');
    end
    set(handles.(gui_field_name), 'String', tstr)
    %display(sprintf('%s = %s', gui_field_name, tstr) )
end

% context menus 
cmenu = uicontextmenu; % for element on focus/alloy

if numelt>=1
    displayStr{1} = ['Element list is ' eltstring];
else
    displayStr{1} = get(handles.File_Library_Load, 'Label');
    displayStr{2} = 'No MEAM elements selected yet.';
end
displayStr{end+1} = 'Left-click popup to select another library entry.';

ind = find(meam_data.MEAM_elements==focus, 1);
if isempty(ind) % not selected as MEAM element
    uimenu(cmenu, ...
        'Label', ['Add ' meam_data.library{focus}.elt ' as MEAM element'], ...
        'Callback', {@MEAM_Element_Add, focus});
    displayStr{end+1} = ['Right-click then "Add ' meam_data.library{focus}.elt ' as MEAM element" to add it.'];
else
    uimenu(cmenu, ...
        'Label', ['Delete ' meam_data.library{focus}.elt ' from MEAM elements'], ...
        'Callback', {@MEAM_Element_Delete, focus});
    displayStr{end+1} = ['Right-click then "Delete ' meam_data.library{focus}.elt ' from MEAM elements" to delete it.'];
end

if numelt>0
    displayStr{end+1} = ['Right-click then "Fix element(s) ..." to use ' eltstring];
    uimenu(cmenu, 'Separator', 'On', ...
        'Label', ['Fix element(s) to ' eltstring], ...
        'Callback', {@Elements_Fix, meam_data.MEAM_elements});
end
tip = 'Right-click for additional actions, if any.';

set(handles.Library_Entry_Select, ...
    'String', dsList, ...
    'Value', focus, ...
    'UIContextMenu', cmenu, ...
    'ToolTipString', tip)

set(handles.text_Display, 'String', sprintf('%s\n', displayStr{:}) )



function MPC_Toggle_Menus(handles)
% toggle menus

% LAMMPS work directory selected ?
if isempty(get(handles.File_LAMMPS_WorkDirectory_Select, 'UserData'))
    set([ ...
        handles.File_Restart_Write, ...
        handles.File_Library_Parameter_Write, ...
        handles.File_Library_Load, ...
        handles.File_Parameters_Load, ...
        handles.Parameter_Entries_Select, ...
        handles.Run_calculations_Selected, ...
        handles.Run_calculations_Similar, ...
        handles.Run_calculations_Included, ...
        handles.Calibration_Run, ...
        ], ...
        'Enable', 'Off')
    Plot_Control_Enable('Off')    
    return
end


set([ ...
    handles.File_Library_Load, ...
    ], 'Enable', 'On')

% library loaded ?
meam_data = get(handles.File_Library_Load, 'UserData');
if isempty(meam_data)
     Plot_Control_Enable('Off')    
   return
end

set([ ...
    handles.Library_Entry_Select, ...
    ], 'Enable', 'On')

% list of elements fixed?
if ~meam_data.library_is_fixed
    set([ ...
        handles.File_Restart_Write, ...
        handles.File_Library_Parameter_Write, ...
        handles.File_Parameters_Load, ...
        handles.Parameter_Entries_Select, ...
        handles.Run_calculations_Selected, ...
        handles.Run_calculations_Similar, ...
        handles.Run_calculations_Included, ...
        ], 'Enable', 'Off')
    set([ ...
        handles.File_Parameters_Load, ...
        ], 'Label', 'MEAM parameter file')
    Plot_Control_Enable('Off')
    return
end

set([ ...
    handles.File_Parameters_Load, ...
    ], 'Enable', 'On')

if isempty(get(handles.label_Parameters, 'UserData'))
     Plot_Control_Enable('Off')    
   return
end

set([ ...
    handles.File_Restart_Write, ...
    handles.Parameter_Entries_Select, ...
    handles.File_Library_Parameter_Write, ...
    handles.Run_calculations_Selected, ...
    handles.Run_calculations_Similar, ...
    handles.Run_calculations_Included, ...
    ], 'Enable', 'On')


% calibration targets and parameters set?
if isempty(handles.calibration_parameter) || isempty(handles.calibration_target)
    set([ ...
        handles.Calibration_Run, ...
        ], 'Enable', 'Off')
else
    set([ ...
        handles.Calibration_Run, ...
        ], 'Visible', 'On', 'Enable', 'On')
end



function Parameter_Indexed_Add(hObject, event, keyword, choices)
% add a parameter

display(sprintf('Parameter_Indexed_Add( %s(*), %s )', keyword, choices) )
handles = guidata(hObject);

% MEAM_Object = get(handles.label_Library, 'UserData');
% choices = '';
% for i=MEAM_Object{objectIdx,1}
%     choices = sprintf('%s; %d=%s', choices, i, MEAM_Object{i,2});
% end
% choices = choices(3:end);

gui_tag = ['param_' keyword];
options.Resize = 'on';
options.WindowStyle = 'normal';
options.Interpreter = 'none';
numlines = 1;
name = ['Add ' keyword];

switch keyword

    case {'Cmax', 'Cmin'} % (I,J,K)
        [~, ~, value] = Parameter_String_Parse(handles.parameter_default.(keyword));
        prompt = {sprintf('%s\nFor I, J, K index, use: %s\n\n%s', handles.description.(gui_tag), choices, keyword); ...
            'I index'; 'J index'; 'K index'};
        defaultanswer = {num2str(value); ''; ''; ''};
        name = ['Add ' keyword '(I,J,K)'];
        
    case {'lattce'}
        [~, ~, value] = Parameter_String_Parse(handles.parameter_default.(keyword));
        prompt = {sprintf('%s\nFor I, J index, use: %s\n\n%s', handles.description.(gui_tag), choices, keyword); ...
            'I index'; 'J index'};
        defaultanswer = {value; ''; ''};
        name = ['Add ' keyword '(I,J)'];
        
    case {'Ec','delta','alpha','re','nn2','attrac','repuls','zbl'}
        [~, ~, value] = Parameter_String_Parse(handles.parameter_default.(keyword));
        prompt = {sprintf('%s\nFor I, J index, use: %s\n\n%s', handles.description.(gui_tag), choices, keyword); ...
            'I index'; 'J index'};
        defaultanswer = {num2str(value); ''; ''};
        name = ['Add ' keyword '(I,J)'];

    case 'rho0'
        [~, ~, value] = Parameter_String_Parse(handles.parameter_default.(keyword));
        prompt = {sprintf('%s\nFor I index, use: %s\n\n%s', handles.description.(gui_tag), choices, keyword); ...
            'I index'};
        defaultanswer = {num2str(value); ''};
        name = ['Add ' keyword '(I)'];

end

answer = inputdlg(prompt, name, numlines, defaultanswer, options);
if isempty(answer), return, end % Cancelled

% the index
idx = str2double(answer(2:end))';
% whos('idx')
if any(isnan(idx))
    msgbox('An index is not a number.', 'Add parameter', 'error', 'modal')
    return
end

% the value
if strcmpi(keyword, 'lattce')
    value = answer{1};
    if ~any(strcmpi(value, {'''dia''','''fcc''','''bcc''', ...
            '''dim''','''b1''','''hcp''','''c11''','''l12''','''b2'''}))
        msgbox(['Invalid lattice code "' value '" - not single quoted?'], ...
            'Add parameter', 'error', 'modal')
        return
    end
else
    [value, status] = str2num(answer{1});
    if ~status
        msgbox(['"' answer(1) '" is not a valid number.'], ...
            'Add parameter', 'error', 'modal')
        return
    end
end

% add entry to parameter file
parameterEntry = get(handles.label_Parameters, 'UserData');
parameterEntry{end+1} = {keyword, {idx}, value};
set(handles.label_Parameters, 'UserData', parameterEntry)


Calculations_Reset(handles)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, event, handles)



function Parameter_Indexed_Delete(hObject, event, keyword)
% delete a parameter

handles = guidata(hObject);

gui_tag = ['param_' keyword];
displayStr = get(handles.(gui_tag), 'String');
valueIndex = get(handles.(gui_tag), 'Value');
[~, idx, value] = Parameter_String_Parse(displayStr{valueIndex});
% whos('tKeyword', 'idx', 'value')
display(sprintf('Parameter_Indexed_Delete( %s = %g)', keyword, value) )

choice = questdlg({handles.description.(gui_tag); ''; ...
    ['Delete ' displayStr{valueIndex} '?']}, ...
    ['Delete ' keyword], 'Yes','No','Cancel','No');
if ~strcmpi(choice, 'Yes'), return, end

% find entry in parameter file
parameterEntry = get(handles.label_Parameters, 'UserData');
for i=1:length(parameterEntry)

    % find matching keyword
    tKeyword = parameterEntry{i}{1};
    tKeyword = strtrim(tKeyword);
    if ~strcmp(keyword, tKeyword), continue, end
    
    % find matching index
    tIdx = parameterEntry{i}{2};
    % whos('tIdx')
    if numel(tIdx{1})~=numel(idx{1}), continue, end
    if any(reshape(tIdx{1},size(idx{1}))~=idx{1}), continue, end
    % if any(tIdx{1}~=idx{1}'), continue, end
    
    % erase entry
    parameterEntry(i) = [];
    break;
end

set(handles.label_Parameters, 'UserData', parameterEntry)

Calculations_Reset(handles)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, event, handles)



function Parameter_Indexed_Edit(hObject, event, keyword, choices)
% edit a parameter

handles = guidata(hObject);

gui_tag = ['param_' keyword];
displayStr = get(handles.(gui_tag), 'String');
valueIndex = get(handles.(gui_tag), 'Value');
[tKeyword, idx, value] = Parameter_String_Parse(displayStr{valueIndex});
% whos('tKeyword', 'idx', 'value')
display(sprintf('Parameter_Indexed_Edit( %s(*) = %g), %s', keyword, value, choices) )

parameterEntry = get(handles.label_Parameters, 'UserData');

prompt = sprintf('%s\n%s\n\nChange %s to:', handles.description.(gui_tag), ...
    ['Index(es): ' choices], displayStr{valueIndex});
name = ['Edit ' tKeyword];
numlines = 1;
if ischar(value)
    defaultanswer = {value};
elseif isinteger(value)
    defaultanswer = {sprintf('%d', value)};
else
    defaultanswer = {sprintf('%f', value)};
end
options.Resize = 'on';
options.WindowStyle = 'normal';
options.Interpreter = 'none';

answer = inputdlg(prompt, name, numlines, defaultanswer, options);
if isempty(answer), return, end % Cancelled

if ischar(value)
    newValue = answer{1};
else
    newValue = str2double(answer{1});
    if isnan(newValue), newValue = value; end
end

% find entry in parameter file
for i=1:length(parameterEntry)
    
    % find matching keyword
    tKeyword = parameterEntry{i}{1};
    tKeyword = strtrim(tKeyword);
    if ~strcmp(keyword, tKeyword), continue, end
    
    % find matching indices
    tIdx = parameterEntry{i}{2};
    % whos('tIdx')
    if numel(tIdx{1})~=numel(idx{1}), continue, end
    if any(reshape(tIdx{1},size(idx{1}))~=idx{1}), continue, end
    % if any(tIdx{1}~=idx{1}), continue, end

    % assign value from display
    parameterEntry{i}{3} = newValue;
    break;
end

set(handles.label_Parameters, 'UserData', parameterEntry)

Calculations_Reset(handles)

% display edited value
set(handles.(['param_' keyword]), 'Value', valueIndex)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, event, handles)


function [keyword, idx, value] = Parameter_String_Parse(tline)
% parse an entry from a parameter file

keyword = '';
idx = [];
value = [];
if isempty(tline) || strncmp(tline, '#', 1) % empty/comment line
    return
end

[tag, remain] = strtok(tline, '='); % get tag & remainder of line
remain = strrep(remain, '=', ' '); % remove '='
tval = str2double(remain);
if isnan(tval)
    value = strtrim(remain);
else
    lpar =  strfind(remain, '.');
    if isempty(lpar) % integer
        value = int16(tval);
    else % double
        value = tval;
    end
end
% whos('value')
lpar =  strfind(tag, '(');
if isempty(lpar) % keyword = value
    keyword = tag;
    idx = {[]};
else % keyword(index) = value
    keyword = tag(1:lpar-1);
    rpar =  strfind(tag, ')');
    idx = textscan(tag(lpar+1:rpar-1), '%n,');
end
keyword = strtrim(keyword);
% tline, keyword, idx, value
% whos('keyword', 'idx', 'value')




function Plot_Options(handles, MEAM_Object)
% set up popups to select plots

% user specified
checkedObjectSize = findobj('-regexp', 'Tag', '^Plot_Include_', 'Checked', 'on');
checkedPlotResult = findobj('-regexp', 'Tag', '^Plot_Result_', 'Checked', 'on');

if isempty(checkedObjectSize) || isempty(checkedPlotResult)
    results_X = {'(none)'; '(none)'; '(none)'};
    results_Y = {'(none)'; '(none)'; '(none)'};
    stat = 'Off';
else
    stat = 'On';
    % the possibilities for x-axis & y-axis
    results_Y = {'rose_E', 'E1', 'E2', 'E3', ...
        'Evac', 'Einterstitials', ...
        'GSFEs', 'ESurfaces', ...
        'Substitution', 'ISubstitution', 'BindingEnergy', 'E0', 'alpha', 'H', 'Nx', 'C'};
    results_X = {'(default)', 'E0', 'alpha', 'H', 'Nx'};

    % remove possibilities not chosen by user
    found_X = zeros(size(results_X));
    found_Y = zeros(size(results_Y));
    for i=1:length(checkedPlotResult)
        tData = get(checkedPlotResult(i), 'Userdata');
        j = find(strcmpi(results_X, tData{1}), 1);
        if ~isempty(j), found_X(j) = found_X(j)+1; end
        j = find(strcmpi(results_Y, tData{2}), 1);
        if ~isempty(j), found_Y(j) = found_Y(j)+1; end
    end
    results_X = results_X(found_X>0);
    results_Y = results_Y(found_Y>0);
%     display(results_Y')
%     display(results_X')

    % further remove possibilities not calculated yet
    found_X = zeros(size(results_X));
    found_Y = zeros(size(results_Y));

    % look for calculated results
    found_X(1) = 1; % automatically find '(default)'
    for idxObject=1:size(MEAM_Object,1)
        
        runData = MEAM_Object{idxObject,6};       
        if isempty(runData), continue, end

        if isfield(runData, 'SingleElement')
            fieldName = fieldnames(runData.SingleElement);
            for i=1:length(fieldName)
                j = find(strcmpi(results_X, fieldName{i}), 1);
                if ~isempty(j), found_X(j) = found_X(j)+1; end
                j = find(strcmpi(results_Y, fieldName{i}), 1);
                if ~isempty(j), found_Y(j) = found_Y(j)+1; end
            end
        end

        if isfield(runData, 'Alloy')
            fieldName = fieldnames(runData.Alloy);
            for i=1:length(fieldName)
                j = find(strcmpi(results_X, fieldName{i}), 1);
                if ~isempty(j), found_X(j) = found_X(j)+1; end
                j = find(strcmpi(results_Y, fieldName{i}), 1);
                if ~isempty(j), found_Y(j) = found_Y(j)+1; end
            end
        end
        
    end
    results_X = results_X(found_X>0);
    results_Y = results_Y(found_Y>0);
%     display(results_Y')
%     display(results_X')

end

if isempty(results_X) || isempty(results_Y)
    results_X = {'(none)'; '(none)'; '(none)'};
    results_Y = {'(none)'; '(none)'; '(none)'};
    stat = 'Off';
end

% display(results_Y')
% display(results_X')
i = get(handles.Plot_control_selectX, 'Value');
if i>size(results_X,1), i = 1; end
j = get(handles.Plot_control_selectY, 'Value');
if j>size(results_X,1), j = 1; end

set(handles.Plot_control_selectX, 'String', results_X, 'Value', i)
set(handles.Plot_control_selectY, 'String', results_Y, 'Value', j)
Plot_Control_Enable(stat)



function Plot_Control_Enable(stat)
% enable/disable popups to select plots

set(findobj('-regexp', 'Tag', '^Plot_control_'), 'Visible', 'On', 'Enable', stat)





function Text_Display_Alloy(handles, MEAM_Object, idxObject)

% Flag to create template for calibration data
makeTemplate = strcmpi(get(handles.File_Calibration_Data_Template, 'Checked'), 'On');

% numElements = max(MEAM_Object{end,1});
elementIdx = MEAM_Object{idxObject,1};
objType = size(elementIdx,2);
tag = MEAM_Object{idxObject,2};
toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
lattice = MEAM_Object{idxObject,5};
runData = MEAM_Object{idxObject,6};
calibrationData = MEAM_Object{idxObject,7};
angstromStr = char(197);
newTarget = false;

hasParameters = ~isempty(get(handles.label_Parameters, 'UserData'));

displayStr{1} = ['Elements are ' Elements_List(MEAM_Object) ...
    '. Reload a *.library.meam to reselect. The focus is ' tag];

% context menu
cmenuParameters = uicontextmenu; % on PARAMETERS popup
tipParameters = sprintf('%s\n', 'TIP: Right-click PARAMETERS popup for other actions.');

cmenuLibrary = uicontextmenu; % on LIBRARY popup
tipLibrary = sprintf('%s\n', 'Right-click LIBRARY popup for other actions on this alloy.');

% check if the structures of component elements are specified
definedLattices = true;
tmpString = ''; % list of components not specified
for i=elementIdx
    if MEAM_Object{i,5}(1)==0 || MEAM_Object{i,5}(2)==0 || MEAM_Object{i,5}(3)==0
        tmpString = [tmpString ' ' MEAM_Object{i,2}];
        definedLattices = false;
    end
end
if ~definedLattices
    displayStr{end+1} = '=====';
    displayStr{end+1} = ['Structures for (' tmpString ...
        ') NOT completely specified.'];
end


% the calculation flags
if objType>2 % ternary

    % run & plot switches
    if hasParameters && definedLattices
        if toggleRunPlot==1 || toggleRunPlot==3
            checkStatus = 'On';
        else
            checkStatus = 'Off';
        end
        uimenu(cmenuLibrary, ...
            'Separator', 'On', ...
            'Checked', checkStatus, ...
            'Label', ['INCLUDE ' handles.TernaryCalculation{1} ' in RUN CALCULATIONS'], ...
            'Callback', {@Toggle_Flag_RunPlot, idxObject, 'Run'});
        if toggleRunPlot==2 || toggleRunPlot==3
            checkStatus = 'On';
        else
            checkStatus = 'Off';
        end
        uimenu(cmenuLibrary, ...
            'Checked', checkStatus, ...
            'Label', ['INCLUDE ' handles.TernaryCalculation{1} ' in DISPLAY of plots'], ...
            'Callback', {@Toggle_Flag_RunPlot, idxObject, 'Plot'});
    end
    
else % binary
    
    % check the binary lattice(s)
    displayStr{end+1} = ['===== ' tag ' binary lattice(s)'];
    tmpString = '';
    if ~isempty(lattice)
        for i=1:length(lattice)
            tmpString = [tmpString ' ' handles.BLattices{lattice(i)}];
        end
        displayStr{end+1} = tmpString;
    else
        definedLattices = false;
    end
    displayStr{end+1} = 'TIP: Right-click LIBRARY popup to select binary lattice(s)';
    uimenu(cmenuLibrary, ...
        'Label', 'SELECT binary lattice(s)', ...
        'Callback', {@Lattice_Select_Binary, idxObject});
    
    % run & plot switches
    if hasParameters && definedLattices
        if toggleRunPlot==1 || toggleRunPlot==3
            checkStatus = 'On';
        else
            checkStatus = 'Off';
        end
        uimenu(cmenuLibrary, ...
            'Separator', 'On', ...
            'Checked', checkStatus, ...
            'Label', 'INCLUDE in RUN CALCULATIONS', ...
            'Callback', {@Toggle_Flag_RunPlot, idxObject, 'Run'});
        if toggleRunPlot==2 || toggleRunPlot==3
            checkStatus = 'On';
        else
            checkStatus = 'Off';
        end
        uimenu(cmenuLibrary, ...
            'Checked', checkStatus, ...
            'Label', 'INCLUDE in DISPLAY of plots', ...
            'Callback', {@Toggle_Flag_RunPlot, idxObject, 'Plot'});
    end
        
end

% run/plot tip
displayStr{end+1} = 'TIP: Right-click LIBRARY popup to RUN/DISPLAY.'; % , and to select calculations';

displayStr{end+1} = ['===== ' tag ' calculation results'];
if isempty(runData) || ~isfield(runData, 'Alloy')
    displayStr{end+1} = '(None available)';
else
    
    if makeTemplate
        fid = fopen([tag '_Calibration.txt'], 'wt');
        fprintf(fid, '# Elements are %s\n', Elements_List(MEAM_Object));
    end

    if isfield(runData.Alloy, 'BLattices')
        
        for i=1:size(lattice,2)
            for j=1:objType
                for k=1:objType
                    if k>size(runData.Alloy.BLattices,3), continue, end
                    
                    BLattices = runData.Alloy.BLattices{i, j, k};
                    if isempty(BLattices), continue, end
                    displayStr{end+1} = ['--- Results for ' runData.Alloy.BLattices{i, j, k}];
                    latticeName = strrep(BLattices, '-', '_');

                    calculatedValue = runData.Alloy.E0(i, j, k);
                    tLabel = sprintf(' E0 = %g (eV)', calculatedValue);
                    if ~isfield(calibrationData.E0, latticeName)
                        calibrationData.E0.(latticeName) = cell(size(runData.Alloy.E0)); % actual target not yet specified
                        newTarget = true;
                    end
                    targetValue = calibrationData.E0.(latticeName){i,j,k};
                    if ~isempty(targetValue)
                        tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
                    end
                    displayStr{end+1} = tLabel;

                    if makeTemplate
                        fprintf(fid, '\n#\n# %s %s:E0\n#\n', tag, BLattices );
                        fprintf(fid, 'E0, %d, %d, %d, %g\n', i, j, k, calculatedValue );
                    end
                    
                    displayStr{end+1} = sprintf(' box = [%g,%g,%g; %g,%g,%g; %g,%g,%g] (%s)', ...
                        runData.Alloy.box{i, j, k}', angstromStr);
                    
                    dimArray = size(runData.Alloy.E1);
                    [~, locResultMin] = min( runData.Alloy.E1(:, i, j, k) );
                    tLabel = sprintf(' [E1,a1] = %g pts (eV vs %s); min = (%g, %g)', ...
                        dimArray(1), angstromStr, ...
                        runData.Alloy.E1(locResultMin, i, j, k), runData.Alloy.a1(locResultMin, i, j, k) );
                    if ~isfield(calibrationData.E1, latticeName)
                        calibrationData.E1.(latticeName) = cell(dimArray(2),dimArray(3),dimArray(4)); 
                        for ii=1:dimArray(2)
                            for jj=1:dimArray(3)
                                for kk=1:dimArray(4)
                                    calibrationData.E1.(latticeName){ii,jj,kk}.file = '';
                                    calibrationData.E1.(latticeName){ii,jj,kk}.xdata = [];
                                    calibrationData.E1.(latticeName){ii,jj,kk}.ydata = [];
                                end
                            end
                        end
                        newTarget = true;
                    end
                    if ~isempty(calibrationData.E1.(latticeName){i,j,k}.ydata)
                        [~, locTargetMin] = min(calibrationData.E1.(latticeName){i,j,k}.ydata);
                        tLabel = sprintf('%s, dist = %.2e', tLabel, sqrt( ...
                            (runData.Alloy.E1(locResultMin,i,j,k)-calibrationData.E1.(latticeName){i,j,k}.ydata(locTargetMin))^2 + ...
                            (runData.Alloy.a1(locResultMin,i,j,k)-calibrationData.E1.(latticeName){i,j,k}.xdata(locTargetMin))^2 ) );
                    end        
                    displayStr{end+1} = tLabel;

                    if makeTemplate
                        fprintf(fid, '\n#\n# %s %s:E1\n#\n', tag, BLattices );
                        fprintf(fid, 'E1, %d, %d, %d, %d\n', i, j, k, ceil((dimArray(1)-2)/2) );
                        fprintf(fid, '%g, %g\n', [runData.Alloy.a1(2:2:end-1, i, j, k), runData.Alloy.E1(2:2:end-1, i, j, k)]');
                    end
                    
                    calculatedValue = runData.Alloy.H(i, j, k);
                    tLabel = sprintf(' H = %g (eV)', calculatedValue);
                    if ~isfield(calibrationData.H, latticeName)
                        calibrationData.H.(latticeName) = cell(size(runData.Alloy.H)); % actual target not yet specified
                        newTarget = true;
                    end
                    targetValue = calibrationData.H.(latticeName){i,j,k};
                    if ~isempty(targetValue)
                        tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
                    end
                    displayStr{end+1} = tLabel;
                    
                    if makeTemplate
                        fprintf(fid, '\n#\n# %s %s:H\n#\n', tag, BLattices );
                        fprintf(fid, 'H, %d, %d, %d, %g\n', i, j, k, calculatedValue );
                    end
                    
                    calculatedValue = runData.Alloy.Nx(i, j, k);
                    tLabel = sprintf(' Nx = %g', calculatedValue);
                    if ~isfield(calibrationData.Nx, latticeName)
                        calibrationData.Nx.(latticeName) = cell(size(runData.Alloy.Nx)); % actual target not yet specified
                        newTarget = true;
                    end
                    targetValue = calibrationData.Nx.(latticeName){i,j,k};
                    if ~isempty(targetValue)
                        tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
                    end
                    displayStr{end+1} = tLabel;
                    
                    if makeTemplate
                        fprintf(fid, '\n#\n# %s %s:Nx\n#\n', tag, BLattices );
                        fprintf(fid, 'Nx, %d, %d, %d, %g\n', i, j, k, calculatedValue );
                    end

                    if isfield(runData.Alloy, 'C')
                        dimArray = size(runData.Alloy.C);
                        if ~isfield(calibrationData.C, latticeName)
                            calibrationData.C.(latticeName) = cell(dimArray(3),dimArray(4),dimArray(5)); % actual target not yet specified
                            for ii=1:dimArray(3)
                                for jj=1:dimArray(4)
                                    for kk=1:dimArray(5)
                                        calibrationData.C.(latticeName){ii,jj,kk} = cell(6,6);
                                    end
                                end
                            end
                            newTarget = true;
                        end
                        
                        C = runData.Alloy.C(:,:,i,j,k);
                        [r,c] = find(C);
                        for l=1:length(r)
                            calculatedValue = C(r(l),c(l));
                            tLabel = sprintf(' C%d%d = %g (GPa)', r(l),c(l), calculatedValue);
                            targetValue = calibrationData.C.(latticeName){i,j,k}{r(l),c(l)};
                            if ~isempty(targetValue)
                                tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
                            end
                            displayStr{end+1} = tLabel;
                            
                            if makeTemplate
                                fprintf(fid, '\n#\n# %s %s:C%d%d\n#\n', tag, BLattices, r(l), c(l) );
                                fprintf(fid, 'C, %d, %d, %d, %d, %d, %g\n', i, j, k, r(l), c(l), calculatedValue );
                            end

                        end
                    end
                end
            end
        end
    end

    if objType==2
        % Substitution energy
        if isfield(runData.Alloy, 'SubsLabel') || isfield(runData.Alloy, 'ISubsLabel')
            for j=1:objType
                for k=1:objType
                    
                    if isfield(runData.Alloy, 'SubsLabel') && ~isempty(runData.Alloy.SubsLabel{j,k})
                        calculatedValue = runData.Alloy.Substitution(j,k);
                        tLabel = sprintf(' %s = %g (mJ/m^2)', ...
                            runData.Alloy.SubsLabel{j,k}, calculatedValue);
                        targetValue = calibrationData.Substitution{j,k};
                        if ~isempty(targetValue)
                            tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
                        end
                        displayStr{end+1} = tLabel;

                        if makeTemplate
                            fprintf(fid, '\n#\n# %s %s\n#\n', tag, runData.Alloy.SubsLabel{j,k} );
                            fprintf(fid, 'Substitution, %d, %d, %g\n', j, k, calculatedValue );
                        end
                    end
                    
                    if isfield(runData.Alloy, 'ISubsLabel') && ~isempty(runData.Alloy.ISubsLabel{j,k})
                        calculatedValue = runData.Alloy.ISubstitution(j,k);
                        tLabel = sprintf(' %s = %g (mJ/m^2)', ...
                            runData.Alloy.ISubsLabel{j,k}, calculatedValue);
                        targetValue = calibrationData.ISubstitution{j,k};
                        if ~isempty(targetValue)
                            tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
                        end
                        displayStr{end+1} = tLabel;

                        if makeTemplate
                            fprintf(fid, '\n#\n# %s %s\n#\n', tag, runData.Alloy.ISubsLabel{j,k} );
                            fprintf(fid, 'ISubstitution, %d, %d, %g\n', j, k, calculatedValue );
                        end
                    end
                end
            end
        end
    end
    
    % Ternaries only - Binding energy
    if isfield(runData.Alloy, 'BindingLabel')
        if isfield(runData.Alloy, 'BLattices')
            displayStr{end+1} = '=====';
        end
        for i=1:objType
            for j=1:objType
                for k=1:objType
                    
                    if ~isempty(runData.Alloy.BindingLabel{i,j,k})
                        calculatedValue = runData.Alloy.BindingEnergy(i,j,k);
                        tLabel = sprintf(' %s = %g (mJ/m^2)', ...
                            runData.Alloy.BindingLabel{i,j,k}, calculatedValue );
                        targetValue = calibrationData.BindingEnergy{i,j,k};
                        if ~isempty(targetValue)
                            tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
                        end
                        displayStr{end+1} = tLabel;

                        if makeTemplate
                            fprintf(fid, '\n#\n# %s %s\n#\n', tag, runData.Alloy.BindingLabel{i,j,k} );
                            fprintf(fid, 'BindingEnergy, %d, %d, %d, %g\n', i, j, k, calculatedValue );
                        end
                    
                    end
                end
            end
        end
    end
    
    if makeTemplate
        fclose(fid);
    end

end


hasTarget = false;
targetList = {};
idxTarget = 0;
displayStr{end+1} = ['===== ' tag ' calibration data'];
uimenu(cmenuParameters, ...
    'Label', 'LOAD calibration data from file', ...
    'Callback', {@Calibration_Data_From_File, idxObject})
% uimenu(cmenuParameters, ...
%     'Label', 'Or, SPECIFY calibration data')

if ~isempty(runData) && isfield(runData, 'Alloy') && isfield(runData.Alloy, 'BLattices')

    for i=1:size(lattice,2)
        for j=1:objType
            for k=1:objType
                if k>size(runData.Alloy.BLattices,3), continue, end

                BLattices = runData.Alloy.BLattices{i, j, k};
                if isempty(BLattices), continue, end
                displayStr{end+1} = ['--- Calibration data for binary: ' runData.Alloy.BLattices{i, j, k}];
                latticeName = strrep(BLattices, '-', '_');

                if ~isempty(calibrationData.E0.(latticeName){i,j,k})
                    hasTarget = true;
                    checkStatus = 'On';
                    tLabel = sprintf('%s: E0 = %g', BLattices, calibrationData.E0.(latticeName){i,j,k});
                    idxTarget = idxTarget + 1;
                    targetList{idxTarget} = {idxObject, 'E0', i, j, k, 'Scalar', 'E0', latticeName, 0, 0};
                    if Calibration_Target_Find(handles, targetList{idxTarget})
                        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
                    else
                        targetStatus = '';
                    end
                    displayStr{end+1} = [tLabel targetStatus];
                else
                    checkStatus = 'Off';
                    tLabel = [BLattices ': E0'];
                end
                uimenu(cmenuParameters, 'Separator', 'On', 'Checked', checkStatus, ...
                    'Label', tLabel, ...
                    'Callback', {@Calibration_Data_Single_Value, idxObject, 'E0', i, j, k, latticeName, 0, 0});

                
                if ~isempty(calibrationData.E1.(latticeName){i,j,k}.ydata)
                    hasTarget = true;
                    checkStatus = 'On';
                    [~, locTargetMin] = min(calibrationData.E1.(latticeName){i,j,k}.ydata);
                    tLabel = sprintf('%s: [E1,a1] = %s, %g pts, min@%d = (%g, %g)', BLattices, ...
                        calibrationData.E1.(latticeName){i,j,k}.file, length(calibrationData.E1.(latticeName){i,j,k}.xdata), ...
                        locTargetMin, ...
                        calibrationData.E1.(latticeName){i,j,k}.ydata(locTargetMin), calibrationData.E1.(latticeName){i,j,k}.xdata(locTargetMin));
                    targetStatus = '';
                    idxTarget = idxTarget + 1;
                    targetList{idxTarget} = {idxObject, 'E1', i, j, k, 'Curve', '[E1,a1]', latticeName, 0, 0};
                    if Calibration_Target_Find(handles, targetList{idxTarget})
                        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
                    end
                    displayStr{end+1} = [tLabel targetStatus];
                else
                    checkStatus = 'Off';
                    tLabel = [BLattices ': E1'];
                end
                uimenu(cmenuParameters, 'Checked', checkStatus, ...
                    'Label', tLabel, ...
                    'Callback', {@Calibration_Data_Curve, idxObject, 'E1', i, j, k, latticeName});

                
                if ~isempty(calibrationData.H.(latticeName){i,j,k})
                    hasTarget = true;
                    checkStatus = 'On';
                    tLabel = sprintf('%s: H = %g', BLattices, calibrationData.H.(latticeName){i,j,k});
                    idxTarget = idxTarget + 1;
                    targetList{idxTarget} = {idxObject, 'H', i, j, k, 'Scalar', 'H', latticeName, 0, 0};
                    if Calibration_Target_Find(handles, targetList{idxTarget})
                        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
                    else
                        targetStatus = '';
                    end
                    displayStr{end+1} = [tLabel targetStatus];
                else
                    checkStatus = 'Off';
                    tLabel = [BLattices ': H'];
                end
                uimenu(cmenuParameters, 'Separator', 'Off', 'Checked', checkStatus, ...
                    'Label', tLabel, ...
                    'Callback', {@Calibration_Data_Single_Value, idxObject, 'H', i, j, k, latticeName, 0, 0});
                
                
                if ~isempty(calibrationData.Nx.(latticeName){i,j,k})
                    hasTarget = true;
                    checkStatus = 'On';
                    tLabel = sprintf('%s: Nx = %g', BLattices, calibrationData.Nx.(latticeName){i,j,k});
                    idxTarget = idxTarget + 1;
                    targetList{idxTarget} = {idxObject, 'Nx', i, j, k, 'Scalar', 'Nx', latticeName, 0, 0};
                    if Calibration_Target_Find(handles, targetList{idxTarget})
                        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
                    else
                        targetStatus = '';
                    end
                    displayStr{end+1} = [tLabel targetStatus];
                else
                    checkStatus = 'Off';
                    tLabel = [BLattices ': Nx'];
                end
                uimenu(cmenuParameters, 'Separator', 'Off', 'Checked', checkStatus, ...
                    'Label', tLabel, ...
                    'Callback', {@Calibration_Data_Single_Value, idxObject, 'Nx', i, j, k, latticeName, 0, 0});
                

                if ~isempty(runData) && isfield(runData, 'Alloy') && isfield(runData.Alloy, 'C')
                    C = runData.Alloy.C(:,:,i,j,k);
                    [r,c] = find(C);
                    for l=1:length(r)
                        if ~isempty(calibrationData.C.(latticeName){i,j,k}{r(l),c(l)})
                            hasTarget = true;
                            checkStatus = 'On';
                            targetVal = calibrationData.C.(latticeName){i,j,k}{r(l),c(l)};
                            tLabel = sprintf('%s: C%d%d = %g', BLattices, r(l),c(l), targetVal );
                            if r(l)==1 && c(l)==2
                                targetVal = (calibrationData.C.(latticeName){i,j,k}{1,1}-calibrationData.C.(latticeName){i,j,k}{1,2})/2;
                                displayStr{end+1} = sprintf(' (C11 - C12)/2 = %g', targetVal );
                            end
                            idxTarget = idxTarget + 1;
                            targetList{idxTarget} = {idxObject, 'C', i, j, k, 'Scalar', sprintf('C%d%d', r(l),c(l)), latticeName, r(l), c(l)};
                            if Calibration_Target_Find(handles, targetList{idxTarget})
                                targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
                            else
                                targetStatus = '';
                            end
                            displayStr{end+1} = [tLabel targetStatus];
                        else
                            checkStatus = 'Off';
                            tLabel = sprintf('%s: C%d%d', BLattices, r(l),c(l) );
                        end
                        uimenu(cmenuParameters, 'Checked', checkStatus, ...
                            'Label', tLabel, ...
                            'Callback', {@Calibration_Data_Single_Value, idxObject, 'C', i, j, k, latticeName, r(l), c(l)});
                        % 'Callback', {@Calibration_Data_Elastic_Tensor, idxObject, r(l), c(l)});
                    end
                    uimenu(cmenuParameters, 'Checked', 'Off', ...
                        'Label', [BLattices ': LOAD CXX calibration data from file'], ...
                        'Callback', {@Calibration_Data_Elastic_Tensor, idxObject, r, c});
                end
                
            end
        end
    end
end

% Substitution energy
if ~isempty(runData) && isfield(runData, 'Alloy') && objType==2 && ...
        ( isfield(runData.Alloy, 'SubsLabel') || isfield(runData.Alloy, 'ISubsLabel') )
    l = 0;
    for j=1:objType
        for k=1:objType
            
            tLabel = runData.Alloy.SubsLabel{j,k};
            if ~isempty(tLabel)
                targetValue = calibrationData.Substitution{j,k};
                if ~isempty(targetValue)
                    hasTarget = true;
                    checkStatus = 'On';
                    tLabel = sprintf('%s = %g', tLabel, targetValue);
                    idxTarget = idxTarget + 1;
                    targetList{idxTarget} = {idxObject, 'Substitution', j, k, 0, 'Scalar', runData.Alloy.SubsLabel{j,k}, '', 0, 0};
                    if Calibration_Target_Find(handles, targetList{idxTarget})
                        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
                    else
                        targetStatus = '';
                    end
                    displayStr{end+1} = [tLabel targetStatus];
                else
                    checkStatus = 'Off';
                end
                l = l + 1;
                if isfield(runData.Alloy, 'BLattices') && l==1
                    separatorStatus = 'On';
                else
                    separatorStatus = 'Off';
                end
                uimenu(cmenuParameters, 'Separator', separatorStatus, 'Checked', checkStatus, ...
                    'Label', tLabel, ...
                    'Callback', {@Calibration_Data_Single_Value, idxObject, 'Substitution', j, k, 0, '', 0, 0});
            end
            
            tLabel = runData.Alloy.ISubsLabel{j,k};
            if ~isempty(tLabel)
                targetValue = calibrationData.ISubstitution{j,k};
                if ~isempty(targetValue)
                    hasTarget = true;
                    checkStatus = 'On';
                    tLabel = sprintf('%s = %g', tLabel, targetValue);
                    idxTarget = idxTarget + 1;
                    targetList{idxTarget} = {idxObject, 'ISubstitution', j, k, 0, 'Scalar', runData.Alloy.ISubsLabel{j,k}, '', 0, 0};
                    if Calibration_Target_Find(handles, targetList{idxTarget})
                        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
                    else
                        targetStatus = '';
                    end
                    displayStr{end+1} = [tLabel targetStatus];
                else
                    checkStatus = 'Off';
                end
                l = l + 1;
                if isfield(runData.Alloy, 'BLattices') && l==1
                    separatorStatus = 'On';
                else
                    separatorStatus = 'Off';
                end
                uimenu(cmenuParameters, 'Separator', separatorStatus, 'Checked', checkStatus, ...
                    'Label', tLabel, ...
                    'Callback', {@Calibration_Data_Single_Value, idxObject, 'ISubstitution', j, k, 0, '', 0, 0});
            end
            
        end
    end
end


% Binding energy
if ~isempty(runData) && isfield(runData, 'Alloy') && isfield(runData.Alloy, 'BindingEnergy')
    
    l = 0;
    for i=1:objType
        for j=1:objType
            for k=1:objType
                
                if isempty(runData.Alloy.BindingLabel{i,j,k}), continue, end
                l = l + 1;
                
                if ~isempty(calibrationData.BindingEnergy{i,j,k})
                    hasTarget = true;
                    checkStatus = 'On';
                    tLabel = sprintf(' %s = %g', runData.Alloy.BindingLabel{i,j,k}, calibrationData.BindingEnergy{i,j,k});
                    idxTarget = idxTarget + 1;
                    targetList{idxTarget} = {idxObject, 'BindingEnergy', i, j, k, 'Scalar', runData.Alloy.BindingLabel{i,j,k}, '', 0, 0};
                    if Calibration_Target_Find(handles, targetList{idxTarget})
                        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
                    else
                        targetStatus = '';
                    end
                    displayStr{end+1} = [tLabel targetStatus];
                else
                    checkStatus = 'Off';
                    tLabel = [' ' runData.Alloy.BindingLabel{i,j,k}];
                end
                if l>1
                    separatorStatus = 'Off';
                else
                    separatorStatus = 'On';
                end
                uimenu(cmenuParameters, 'Separator', separatorStatus, 'Checked', checkStatus, ...
                    'Label', tLabel, ...
                    'Callback', {@Calibration_Data_Single_Value, idxObject, 'BindingEnergy', i, j, k, '', 0, 0});
                
                
            end
        end
    end
end

if newTarget
    MEAM_Object{idxObject,7} = calibrationData;
    set(handles.label_Library, 'UserData', MEAM_Object)
end

if ~hasTarget
    displayStr{end+1} = '(None specified)';

else % context menu to select calibration targets
    uimenu(cmenuParameters, 'Separator', 'On', ...
        'Label', 'SELECT calibration target(s)');
    
    for idxTarget=1:length(targetList)
        if idxTarget==1
            separatorStatus = 'On';
        else
            separatorStatus = 'Off';
        end        
        varName = targetList{idxTarget}{2};
        if isempty(targetList{idxTarget}{8})
            targetType = targetList{idxTarget}{6};
        else
            targetType = [targetList{idxTarget}{6} ' - ' strrep(targetList{idxTarget}{8}, '_', '-')];
        end
        if isfield(calibrationData, varName) && ~isempty(calibrationData.(varName))
            if Calibration_Target_Find(handles, targetList{idxTarget})
                checkStatus = 'On';
            else
                checkStatus = 'Off';
            end
            uimenu(cmenuParameters, 'Separator', separatorStatus, ...
                'Checked', checkStatus, ...
                'Label', [targetType ': ' targetList{idxTarget}{7}], ...
                'Callback', {@Calibration_Target_Toggle, targetList{idxTarget}});
        end
    end
    uimenu(cmenuParameters, 'Separator', 'On', ...
        'Checked', 'Off', ...
        'Label', ['CLEAR calibration targets for ' tag], ...
        'Callback', {@Calibration_Target_Clear, idxObject});
    
end


set(handles.Library_Entry_Select, ...
    'UIContextMenu', cmenuLibrary, ...
    'ToolTipString', tipLibrary) 

set(handles.Parameter_Entries_Select, 'Enable', 'On', ...
    'UIContextMenu', cmenuParameters, ...
    'ToolTipString', tipParameters)

set(handles.text_Display, 'String', displayStr )


function Text_Display_Element(handles, MEAM_Object, idxObject)
% update text display box for a single element

% Flag to create template for calibration data
makeTemplate = strcmpi(get(handles.File_Calibration_Data_Template, 'Checked'), 'On');

% numElements = max(MEAM_Object{end,1});
% elementIdx = MEAM_Object{idxObject,1};
% objSize = size(elementIdx,2);
tag = MEAM_Object{idxObject,2};
toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
lattice = MEAM_Object{idxObject,5};
runData = MEAM_Object{idxObject,6};
calibrationData = MEAM_Object{idxObject,7};
angstromStr = char(197);
newTarget = false;

element_list = Elements_List(MEAM_Object);

hasParameters = ~isempty(get(handles.label_Parameters, 'UserData') );

displayStr{1} = ['Element list: ' element_list '. Focus is ' tag];
displayStr{end+1} = 'TIP: Reload a *.library.meam to reselect list.';

% context menus 
cmenuParameters = uicontextmenu; % on PARAMETERS popup
tipParameters = sprintf('%s\n', 'TIP: Right-click PARAMETERS popup for other actions.');

cmenuLibrary = uicontextmenu; % on LIBRARY popup
tipLibrary = sprintf('%s\n', 'TIP: Right-click LIBRARY popup for other actions.');

if ~hasParameters
    displayStr{end+1} = '===== Parameter file';
    displayStr{end+1} = ['TIP: Click menu "File | Load MEAM parameter file" to load a parameter file for ' ...
        element_list];
end

% the structures
displayStr{end+1} = ['===== ' tag ' structures'];
definedLattices = true;
tLabel = {'Primary - ?', 'Secondary 1 - ?', 'Secondary 2 - ?'};
for i=1:3
    
    latticeIndex = lattice(i);
    if latticeIndex~=0
        label = [tag handles.structName{i} 'is ' handles.lattices{latticeIndex}];
        checkStatus = 'On';
        switch i
            case 1
                tLabel{i} = ['Primary - ' handles.lattices{latticeIndex}];
            case 2
                tLabel{i} = ['Secondary 1 - ' handles.lattices{latticeIndex}];
            case 3
                tLabel{i} = ['Secondary 2 - ' handles.lattices{latticeIndex}];
        end
        
    else
        label = [tag handles.structName{i} 'is not specified'];
        definedLattices = false;
        checkStatus = 'Off';
    end
    % displayStr{end+1} = label;
    uimenu(cmenuLibrary, ... 
        'Checked', checkStatus, ...
        'Label', label, ...
        'Callback', {@Lattice_Select_SingleElement, idxObject, i});

end
displayStr{end+1} = [tLabel{1} '; ' tLabel{2} '; ' tLabel{3}];
if definedLattices
    displayStr{end+1} = 'TIP: Right-click LIBRARY popup to reselect structures.';
else
    displayStr{end+1} = 'TIP: Right-click LIBRARY popup to select structures.';
end

% run & plot switches
if hasParameters && definedLattices
    if toggleRunPlot==1 || toggleRunPlot==3
        checkStatus = 'On';
    else
        checkStatus = 'Off';
    end
    uimenu(cmenuLibrary, ...
        'Separator', 'On', ...
        'Checked', checkStatus, ...
        'Label', 'INCLUDE in RUN CALCULATIONS', ...
        'Callback', {@Toggle_Flag_RunPlot, idxObject, 'Run'});
    if toggleRunPlot==2 || toggleRunPlot==3
        checkStatus = 'On';
    else
        checkStatus = 'Off';
    end
    uimenu(cmenuLibrary, ...
        'Checked', checkStatus, ...
        'Label', 'INCLUDE in DISPLAY of plots', ...
        'Callback', {@Toggle_Flag_RunPlot, idxObject, 'Plot'});
end

% available results
displayStr{end+1} = ['===== ' tag ' calculation results'];
if isempty(runData)
    displayStr{end+1} = '(None available)';
else
    
    if makeTemplate
        fid = fopen([tag '_Calibration.txt'], 'wt');
        fprintf(fid, '\n#\n# Calibration data template for %s\n#\n', tag );
    end
    
    if isfield(runData.SingleElement, 'rose_E')
        displayStr{end+1} = sprintf(' [rose_E,rose_a] = %g pts (eV vs %s)', ...
            length(runData.SingleElement.rose_E), angstromStr);
    end
    
    if isfield(runData.SingleElement, 'E0')
        calculatedValue = runData.SingleElement.E0;
        tLabel = sprintf(' E0 = %g (eV)', calculatedValue);
        targetValue = calibrationData.E0;
        if ~isempty(targetValue)            
            tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
        end        
        displayStr{end+1} = tLabel;
    
        if makeTemplate
            fprintf(fid, '\n#\n# %s E0\n#\n', tag );
            fprintf(fid, 'E0, 0, 0, 0, %g\n', calculatedValue );
        end

    end
    
    if isfield(runData.SingleElement, 'box')
        displayStr{end+1} = sprintf(' box = [%g,%g,%g; %g,%g,%g; %g,%g,%g] (%s s)', ...
            runData.SingleElement.box', angstromStr);
    end
    
    if isfield(runData.SingleElement, 'E1')
        [~, locResultMin] = min(runData.SingleElement.E1);
        tLabel = sprintf(' [E1,a1] = %g pts (eV vs %s); min = (%g, %g)', ...
            length(runData.SingleElement.E1), angstromStr, ...
            runData.SingleElement.E1(locResultMin), runData.SingleElement.a1(locResultMin) );
        
        if makeTemplate
            fprintf(fid, '\n#\n# %s %s\n#\n', tag, handles.lattices{lattice(1)});
            fprintf(fid, 'E1, 0, 0, 0, %d\n', ceil((length(runData.SingleElement.E1)-2)/2) );
            fprintf(fid, '%g, %g\n', [runData.SingleElement.a1(2:2:end-1); runData.SingleElement.E1(2:2:end-1)']);
        end
        
        if ~isempty(calibrationData.E1)
            [~, locTargetMin] = min(calibrationData.E1.ydata);
            tLabel = sprintf('%s, dist = %.2e', tLabel, sqrt( ...
                (runData.SingleElement.E1(locResultMin)-calibrationData.E1.ydata(locTargetMin))^2 + ...
                (runData.SingleElement.a1(locResultMin)-calibrationData.E1.xdata(locTargetMin))^2 ) );
        end        
        displayStr{end+1} = tLabel;
    end
    
    if isfield(runData.SingleElement, 'E2')
        [~, locResultMin] = min(runData.SingleElement.E2);
        tLabel = sprintf(' [E2,a2] = %g pts (eV vs %s); min = (%g, %g)', ...
            length(runData.SingleElement.E2), angstromStr, ...
            runData.SingleElement.E2(locResultMin), runData.SingleElement.a2(locResultMin) );

        if makeTemplate
            fprintf(fid, '\n#\n# %s %s\n#\n', tag, handles.lattices{lattice(2)});
            fprintf(fid, 'E2, 0, 0, 0, %d\n', ceil((length(runData.SingleElement.E2)-2)/2) );
            fprintf(fid, '%g, %g\n', [runData.SingleElement.a2(2:2:end-1); runData.SingleElement.E2(2:2:end-1)']);
        end

        if ~isempty(calibrationData.E2)
            [~, locTargetMin] = min(calibrationData.E2.ydata);
            tLabel = sprintf('%s, dist = %.2e', tLabel, sqrt( ...
                (runData.SingleElement.E2(locResultMin)-calibrationData.E2.ydata(locTargetMin))^2 + ...
                (runData.SingleElement.a2(locResultMin)-calibrationData.E2.xdata(locTargetMin))^2 ) );
        end        
        displayStr{end+1} = tLabel;
    end
    
    if isfield(runData.SingleElement, 'E3')
        [~, locResultMin] = min(runData.SingleElement.E3);
        tLabel = sprintf(' [E3,a3] = %g pts (eV vs %s); min = (%g, %g)', ...
            length(runData.SingleElement.E3), angstromStr, ...
            runData.SingleElement.E3(locResultMin), runData.SingleElement.a3(locResultMin) );
        
        if makeTemplate
            fprintf(fid, '\n#\n# %s %s\n#\n', tag, handles.lattices{lattice(3)});
            fprintf(fid, 'E3, 0, 0, 0, %d\n', ceil((length(runData.SingleElement.E3)-2)/2) );
            fprintf(fid, '%g, %g\n', [runData.SingleElement.a3(2:2:end-1); runData.SingleElement.E3(2:2:end-1)']);
        end
        
        if ~isempty(calibrationData.E3)
            [~, locTargetMin] = min(calibrationData.E3.ydata);
            tLabel = sprintf('%s, dist = %.2e', tLabel, sqrt( ...
                (runData.SingleElement.E3(locResultMin)-calibrationData.E3.ydata(locTargetMin))^2 + ...
                (runData.SingleElement.a3(locResultMin)-calibrationData.E3.xdata(locTargetMin))^2 ) );
        end        
        displayStr{end+1} = tLabel;
    end

    if isfield(runData.SingleElement, 'C')
        [r,c] = find(runData.SingleElement.C);
        for i=1:length(r)
            calculatedValue = runData.SingleElement.C(r(i),c(i));
            targetValue = calibrationData.C{r(i),c(i)};
            tLabel = sprintf(' C%d%d = %g (GPa)', r(i),c(i), calculatedValue );
            if ~isempty(targetValue)
                tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
            end
            displayStr{end+1} = tLabel;
            if r(i)==1 && c(i)==2
                calculatedValue = (runData.SingleElement.C(1,1)-runData.SingleElement.C(1,2))/2.0;
                tLabel = sprintf(' (C11 - C12)/2 = %g (GPa)', calculatedValue);
                if ~isempty(calibrationData.C{1,1}) && ~isempty(calibrationData.C{1,2}) 
                    targetValue = (calibrationData.C{1,1}-calibrationData.C{1,2})/2.0;
                    tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue );
                end
                displayStr{end+1} = tLabel;
            end
            
            if makeTemplate
                fprintf(fid, '\n#\n# %s C%d%d\n#\n', tag, r(i),c(i) );
                fprintf(fid, 'C, 0, 0, 0, %d, %d, %g\n', r(i),c(i), calculatedValue );
            end

        end
    end
    
    if isfield(runData.SingleElement, 'Evac')
        calculatedValue = runData.SingleElement.Evac;
        tLabel = sprintf(' Evac = %g (eV)', calculatedValue);
        targetValue = calibrationData.Evac;
        if ~isempty(targetValue)            
            tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue );
        end
        displayStr{end+1} = tLabel;
    
        if makeTemplate
            fprintf(fid, '\n#\n# %s Evac\n#\n', tag );
            fprintf(fid, 'Evac, %g\n', calculatedValue );
        end
    end
    
    
    if isfield(runData.SingleElement, 'Einterstitials')
        nValues = length(runData.SingleElement.interstials);
        % expand calibration targets?
        if length(calibrationData.Einterstitials)<nValues
            calibrationData.Einterstitials{nValues} = [];
            newTarget = true;
        end
        for i=1:nValues
            calculatedValue = runData.SingleElement.Einterstitials(i);
            targetValue = calibrationData.Einterstitials{i};
            tLabel = sprintf(' E( %s ) = %g (eV)', ...
                runData.SingleElement.interstials{i}, calculatedValue );
            if ~isempty(targetValue)
                tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
            end
            displayStr{end+1} = tLabel;
    
            if makeTemplate
                fprintf(fid, '\n#\n# %s E ( %s )\n#\n', tag, runData.SingleElement.interstials{i} );
                fprintf(fid, 'Einterstitials, %d, %g\n', i, calculatedValue );
            end
        end
    end
    
    if isfield(runData.SingleElement, 'ESurfaces')
        nValues = length(runData.SingleElement.Surfaces);
        % expand calibration targets?
        if length(calibrationData.ESurfaces)<nValues
            calibrationData.ESurfaces{nValues} = [];
            newTarget = true;
        end
        for i=1:nValues
            calculatedValue = runData.SingleElement.ESurfaces(i);
            targetValue = calibrationData.ESurfaces{i};
            tLabel = sprintf(' E( %s ) = %g (mJ/m^2)', ...
                runData.SingleElement.Surfaces{i}, calculatedValue );
            if ~isempty(targetValue)
                tLabel = sprintf('%s; dist = %.2e', tLabel, targetValue-calculatedValue);
            end
            displayStr{end+1} = tLabel;
    
            if makeTemplate
                fprintf(fid, '\n#\n# %s E ( %s )\n#\n', tag, runData.SingleElement.Surfaces{i} );
                fprintf(fid, 'ESurfaces, %d, %g\n', i, calculatedValue );
            end
        end
    end
    
    if isfield(runData.SingleElement, 'GSFEs')
        nValues = size(runData.SingleElement.GSFEs,1);
        if length(calibrationData.GSFEs)<nValues
            calibrationData.GSFEs{nValues} = [];
            newTarget = true;
        end
        for i=1:nValues
            displayStr{end+1} = sprintf(' GSFEs( %s ) = %g pts (mJ/m^2 vs %s)', ...
                runData.SingleElement.planes{i}, ...
                size(runData.SingleElement.GSFEs,2), angstromStr );
            
            if makeTemplate
                fprintf(fid, '\n#\n# %s GSFE %s\n#\n', tag, runData.SingleElement.planes{i});
                fprintf(fid, 'GSFEs, %d, %g\n', i, ceil( (size(runData.SingleElement.GSFEs,2)-2)/2) );
                fprintf(fid, '%g, %g\n', [runData.SingleElement.shift(i,(2:2:end-1)); ...
                    runData.SingleElement.GSFEs(i,(2:2:end-1))]);
            end
        end
    end

    if makeTemplate
        fclose(fid);
    end
    
end

hasTarget = false;
targetList = {};
idxTarget = 0;
displayStr{end+1} = ['===== ' tag ' calibration data'];
uimenu(cmenuParameters, ...
    'Label', 'LOAD calibration data from file', ...
    'Callback', {@Calibration_Data_From_File, idxObject})
% uimenu(cmenuParameters, ...
%     'Label', 'SPECIFY calibration data');

if ~isempty(calibrationData.E0)
    hasTarget = true;
    checkStatus = 'On';
    tLabel = sprintf(' E0 = %g', calibrationData.E0);
    idxTarget = idxTarget + 1;
    targetList{idxTarget} = {idxObject, 'E0', 0, 0, 0, 'Scalar', 'E0', '', 0, 0};
    if Calibration_Target_Find(handles, targetList{idxTarget})
        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
    else
        targetStatus = '';
    end
    displayStr{end+1} = [tLabel targetStatus];
else
    checkStatus = 'Off';
    tLabel = ' E0';
end
uimenu(cmenuParameters, 'Separator', 'On', 'Checked', checkStatus, ...
    'Label', tLabel, ...
    'Callback', {@Calibration_Data_Single_Value, idxObject, 'E0', 0, 0, 0, '', 0, 0});


if ~isempty(calibrationData.E1)
    hasTarget = true;
    checkStatus = 'On';
    [~, locTargetMin] = min(calibrationData.E1.ydata);
    tLabel = sprintf(' [E1,a1] = %s, %g pts, min@%d = (%g, %g)', ...
        calibrationData.E1.file, length(calibrationData.E1.xdata), locTargetMin, ...
        calibrationData.E1.ydata(locTargetMin), calibrationData.E1.xdata(locTargetMin));
    targetStatus = '';
    idxTarget = idxTarget + 1;
    targetList{idxTarget} = {idxObject, 'E1', 0, 0, 0, 'Curve', '[E1,a1]', '', 0, 0};
    if Calibration_Target_Find(handles, targetList{idxTarget})
        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
    end
    displayStr{end+1} = [tLabel targetStatus];
else
    checkStatus = 'Off';
    tLabel = ' E1';
end
uimenu(cmenuParameters, 'Checked', checkStatus, ...
    'Label', tLabel, ...
    'Callback', {@Calibration_Data_Curve, idxObject, 'E1', 0, 0, 0, ''});


if ~isempty(calibrationData.E2)
    hasTarget = true;
    checkStatus = 'On';
    [~, locTargetMin] = min(calibrationData.E2.ydata);
    tLabel = sprintf(' [E2,a2] = %s, %g pts, min@%d = (%g, %g)', ...
        calibrationData.E2.file, length(calibrationData.E2.xdata), locTargetMin, ...
        calibrationData.E2.ydata(locTargetMin), calibrationData.E2.xdata(locTargetMin));
    targetStatus = '';
    idxTarget = idxTarget + 1;
    targetList{idxTarget} = {idxObject, 'E2', 0, 0, 0, 'Curve', '[E2,a2]', '', 0, 0};
    if Calibration_Target_Find(handles, targetList{idxTarget})
        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
    end
    displayStr{end+1} = [tLabel targetStatus];
else
    checkStatus = 'Off';
    tLabel = ' E2';
end
uimenu(cmenuParameters, 'Checked', checkStatus, ...
    'Label', tLabel, ...
    'Callback', {@Calibration_Data_Curve, idxObject, 'E2', 0, 0, 0, ''});

if ~isempty(calibrationData.E3)
    hasTarget = true;
    checkStatus = 'On';
    [~, locTargetMin] = min(calibrationData.E3.ydata);
    tLabel = sprintf(' [E3,a3] = %s, %g pts, min@%d = (%g, %g)', ...
        calibrationData.E3.file, length(calibrationData.E3.xdata), locTargetMin, ...
        calibrationData.E3.ydata(locTargetMin), calibrationData.E3.xdata(locTargetMin));
    targetStatus = '';
    idxTarget = idxTarget + 1;
    targetList{idxTarget} = {idxObject, 'E3', 0, 0, 0, 'Curve', '[E3,a3]', '', 0, 0};
    if Calibration_Target_Find(handles, targetList{idxTarget})
        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
    end
    displayStr{end+1} = [tLabel targetStatus];
else
    checkStatus = 'Off';
    tLabel = ' E3';
end
uimenu(cmenuParameters, 'Checked', checkStatus, ...
    'Label', tLabel, ...
    'Callback', {@Calibration_Data_Curve, idxObject, 'E3', 0, 0, 0, ''});


if ~isempty(runData) && isfield(runData.SingleElement, 'C')
    [r,c] = find(runData.SingleElement.C);
    for i=1:length(r)
        if ~isempty(calibrationData.C{r(i),c(i)})
            hasTarget = true;
            checkStatus = 'On';
            targetVal = calibrationData.C{r(i),c(i)};
            tLabel = sprintf(' C%d%d = %g', r(i),c(i), targetVal );
            if r(i)==1 && c(i)==2
                targetVal = (calibrationData.C{1,1}-calibrationData.C{1,2})/2;
                displayStr{end+1} = sprintf(' (C11 - C12)/2 = %g', targetVal );
            end
            idxTarget = idxTarget + 1;
            targetList{idxTarget} = {idxObject, 'C', 0, 0, 0, 'Scalar', sprintf('C%d%d', r(i),c(i)), '', r(i), c(i)};
            if Calibration_Target_Find(handles, targetList{idxTarget})
                targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
            else
                targetStatus = '';
            end
            displayStr{end+1} = [tLabel targetStatus];
        else
            checkStatus = 'Off';
            tLabel = sprintf(' C%d%d', r(i),c(i) );
        end
        uimenu(cmenuParameters, 'Checked', checkStatus, ...
                'Label', tLabel, ...
                'Callback', {@Calibration_Data_Single_Value, idxObject, 'C', 0, 0, 0, '', r(i), c(i)});
                % 'Callback', {@Calibration_Data_Elastic_Tensor, idxObject, r(i), c(i)});
    end
%     uimenu(cmenuParameters, 'Checked', 'Off', ...
%             'Label', 'LOAD CXX calibration data from file with 6x6 numbers', ...
%             'Callback', {@Calibration_Data_Elastic_Tensor, idxObject, r, c});
end

if ~isempty(calibrationData.Evac)
    hasTarget = true;
    checkStatus = 'On';
    tLabel = sprintf(' Evac = %g', calibrationData.Evac);
    idxTarget = idxTarget + 1;
    targetList{idxTarget} = {idxObject, 'Evac', 0, 0, 0, 'Scalar', 'Evac', '', 0, 0};
    if Calibration_Target_Find(handles, targetList{idxTarget})
        targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
    else
        targetStatus = '';
    end
    displayStr{end+1} = [tLabel targetStatus];
else
    checkStatus = 'Off';
    tLabel = ' Evac';
end
uimenu(cmenuParameters, 'Checked', checkStatus, ...
    'Label', tLabel, ...
    'Callback', {@Calibration_Data_Single_Value, idxObject, 'Evac', 0, 0, 0, '', 0, 0});

if ~isempty(calibrationData.Einterstitials) ...
         && ~isempty(runData) && isfield(runData.SingleElement, 'interstials')
    for i=1:length(runData.SingleElement.interstials)
        if ~isempty(calibrationData.Einterstitials{i})
            hasTarget = true;
            checkStatus = 'On';
            tLabel = sprintf(' E( %s ) = %g', ...
                runData.SingleElement.interstials{i}, calibrationData.Einterstitials{i} );
            idxTarget = idxTarget + 1;
            targetList{idxTarget} = {idxObject, 'Einterstitials', i, 0, 0, 'Scalar', ...
                ['E( ' runData.SingleElement.interstials{i} ' )'], '', 0, 0};
            if Calibration_Target_Find(handles, targetList{idxTarget})
                targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
            else
                targetStatus = '';
            end
            displayStr{end+1} = [tLabel targetStatus];
        else
            checkStatus = 'Off';
            tLabel = [' E( ' runData.SingleElement.interstials{i} ' )'];
        end
        uimenu(cmenuParameters, 'Checked', checkStatus, ...
            'Label', tLabel, ...
            'Callback', {@Calibration_Data_Single_Value, idxObject, 'Einterstitials', i, 0, 0, '', 0, 0} );

    end
end

if ~isempty(calibrationData.ESurfaces) ...
         && ~isempty(runData) && isfield(runData.SingleElement, 'Surfaces')
    for i=1:length(runData.SingleElement.Surfaces)
        if ~isempty(calibrationData.ESurfaces{i})
            hasTarget = true;
            checkStatus = 'On';
            tLabel = sprintf(' E( %s ) = %g', ...
                runData.SingleElement.Surfaces{i}, calibrationData.ESurfaces{i});
            idxTarget = idxTarget + 1;
            targetList{idxTarget} = {idxObject, 'ESurfaces', i, 0, 0, 'Scalar', ...
                ['E( ' runData.SingleElement.Surfaces{i} ' )'], '', 0, 0};
            if Calibration_Target_Find(handles, targetList{idxTarget})
                targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
            else
                targetStatus = '';
            end
            displayStr{end+1} = [tLabel targetStatus];
        else
            checkStatus = 'Off';
            tLabel = [' E( ' runData.SingleElement.Surfaces{i} ' )'];
        end
        uimenu(cmenuParameters, 'Checked', checkStatus, ...
            'Label', tLabel, ...
            'Callback', {@Calibration_Data_Single_Value, idxObject, 'ESurfaces', i, 0, 0, '', 0, 0} );

    end
end


if ~isempty(calibrationData.GSFEs) ...
         && ~isempty(runData) && isfield(runData.SingleElement, 'planes')
    for i=1:length(runData.SingleElement.planes)
        if ~isempty(calibrationData.GSFEs{i})
            hasTarget = true;
            checkStatus = 'On';
            tLabel = sprintf(' GSFEs( %s ) = %s', ...
                runData.SingleElement.planes{i}, calibrationData.GSFEs{i}.file);
            idxTarget = idxTarget + 1;
            targetList{idxTarget} = {idxObject, 'GSFEs', i, 0, 0, 'Curve', sprintf('GSFEs( %s )', ...
                runData.SingleElement.planes{i}), '', 0, 0};
            if Calibration_Target_Find(handles, targetList{idxTarget})
                targetStatus = [' (Target: ' targetList{idxTarget}{6} ')'];
            else
                targetStatus = '';
            end
            displayStr{end+1} = sprintf('%s, %g pts %s', ...
                tLabel, length(calibrationData.GSFEs{i}.xdata), targetStatus );
        else
            checkStatus = 'Off';
            tLabel = sprintf(' GSFEs( %s )', runData.SingleElement.planes{i});
        end
        uimenu(cmenuParameters, 'Checked', checkStatus, ...
            'Label', tLabel, ...
            'Callback', {@Calibration_Data_Curve, idxObject, 'GSFEs', i, 0, 0, ''});
    end
end

if ~hasTarget
    displayStr{end+1} = '(Not specified)';
end

% context menu to select calibration targets
if hasTarget
    uimenu(cmenuParameters, 'Separator', 'On', ...
        'Label', 'SELECT calibration target(s)');
    
    for idxTarget=1:length(targetList)
        if idxTarget==1
            separatorStatus = 'On';
        else
            separatorStatus = 'Off';
        end        
        targetType = targetList{idxTarget}{6};
        if Calibration_Target_Find(handles, targetList{idxTarget})
            checkStatus = 'On';
        else
            checkStatus = 'Off';
        end
        uimenu(cmenuParameters, 'Separator', separatorStatus, ...
            'Checked', checkStatus, ...
            'Label', [targetType ' : ' targetList{idxTarget}{7}], ...
            'Callback', {@Calibration_Target_Toggle, targetList{idxTarget}});
    end
    uimenu(cmenuParameters, 'Separator', 'On', ...
        'Checked', 'Off', ...
        'Label', ['Clear calibration targets for ' tag], ...
        'Callback', {@Calibration_Target_Clear, idxObject});
    
end

if newTarget
    MEAM_Object{idxObject,7} = calibrationData;
    set(handles.label_Library, 'UserData', MEAM_Object)
end


set(handles.label_Library, 'UIContextMenu', [])

set(handles.Library_Entry_Select, ...
    'UIContextMenu', cmenuLibrary, ...
    'ToolTipString', tipLibrary)

set(handles.Parameter_Entries_Select, ...
    'UIContextMenu', cmenuParameters, ...
    'ToolTipString', tipParameters)

set(handles.text_Display, 'String', displayStr )




function Text_Display_Object(handles, MEAM_Object, idxObject)
% update text display area

elementIdx = MEAM_Object{idxObject,1};
objectSize = size(elementIdx,2);

% INCLUDEd in RUN/DISPLAY
runSimilarList = [];
runIncludeList = [];
displayList = [];
for idx=1:size(MEAM_Object,1)
    % check if the structures of component elements are specified
    definedLattices = true;
    for i=MEAM_Object{idx,1}
        if MEAM_Object{i,5}(1)==0 || MEAM_Object{i,5}(2)==0 || MEAM_Object{i,5}(3)==0
            definedLattices = false;
        end
    end
    if ~definedLattices, continue, end
        
    if size(MEAM_Object{idx,1},2)==objectSize
        runSimilarList(end+1) = idx;
    end
    
    toggleRunPlot = MEAM_Object{idx,3};
    if toggleRunPlot==1 || toggleRunPlot==3 % INCLUDEd in RUN
        runIncludeList(end+1) = idx;
    end
    
    if toggleRunPlot==2 || toggleRunPlot==3 % INCLUDEd in DISPLAY
        % Plot <objectsize> checked?
        switch size(MEAM_Object{idx,1},2)
            case 1
                if ~strcmpi(get(handles.Plot_Include_elements, 'checked'), 'on'), continue, end
            case 2
                if ~strcmpi(get(handles.Plot_Include_binaries, 'checked'), 'on'), continue, end
            case 3
                if ~strcmpi(get(handles.Plot_Include_ternaries, 'checked'), 'on'), continue, end
        end
        displayList(end+1) = idx;
    end
end
set(handles.Run_calculations_Selected, 'UserData', idxObject)
set(handles.Run_calculations_Similar, 'UserData', runSimilarList)
set(handles.Run_calculations_Included, 'UserData', runIncludeList)

if isempty(runSimilarList)
    runSimilarListStr = '; (none)';
else
    runSimilarListStr = sprintf('; %s', MEAM_Object{runSimilarList,2});
end
runSimilarListStr = ['RUN Similar={' runSimilarListStr(3:end) '}'];

if isempty(runIncludeList)
    runIncludeListStr = '; (none)';
else
    runIncludeListStr = sprintf('; %s', MEAM_Object{runIncludeList,2});
end
runIncludeListStr = ['RUN Included={' runIncludeListStr(3:end) '}'];

if isempty(displayList)
    displayListStr = '; (none)'; 
else
    displayListStr = sprintf('; %s', MEAM_Object{displayList,2});
end
displayListStr = ['DISPLAY={' displayListStr(3:end) '}'];
[parameterStr, targetStr] = Calibration_Selections(handles, MEAM_Object);

set(handles.text_Includes, 'String', ...
    { runSimilarListStr, ...
    runIncludeListStr, ...
    displayListStr, ...
    '', ...
    'CALIBRATION:', ...
    parameterStr, ...
    targetStr, ...
    'TIP: Right-click PARAMETERS popup to specify calibration data & targets.'} )


switch objectSize

    case 1 % element
        Text_Display_Element(handles, MEAM_Object, idxObject)
        
    otherwise % binary, % ternary
        Text_Display_Alloy(handles, MEAM_Object, idxObject)
end

Plot_Options(handles, MEAM_Object)

Plot_control_update_Callback(handles.Plot_control_update, [], handles)


function Optimization_Configure(hObject, event, method)
% select a file or directory for LAMMPS

handles = guidata(hObject);

switch method

    case 'clear'
        handles.calibration_target = {};
        handles.calibration_parameter = {};
        
    case 'fminsearch'
        if handles.optimization_method == 2
            handles.optimization_options = ...
                Optimization_options_fminsearch(handles.optimization_options);
        else
            handles.optimization_method = 2;
            handles.optimization_options = Optimization_options_fminsearch();
        end
        
    case 'particleswarm'
        handles.optimization_method = 3;
        handles.pswarm_options = Optimization_options_pswarm(handles.pswarm_options);
        
    case 'lsqnonlin'
        if handles.optimization_method == 4
            handles.optimization_options = ...
                options_lsqnonlin(handles.optimization_options);
        else
            handles.optimization_method = 4;
            handles.optimization_options = options_lsqnonlin([]);
        end
        
    case 'fmincon'
        if handles.optimization_method == 5
            handles.optimization_options = ...
                options_fmincon(handles.optimization_options);
        else
            handles.optimization_method = 5;
            handles.optimization_options = options_fmincon([]);
        end
        if handles.isParallel
            handles.optimization_options = ...
                optimset(handles.optimization_options, ...
                'GradObj', 'off', ...
                'GradConstr', 'off', ...
                'UseParallel', 'always');
        else
            handles.optimization_options = ...
                optimset(handles.optimization_options, ...
                'UseParallel', 'never');
        end
    
    case 'patternsearch'
        handles.optimization_method = 6;
        handles.ps_options = ...
            Optimization_options_patternsearch(handles.ps_options);
        if handles.isParallel
            handles.ps_options = psoptimset(handles.ps_options, ...
                'Cache', 'off', ...
                'CompletePoll', 'on', ...
                'Vectorized', 'off', ...
                'UseParallel', 'always');
        else
            handles.ps_options = ...
                psoptimset(handles.ps_options, 'UseParallel', 'never');
        end
        
    case 'ga'
        handles.optimization_method = 7;
        handles.ga_options = ...
            Optimization_options_ga(handles.ga_options);
        if handles.isParallel
            handles.ga_options = ...
                gaoptimset(handles.ga_options, 'UseParallel', 'always');
        else
            handles.ga_options = ...
                gaoptimset(handles.ga_options, 'UseParallel', 'never');
        end

    case 'gamultiobj'
        handles.optimization_method = 8;
        handles.gamultiobj_options = ...
            Optimization_options_ga(handles.gamultiobj_options);

end

guidata(hObject, handles)
Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, event, handles)



function options = Optimization_options_fminsearch(varargin)

if ~isempty(varargin)
    if ~isempty(varargin{1})
        old_opts = varargin{1};
    else
        old_opts = optimset('fminsearch');
    end
else
    old_opts = optimset('fminsearch');
end

options = old_opts;

dlg_options.Resize = 'on';
dlg_options.WindowStyle = 'normal';
dlg_options.Interpreter = 'none';
name = 'Options for fminsearch()';
numlines = 1;

%     'Display - Level of display (off, iter, final, notify)'; ...
%     options.Display; ...
%     'PlotFcns - Plots various measures of progress while the algorithm executes'; ... 
%     '{@optimplotval, @optimplotfuncount}'; ...

prompt = { ...
    'TolFun - Termination tolerance on the function value'; ...
    'TolX - Termination tolerance on x'; ...
    'MaxFunEvals - Maximum number of function evaluations allowed'; ...
    'MaxIter - Maximum number of iterations allowed'; ...
    };
defaultanswer = { ...
    num2str(options.TolFun); ...
    num2str(options.TolX);
    ''; ...
    ''; ...
    };

answer = inputdlg(prompt, name, numlines, defaultanswer, dlg_options);
if isempty(answer), return, end % Cancelled

% options = optimset(options, 'PlotFcns', {@optimplotfval, @optimplotfunccount});
tval = str2double(answer{1});
if ~isnan(tval)
    options = optimset(options, 'TolFun', tval);
end
tval = str2double(answer{2});
if ~isnan(tval)
    options = optimset(options, 'TolX', tval);
end
tval = str2double(answer{3});
if ~isnan(tval)
    options = optimset(options, 'MaxFunEvals', tval);
end
tval = str2double(answer{4});
if ~isnan(tval)
    options = optimset(options, 'MaxIter', tval);
end



function options = Optimization_options_pswarm(old_option)

options = old_option;

dlg_options.Resize = 'on';
dlg_options.WindowStyle = 'normal';
dlg_options.Interpreter = 'none';
name = 'Some options for particleswarm()';
numlines = 1;

prompt = { ...
    'TolFun', ['Iterations end when the relative change in ' ...
        ' best objective function value over the last StallIterLimit ' ...
        ' iterations is less than TolFun']; ...
    'StallTimeLimit', ['Maximum number of seconds without an improvement ' ...
        ' in the best known objective function value']; ...
    'StallIterLimit', ['Iterations end when the relative change in ' ...
        ' best objective function value over the last StallIterLimit ' ...
        ' iterations is less than TolFun.']; ...
    'MaxTime', 'Maximum time in seconds that particleswarm runs'; ...
    };

defaultanswer = { ...
    num2str(old_option.TolFun); ...
    num2str(old_option.StallTimeLimit); ...
    num2str(old_option.StallIterLimit); ...
    num2str(old_option.MaxTime); ...
    };

answer = inputdlg(prompt, name, numlines, defaultanswer, dlg_options);
if isempty(answer), return, end % Cancelled

tval = str2double(answer{1});
if ~isnan(tval)
    options = optimoptions(options, 'TolFun', tval);
end
tval = str2double(answer{2});
if ~isnan(tval)
    options = optimoptions(options, 'StallTimeLimit', tval);
end
tval = str2double(answer{3});
if ~isnan(tval)
    options = optimoptions(options, 'StallIterLimit', tval);
end
tval = str2double(answer{4});
if ~isnan(tval)
    options = optimoptions(options, 'MaxTime', tval);
end



function options = Optimization_options_patternsearch(old_options)

options = old_options;

dlg_options.Resize = 'on';
dlg_options.WindowStyle = 'normal';
dlg_options.Interpreter = 'none';
name = 'Options for patternsearch()';
numlines = 1;

%     'Display - Level of display (off, iter, final, notify)'; ...
%     options.Display; ...
%     'PlotFcns - Plots various measures of progress while the algorithm executes'; ... 
%     '{@optimplotval, @optimplotfuncount}'; ...

prompt = { ...
    'TolFun - Termination tolerance on the function value'; ...
    'TolX - Termination tolerance on x'; ...
    'TolMesh - Termination tolerance on mesh size'; ...
    'MaxFunEvals - Maximum number of function evaluations allowed'; ...
    'MaxIter - Maximum number of iterations allowed'; ...
    };
defaultanswer = { ...
    num2str(options.TolFun); ...
    num2str(options.TolX);
    num2str(options.TolMesh);
    ''; ...
    ''; ...
    };

answer = inputdlg(prompt, name, numlines, defaultanswer, dlg_options);
if isempty(answer), return, end % Cancelled

% options = optimset(options, 'PlotFcns', {@optimplotfval, @optimplotfunccount});
tval = str2double(answer{1});
if ~isnan(tval)
    options = psoptimset(options, 'TolFun', tval);
end
tval = str2double(answer{2});
if ~isnan(tval)
    options = psoptimset(options, 'TolX', tval);
end
tval = str2double(answer{3});
if ~isnan(tval)
    options = psoptimset(options, 'TolMesh', tval);
end
tval = str2double(answer{4});
if ~isnan(tval)
    options = psoptimset(options, 'MaxFunEvals', tval);
end
tval = str2double(answer{5});
if ~isnan(tval)
    options = psoptimset(options, 'MaxIter', tval);
end


function options = Optimization_options_ga(old_option)
% 
% if isempty(old_option)
%     options = gaoptimset();
% else
    options = old_option;
% end

dlg_options.Resize = 'on';
dlg_options.WindowStyle = 'normal';
dlg_options.Interpreter = 'none';
name = 'Some options for ga()';
numlines = 1;

prompt = { ...
    'PopulationSize - Size of the population'; ...
    'Generations - Maximum number of iterations before the algorith fails'; ...
    'TolFun - (See StallGenLimit)'; ...
    'StallGenLimit - Algorithm stops if the weighted average relative change in best fitness function value over StallGenLimit genarations is <= TolFun'; ...
    'StallTimeLimit - The algorithm stops if there is no improvement in objective function for StallTimeLimit seconds'; ...
    'TimeLimit - The algorithm stops after running for TimeLimit seconds'; ...
    };
defaultanswer = { ...
    num2str(old_option.PopulationSize); ...
    num2str(old_option.Generations); ...
    num2str(old_option.TolFun); ...
    num2str(old_option.StallGenLimit); ...
    num2str(old_option.StallTimeLimit); ...
    num2str(old_option.TimeLimit); ...
    };


answer = inputdlg(prompt, name, numlines, defaultanswer, dlg_options);
if isempty(answer), return, end % Cancelled


tval = str2double(answer{1});
if ~isnan(tval)
    options = gaoptimset(options, 'PopulationSize', tval);
end
tval = str2double(answer{2});
if ~isnan(tval)
    options = gaoptimset(options, 'Generations', tval);
end
tval = str2double(answer{3});
if ~isnan(tval)
    options = gaoptimset(options, 'TolFun', tval);
end
tval = str2double(answer{4});
if ~isnan(tval)
    options = gaoptimset(options, 'StallGenLimit', tval);
end
tval = str2double(answer{5});
if ~isnan(tval)
    options = gaoptimset(options, 'StallTimeLimit', tval);
end
tval = str2double(answer{6});
if ~isnan(tval)
    options = gaoptimset(options, 'TimeLimit', tval);
end



% --------------------------------------------------------------------
function Calibration_Run_Callback(hObject, eventdata, handles)
% hObject    handle to Calibration_Run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


dlg_title = get(hObject, 'Tag');

if isempty(handles.calibration_target)
    msgbox('No calibration targets.', dlg_title, 'error', 'modal')
    return
end

if isempty(handles.calibration_parameter)
    msgbox('No calibration parameters.', dlg_title, 'error', 'modal')
    return
end

MEAM_Object = get(handles.label_Library, 'UserData');
numElements = max(MEAM_Object{end,1});

% make a list of objects and corresponding calculation flags based on calibration targets
fit_targets_and_parameters = '';
nTargets = length(handles.calibration_target);
objectList = []; % zeros(1,nTargets);
calculationList = {}; % cell(1,nTargets); % SEflags, Bflags, Tflags
display( ['Calibration targets = ' num2str(nTargets)] )    

% weights for error estimates
if nTargets>1
    prompt = cell(nTargets,1);
    defaultanswer = cell(nTargets,1);

    options.Resize = 'on';
    options.WindowStyle = 'normal';
    options.Interpreter = 'none';
    numlines = 1;
    name = 'User input';
    for i=1:nTargets
        defaultanswer{i} = '1.0';

        idxObject  = handles.calibration_target{i}{1};
        varName = handles.calibration_target{i}{2};
        row = handles.calibration_target{i}{3};
        col = handles.calibration_target{i}{4};
        hyt = handles.calibration_target{i}{5};
        latticeName  = handles.calibration_target{i}{8};
        if isempty(latticeName)
            prompt{i} = ['Target is ' MEAM_Object{idxObject,2}  ':' handles.calibration_target{i}{7}];
            if strcmp(handles.calibration_target{i}{6}, 'Curve')
                if row==0
                    prompt{i} = [prompt{i} '(' num2str(MEAM_Object{idxObject,7}.(varName).left) ':' ...
                        num2str(MEAM_Object{idxObject,7}.(varName).right) ')'];
                else
                    prompt{i} = [prompt{i} '(' num2str(MEAM_Object{idxObject,7}.(varName){row}.left) ':' ...
                        num2str(MEAM_Object{idxObject,7}.(varName){row}.right) ')'];
                end
            end
        else
            prompt{i} = ['Target is ' strrep(latticeName,'_','-')  ':' handles.calibration_target{i}{7}];
            if strcmp(handles.calibration_target{i}{6}, 'Curve')
                prompt{i} = [prompt{i} '(' num2str(MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.left) ':' ...
                    num2str(MEAM_Object{idxObject,7}.(varName).(latticeName){row,col,hyt}.right) ')'];
            end
        end
    end

    prompt{1} = sprintf([ ...
        'Specify the weight for the error estimate for each target. The weight \n' ...
        'for a target will be divided by the sum of all weights.\n\n%s'], ...
        prompt{1});
    answer = inputdlg(prompt, name, numlines, defaultanswer, options);
    if isempty(answer)
        display('User cancel: weights for error estimates')
        return
    end

    err_weight = str2double(answer);
    if any(isnan(err_weight))
        msgbox('Weights for error estimates: at least one input is not a valid number.', ...
            name, 'error', 'modal')
        return
    else
        tSum = sum(err_weight);
        err_weight = err_weight/tSum;
        % return
    end
else
    err_weight = 1.0;
end

% build structure for optimization data
optData = [];
optData.nTargets = nTargets;
optData.nPoints = zeros(nTargets,1);
optData.err_est = zeros(nTargets,1);
optData.err_weight = err_weight;

for i=1:nTargets
    idx = handles.calibration_target{i}{1};
    posList = find(objectList==idx,1);
    if isempty(posList)
        posList = length(objectList)+1;
        SEflags = zeros(1,length(handles.SingleElementCalculation));
        Bflags = zeros(1,length(handles.BinaryCalculation));
        Tflags = zeros(1,length(handles.TernaryCalculation));
    else
        SEflags = calculationList{posList}{1};
        Bflags = calculationList{posList}{2};
        Tflags = calculationList{posList}{3};
    end

    elementIdx = MEAM_Object{idx,1};
    objectSize = size(elementIdx,2);
    tag = MEAM_Object{idx,2};
    
    display( [num2str(i) '. ' tag ' - ' handles.calibration_target{i}{7}] )    
    fit_targets_and_parameters = [fit_targets_and_parameters ' ' ...
        tag ':' handles.calibration_target{i}{7}];
    
    switch objectSize
        
        case 1
            SEflags(1) = 1;
            % 1) Primary EV curve
            % 2) Secondary EV curve
            % 3) Secondary2 EV curve
            % 4) Elastic Constants Calculation
            % 5) Vacancy Energy Calculation
            % 6) Interstitital Energy Calculations
            % 7) Surface Energy Calculations
            % 8) Generalized Stacking Fault Energy Calculations
            switch handles.calibration_target{i}{2}
                case 'E0' % 'Scalar'
                    SEflags(1) = 1;
                    optData.nPoints(i) = 1;
                case 'E1'
                    SEflags(1) = 1;
                    optData.nPoints(i) = 1 + ...
                        MEAM_Object{idx,7}.E1.right - MEAM_Object{idx,7}.E1.left;
                case 'E2'
                    SEflags(2) = 1;
                    optData.nPoints(i) = 1 + ...
                        MEAM_Object{idx,7}.E2.right - MEAM_Object{idx,7}.E2.left;
                case 'E3'
                    SEflags(3) = 1;
                    optData.nPoints(i) = 1 + ...
                        MEAM_Object{idx,7}.E3.right - MEAM_Object{idx,7}.E3.left;
                case 'C' % 'Scalar'
                    SEflags(4) = 1;
                    optData.nPoints(i) = 1;
                case 'Evac' % 'Scalar'
                    SEflags(5) = 1;
                    optData.nPoints(i) = 1;
                case 'EInterstitial' % 'Scalar'
                    SEflags(6) = 1;
                    optData.nPoints(i) = 1;
                case 'ESurfaces' % 'Scalar'
                    SEflags(7) = 1;
                    optData.nPoints(i) = 1;
                case 'GSFEs' % 'Curve'
                    SEflags(8) = 1;
                    optData.nPoints(i) = 1 + ...
                        MEAM_Object{idx,7}.GSFEs{handles.calibration_target{i}{3}}.right - ...
                        MEAM_Object{idx,7}.GSFEs{handles.calibration_target{i}{3}}.left;
            end
            %display(handles.SingleElementCalculation(SEflags>0)')
            
            
        case 2
            Bflags(1) = 1;
            % 1) Binary EV Curves
            % 2) Binary Elastic Constants Calculation
            % 3) Substitution Energy
            % 4) Interstitial Substitution Energy
            switch handles.calibration_target{i}{2}
                case 'E1'
                    Bflags(1) = 1;
                    optData.nPoints(i) = 1 + ...
                        MEAM_Object{idx,7}.E1.(handles.calibration_target{i}{8}){handles.calibration_target{i}{3},handles.calibration_target{i}{4},handles.calibration_target{i}{5}}.right - ...
                        MEAM_Object{idx,7}.E1.(handles.calibration_target{i}{8}){handles.calibration_target{i}{3},handles.calibration_target{i}{4},handles.calibration_target{i}{5}}.left;
                case {'E0', 'H', 'Nx'}
                    Bflags(1) = 1;
                    optData.nPoints(i) = 1;
                case 'C'
                    Bflags(2) = 1;
                    optData.nPoints(i) = 1;
                case 'Substitution'
                    Bflags(3) = 1;
                    optData.nPoints(i) = 1;
                case 'ISubstitution'
                    Bflags(4) = 1;
                    optData.nPoints(i) = 1;
            end
            % force single element Primary EV Curve calculation dependency
            if Bflags(1)+Bflags(3)+Bflags(4)>0
                SEflags(1) = 1;
            end
            %display(handles.SingleElementCalculation(SEflags>0)')
            %display(handles.BinaryCalculation(Bflags>0)')

            
        case 3
            optData.nPoints(i) = 1;
            Tflags     = 1; % Binding Energy
            Bflags(3)  = 1; % Substitution Energy
            Bflags(4)  = 1; % ISubstitution Energy
            Bflags(1)  = 1; % Binary EV
            SEflags(1) = 1; % Primary EV
            %display(handles.SingleElementCalculation(SEflags>0)')
            %display(handles.BinaryCalculation(Bflags>0)')
            %display(handles.TernaryCalculation(Tflags>0)')
            
    end
    objectList(posList) = idx;
    calculationList{posList} = {SEflags, Bflags, Tflags};
    
end

% expand binaries and ternaries in object list
expandedList = [];
calculationFlag ={};
for i=1:length(objectList)
    idx = objectList(i);
    SEflags = calculationList{i}{1};
    Bflags = calculationList{i}{2};
    Tflags = calculationList{i}{3};
    
    for j=MEAM_Object{idx,1} % for each element in object
        pos = find(expandedList==j,1);
        if pos % element is already in expandedList
            calculationFlag{pos}{1} = calculationFlag{pos}{1} + SEflags;
            %display(['A1. Element already in list: ' MEAM_Object{j,2}])
            %display(['  - ' num2str(calculationFlag{pos}{1})])
            continue
        end
        expandedList(end+1) = j; % add element
        calculationFlag{end+1} = {SEflags, zeros(size(Bflags)), zeros(size(Tflags))};
        %display(['A2. Element added to list: ' MEAM_Object{j,2}])
        %display(['  - ' num2str(SEflags)])
    end
    
    if find(expandedList==idx), continue, end % object is already in expandedList
    
    if size(MEAM_Object{idx,1},2)>2 % object is a ternary? 
        Binary = nchoosek(MEAM_Object{idx,1},2); % make list of binaries in ternary object
        numBinaries = size(Binary,1); % how many binaries in ternary object
        for k=1:numBinaries % for each binary in ternary object
            for l=1:size(MEAM_Object,1) % examine all objects
                if size(MEAM_Object{l,1},2)~=2, continue, end % object is not a binary
                if MEAM_Object{l,1}==Binary(k,1:2) % object is a binary AND is in ternary under consideration

                    pos = find(expandedList==l,1);
                    if pos % element is already in expandedList
                        calculationFlag{pos}{2} = calculationFlag{pos}{2} + Bflags;
                        %display(['B1. Binary already in list: ' MEAM_Object{l,2}])
                        %display(['  - ' num2str(calculationFlag{pos}{2})])
                        continue
                    end

                    
                    expandedList(end+1) = l; % add binary
                    calculationFlag{end+1} = {zeros(size(SEflags)), Bflags, zeros(size(Tflags))};
                    %display(['B2. Binary added to list: ' MEAM_Object{l,2}])
                    %display(['  - ' num2str(Bflags)])
                    break % move to next binary in ternary object
                end
            end
        end
    end
    
    expandedList(end+1) = idx; % add object
    switch size(MEAM_Object{idx,1},2)
        case 1
            calculationFlag{end+1} = {SEflags, zeros(size(Bflags)), zeros(size(Tflags))};
            %display(['A3. Element added to list: ' MEAM_Object{idx,2}])
            %display(['  - ' num2str(SEflags)])
        case 2
            calculationFlag{end+1} = {zeros(size(SEflags)), Bflags, zeros(size(Tflags))};
            %display(['B3. Binary added to list: ' MEAM_Object{idx,2}])
            %display(['  - ' num2str(Bflags)])
        case 3
            calculationFlag{end+1} = {zeros(size(SEflags)), zeros(size(Bflags)), Tflags>0};
            %display(['C1. Ternary added to list: ' MEAM_Object{idx,2}])
            %display(['  - ' num2str(Tflags)])
    end
    
end
[expandedList, IX] = sort(expandedList);
calculationFlag = calculationFlag(IX);
% the calculations
for i=length(expandedList):-1:1
    idx = expandedList(i);
    display(['Calculations for ' MEAM_Object{idx,2}])
    switch size(MEAM_Object{idx,1},2)
        case 1
            display(handles.SingleElementCalculation(calculationFlag{i}{1}>0)')
        case 2
            display(handles.BinaryCalculation(calculationFlag{i}{2}>0)')
        case 3
            display(handles.TernaryCalculation(calculationFlag{i}{3}>0)')
    end
    
end


optData.MEAM_Object = MEAM_Object;
optData.expandedList = expandedList;
optData.calculationList = calculationFlag;
optData.residuals = zeros(sum(optData.nPoints)+1,1);

% working directory
multi_tag = dlg_title;
if strcmpi(get(handles.File_Use_tempname, 'Checked'), 'On')
    [~, timeStamp, ~] = fileparts(tempname);
else
    timeStamp = 'files';
end
optData.run_dir = fullfile( get(handles.File_LAMMPS_WorkDirectory_Select, 'UserData'), ...
    multi_tag, timeStamp);
[~, ~, ~] = mkdir(optData.run_dir);


% initial approximation x0, and constraints xmin, xmax
fmt = {'%s=[%g,%g,%g]', '%s(%d)=[%g,%g,%g]', ...
    '%s(%d,%d)=[%g,%g,%g]', '%s(%d,%d,%d)=[%g,%g,%g]'};
n2fit = length(handles.calibration_parameter);
x0 = zeros(n2fit,1);
xmin = x0;
xmax = x0;
fit_targets_and_parameters = [fit_targets_and_parameters ';'];
for i=1:n2fit
    idxObject  = handles.calibration_parameter{i}{1};
    keyword = handles.calibration_parameter{i}{2};
    idx     = handles.calibration_parameter{i}{3}{1};
    value   = handles.calibration_parameter{i}{4};
    % suppress 'lib_' or 'param_' in keyword
    if strncmp(keyword, 'lib_', 4)
        keyword(1:4) = [];
        display(sprintf(fmt{1}, ...
            [MEAM_Object{idxObject,2} ':' keyword], value))
        xmin(i) = value(1);
        x0(i)   = value(2);
        xmax(i) = value(3);
        fit_targets_and_parameters = [fit_targets_and_parameters ' ' ...
            MEAM_Object{idxObject,2} ':' keyword]; %#ok<*AGROW>

    else
        keyword(1:6) = [];
        fidx = length(idx)+1;
        switch fidx
            case 1
                display( sprintf(fmt{fidx}, keyword, value) )
                fit_targets_and_parameters = [fit_targets_and_parameters ' ' ...
                    keyword];
            case 2
                display( sprintf(fmt{fidx}, keyword, idx(1), value) )
                fit_targets_and_parameters = [fit_targets_and_parameters ' ' ...
                    keyword '(' num2str(idx(1)) ')'];
            case 3
                display( sprintf(fmt{fidx}, keyword, idx(1), idx(2), value) )
                fit_targets_and_parameters = [fit_targets_and_parameters ' ' ...
                    keyword '(' num2str(idx(1)) ',' num2str(idx(2)) ')'];
            case 4
                display( sprintf(fmt{fidx}, keyword, idx(1), idx(2), idx(3), value) )
                fit_targets_and_parameters = [fit_targets_and_parameters ' ' ...
                    keyword '(' num2str(idx(1)) ',' num2str(idx(2)) ',' num2str(idx(3)) ')'];
        end
        xmin(i) = value(1);
        x0(i)   = value(2);
        xmax(i) = value(3);
        
    end

end
% [x0 xmin xmax]

% copy x0 to library and parameter
library = cell(1,numElements);
for idxObject=1:numElements
    library{idxObject} = MEAM_Object{idxObject,4};
end
parameter = get(handles.label_Parameters, 'UserData');
[library_out, parameter_out, ~, ~, ~] = ...
    Copy_values(x0, handles.calibration_parameter, library, parameter);

optData.run_desc = dlg_title;
optData.fitted_list = handles.calibration_parameter;
optData.library = library_out;
optData.parameter = parameter_out;
optData.MEAM_elements = [1:numElements];
optData.libFile = fullfile(optData.run_dir, 'local.library.meam');
optData.paramFile = fullfile(optData.run_dir, 'local.parameter.meam');

% write the library file once
mesg = File_Library_Write(handles, optData.libFile, ...
    library_out, optData.MEAM_elements, multi_tag);
if ~isempty(mesg)
    msgbox(mesg, dlg_title, 'error', 'modal')
    return
end

% write the parameter file once
mesg = File_Parameters_Write( optData.paramFile, parameter_out );
if ~isempty(mesg)
    msgbox(mesg, dlg_title, 'error', 'modal')
    return
end

method = handles.optimization_method;
if nTargets==1 && handles.optimization_method==8
    method = 7;
end
optData.method = method;

% optData

% create handle to the objective function
% pass 'global' handles and optData as extra parameters
objFn = @(z) Optimization_objective_function(z, handles, optData);
% testObjFnValue = objFn(x0 + rand(size(x0)).*(xmax-xmin)/2.0)

% run optimization
h = msgbox(['Please wait several minutes (or hours) for the calibration ' ...
    ' to complete, after which this message will automatically go away.'], ...
    dlg_title, 'help', 'modal');

switch method

    case 2 % 'fminsearch'
        options = optimset(handles.optimization_options, ...
            'Display', 'iter', 'PlotFcns',@optimplotfval)
        [x, ~, exit_flag, Output] = fminsearch(objFn, x0, options)

    case 3 % 'particleswarm'
        options = optimoptions(handles.pswarm_options, ...
            'Display', 'iter', 'PlotFcns',@pswplotbestf )            
        [x, ~, exit_flag, Output] = particleswarm(objFn, ...
            length(x0), xmin, xmax, options)
    
    case 4 % 'lsqnonlin'
        options = optimset(handles.optimization_options, ...
            'Display', 'none') % 'iter')
        [x, ~, ~, exit_flag, Output] = lsqnonlin(objFn, x0, ...
            xmin, xmax, options)

    case 5 % fmincon
        % options = optimset(user_data.optimization_options, ...
        %      'Algorithm','active-set', 'Display', 'iter')
        options = optimset(handles.optimization_options, ...
            'Algorithm','interior-point', 'Display', 'none') % 'iter');
        [x, ~, exit_flag, Output] = fmincon(objFn, x0, ...
            [], [], [], [], xmin, xmax, [], options);

    case 6 % 'patternsearch'
        options = psoptimset(handles.ps_options, ...
            'Display', 'iter', 'PlotFcns', @psplotbestf)
        [x, ~, exit_flag, Output] = patternsearch(objFn, ...
            x0, [], [], [], [], xmin, xmax, [], options);

    case 7 % 'ga'
        options = gaoptimset(handles.ga_options, ...
            'Display', 'iter', 'PlotFcns', @gaplotbestf)
        [x, ~, exit_flag, Output] = ga(objFn, ...
            length(x0), [], [], [], [], xmin, xmax, [], options);

    case 8 % 'gamultiobj'

        options = gaoptimset(handles.gamultiobj_options, ...
            'Display', 'iter', 'PlotFcns', @gaplotpareto)
        [x,Fval,exit_flag,Output] = gamultiobj(objFn, n2fit, ...
            [], [], [], [], xmin, xmax, options);

end

% close message window
if ishandle(h), delete(h); end
display(Output.message)

% delete PlotFn plot if any
h = findobj('Name', 'Optimization PlotFcns');
if ishandle(h), close(h), end
h = findobj('Name', 'Pattern Search');
if ishandle(h), close(h), end
h = findobj('Tag', 'Particleswarm', 'Type', 'figure');
if ishandle(h), close(h), end
h = findobj('Name', 'Genetic Algorithm');
if ishandle(h), close(h), end

% add to history
history = get(handles.Calibration_History, 'UserData');

switch method
    
    case 8 % 'gamultiobj'
        if exit_flag==-2 % no solution found
            msgbox(Output.message, dlg_title, 'none', 'modal')
            return

        else
            % copy x(1,:) to library and parameter
            [library_out, parameter_out, ~, ~, ~] = ...
                Copy_values(x(1,:), handles.calibration_parameter, library, parameter);
            history{end+1} = {library_out, parameter_out, ...
                fit_targets_and_parameters};
%             for i=1:size(x,1)
%                 
%                 % copy x(i,.) to library and parameter
%                 [library_out, parameter_out, ~, ~] = ...
%                     Copy_values(x(i,:), fitted_list, library, parameter);
%                 meam_data.library = library_out;
%                 
%                 history{end+1} = {meam_data, parameter_out, ...
%                     ['#' num2str(i) ': ' fit_targets_and_parameters]};
% 
%             end

        end
        
    otherwise
        
        if exit_flag>-1 || ~isempty(x) % something in x
            
            [library_out, parameter_out, ~, ~, ~] = ...
                Copy_values(x, handles.calibration_parameter, library, parameter);
            history{end+1} = {library_out, parameter_out, ...
                fit_targets_and_parameters};

        else
            msgbox(Output.message, dlg_title, 'none', 'modal')
            return
        end
end

% update calculation flags to include calculations 'implied' by
% calibration targets
set(handles.label_Library, 'UserData', MEAM_Object)

% update history and displayed values
history_len = length(history);
history_display = {};
for i=1:history_len
    history_display{i} = history{i}{3};
end
set(handles.Calibration_History, 'UserData', history, ...
    'String', history_display, 'Value', history_len)
Calibration_History_Callback(handles.Calibration_History, [], handles)

% % clear calibration targets and parameters
% Optimization_Configure(gcbo, [], 'clear')

msgbox(Output.message, dlg_title, 'none', 'modal')



% --------------------------------------------------------------------
function y = Optimization_objective_function(x, handles, optData)
% the objective function to be optimized

display(sprintf('%0.6f ', x'))
y = Inf(size(optData.err_est));

% copy x() to library file and/or parameter file
[library, parameter, libFileChanges, paramFileChanges, outOfBounds] = ...
    Copy_values(x, optData.fitted_list, optData.library, optData.parameter);

if optData.method==2 && outOfBounds>0, return, end % 'fminsearch' out of bound

% stamp = datestr(now,30);
% write the library file
if libFileChanges
%     movefile(fullfile(optData.run_dir, optData.libFile), ...
%         fullfile(optData.run_dir, [optData.libFile '-' stamp]), 'f' )
    mesg = File_Library_Write(handles, optData.libFile, ...
        library, optData.MEAM_elements, optData.run_desc);
    if ~isempty(mesg)
        msgbox(mesg, optData.run_desc, 'error', 'modal')
        return
    end
end

% write the parameter file
if paramFileChanges
%     movefile(fullfile(optData.run_dir, optData.paramFile), ...
%         fullfile(optData.run_dir, [optData.paramFile '-' stamp]), 'f' )
    mesg = File_Parameters_Write( optData.paramFile, parameter );
    if ~isempty(mesg)
        msgbox(mesg, optData.run_desc, 'error', 'modal')
        return
    end
end

optData.MEAM_Object = MPC_Run_LAMMPS( handles, optData.libFile, optData.paramFile, ...
    optData.MEAM_Object, optData.expandedList, optData.calculationList, false);


% calculate error estimate
optData.residuals(1:end) = 0.0;
start = 0;

for idxTarget=1:optData.nTargets

    % the target
    targetObject = handles.calibration_target{idxTarget}{1};
    varName      = handles.calibration_target{idxTarget}{2};
    row          = handles.calibration_target{idxTarget}{3};
    col          = handles.calibration_target{idxTarget}{4};
    hyt          = handles.calibration_target{idxTarget}{5};
    %targetType   = handles.calibration_target{idxTarget}{6};
    latticeName  = handles.calibration_target{idxTarget}{8};
    Ci           = handles.calibration_target{idxTarget}{9};
    Cj           = handles.calibration_target{idxTarget}{10};
    
    elementIdx = optData.MEAM_Object{targetObject,1};
    objectSize = size(elementIdx,2);
    % tag = optData.MEAM_Object{targetObject,2};
    % display( [num2str(idxTarget) '. ' tag ' - ' handles.calibration_target{idxTarget}{7}] )    
    
    % the calculated result
    idxResult = optData.expandedList( find(optData.expandedList==targetObject, 1) );
    
    switch objectSize
        
        case 1
            switch varName
                
                case {'E1', 'E2', 'E3'}
                    xName = ['a' varName(2:2)];
                    idxLeft = optData.MEAM_Object{targetObject,7}.(varName).left;
                    idxRight = optData.MEAM_Object{targetObject,7}.(varName).right;
                    if idxLeft==idxRight % assume target is curve minimum
                        % find location of the minimum in the result
                        [~, locResultMin] = min(optData.MEAM_Object{idxResult,6}.SingleElement(1).(varName)); 
                        xDiff = optData.MEAM_Object{targetObject,7}.(varName).xdata(idxLeft) - ...
                            optData.MEAM_Object{idxResult,6}.SingleElement(1).(xName)(locResultMin);
                        yDiff = optData.MEAM_Object{targetObject,7}.(varName).ydata(idxLeft) - ...
                            optData.MEAM_Object{idxResult,6}.SingleElement(1).(varName)(locResultMin);
                        optData.err_est(idxTarget) = sqrt( xDiff^2 + yDiff^2 );
                        optData.residuals(start+1:start+1,1) = optData.err_est(idxTarget);
                    else % interpolate at calibration points
                        val = interp1( ...
                            optData.MEAM_Object{idxResult,6}.SingleElement(1).(xName), ...
                            optData.MEAM_Object{idxResult,6}.SingleElement(1).(varName), ...
                            optData.MEAM_Object{targetObject,7}.(varName).xdata(idxLeft:idxRight), 'linear');
                        % Calculate residuals
                        residual = (optData.MEAM_Object{targetObject,7}.(varName).ydata(idxLeft:idxRight) - val);
                        residual(isnan(residual)) = 0.0;
                        optData.err_est(idxTarget) = norm(residual);
                        optData.residuals(start+1:start+optData.nPoints(idxTarget),1) = residual;
                    end
                    start = start + optData.nPoints(idxTarget);
                    
                case 'C' % 'Scalar'
                    if Ci==1 && (Cj==1 || Cj==2)
                        yTarget = (optData.MEAM_Object{targetObject,7}.C{1,1}-optData.MEAM_Object{targetObject,7}.C{1,2})/2;
                        yCalculated = (optData.MEAM_Object{idxResult,6}.SingleElement(1).C(1,1)-optData.MEAM_Object{idxResult,6}.SingleElement(1).C(1,2))/2.0;
                        optData.residuals(start+1:start+1,1) = yTarget - yCalculated;
                        optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
                        start = start + 1;
                    else 
                        yTarget = optData.MEAM_Object{targetObject,7}.C{Ci,Cj};
                        optData.residuals(start+1:start+1,1) = yTarget-optData.MEAM_Object{idxResult,6}.SingleElement(1).C(Ci,Cj);
                        optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
                        start = start + 1;
                    end

                case {'E0', 'Evac'} % 'Scalar'
                    yTarget = optData.MEAM_Object{targetObject,7}.(varName);
                    optData.residuals(start+1:start+1,1) = yTarget-optData.MEAM_Object{idxResult,6}.SingleElement(1).(varName);
                    optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
                    start = start + 1;

                case 'EInterstitial' % 'Scalar'
                    yTarget = optData.MEAM_Object{targetObject,7}.Einterstitials{row};
                    optData.residuals(start+1:start+1,1) = yTarget-optData.MEAM_Object{idxResult,6}.SingleElement(1).interstials(row);
                    optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
                    start = start + 1;

                case 'ESurfaces' % 'Scalar'
                    yTarget = optData.MEAM_Object{targetObject,7}.ESurfaces{row};
                    optData.residuals(start+1:start+1,1) = yTarget-optData.MEAM_Object{idxResult,6}.SingleElement(1).ESurfaces(row);
                    optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
                    start = start + 1;

                case 'GSFEs' % 'Curve'
%                     val = interp1( ...
%                         optData.MEAM_Object{idxResult,6}.SingleElement.shift(row,:), ...
%                         optData.MEAM_Object{idxResult,6}.SingleElement.GSFEs(row,:), ...
%                         optData.MEAM_Object{targetObject,7}.GSFEs{row}.xdata, 'linear', 0.0);
%                     % Calculate residuals
%                     residual = (val - optData.MEAM_Object{targetObject,7}.GSFEs{row}.ydata);
%                     optData.err_est(idxTarget) = norm(residual);
%                     optData.residuals(start+1:start+optData.nPoints(idxTarget),1) = residual/optData.nPoints(idxTarget);
%                     start = start + optData.nPoints(idxTarget);
                    
                    idxLeft = optData.MEAM_Object{targetObject,7}.GSFEs{row}.left;
                    idxRight = optData.MEAM_Object{targetObject,7}.GSFEs{row}.right;
                    if idxLeft==idxRight
                        % distances from calculated values
                        xDiff = optData.MEAM_Object{targetObject,7}.GSFEs{row}.xdata(idxLeft) - ...
                            optData.MEAM_Object{idxResult,6}.SingleElement.shift(row,:);
                        yDiff= optData.MEAM_Object{targetObject,7}.GSFEs{row}.ydata(idxLeft) - ...
                            optData.MEAM_Object{idxResult,6}.SingleElement.GSFEs(row,:);
                        val = dot(xDiff,xDiff) + dot(yDiff,yDiff);
                        % find location of the minimum in the result
                        [~, locResultMin] = min(val); 
                        optData.err_est(idxTarget) = sqrt( val(locResultMin) );
                        optData.residuals(start+1:start+1,1) = optData.err_est(idxTarget);
                    else % interpolate at calibration points
                        val = interp1( ...
                            optData.MEAM_Object{idxResult,6}.SingleElement.shift(row,:), ...
                            optData.MEAM_Object{idxResult,6}.SingleElement.GSFEs(row,:), ...
                            optData.MEAM_Object{targetObject,7}.GSFEs{row}.xdata(idxLeft:idxRight));
                        % Calculate residuals
                        residual = (optData.MEAM_Object{targetObject,7}.GSFEs{row}.ydata(idxLeft:idxRight) - val);
                        residual(isnan(residual)) = 0.0;
                        optData.err_est(idxTarget) = norm(residual);
                        optData.residuals(start+1:start+optData.nPoints(idxTarget),1) = residual;
                    end
                    start = start + optData.nPoints(idxTarget);
            end
            
            
        case 2
            % 1) Binary EV Curves
            % 2) Binary Elastic Constants Calculation
            % 3) Substitution Energy
            % 4) Interstitial Substitution Energy
            if ~isempty(latticeName)
                if Ci~=0 && Cj~=0  % Elastics Cij
                    yTarget = optData.MEAM_Object{targetObject,7}.(varName).(latticeName){row,col,hyt}{Ci,Cj};
                    optData.residuals(start+1:start+1,1) = yTarget-optData.MEAM_Object{idxResult,6}.Alloy.(varName).(latticeName)(Ci,Cj,row,col,hyt);
                    optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
                    start = start + 1;
                    
                elseif strcmp(varName, 'E1')
                    xName = ['a' varName(2:2)];
                    idxLeft = optData.MEAM_Object{targetObject,7}.(varName).(latticeName){row,col,hyt}.left;
                    idxRight = optData.MEAM_Object{targetObject,7}.(varName).(latticeName){row,col,hyt}.right;
                    if idxLeft==idxRight % assume target is curve minimum
                        % find location of the minimum in the result
                        [~, locResultMin] = min(optData.MEAM_Object{idxResult,6}.Alloy.(varName)(:,row,col,hyt));
                        xDiff = optData.MEAM_Object{targetObject,7}.(varName).(latticeName){row,col,hyt}.xdata(idxLeft) - ...
                            optData.MEAM_Object{idxResult,6}.Alloy.(xName)(locResultMin,row,col,hyt);
                        yDiff = optData.MEAM_Object{targetObject,7}.(varName).(latticeName){row,col,hyt}.ydata(idxLeft) - ...
                            optData.MEAM_Object{idxResult,6}.Alloy.(varName)(locResultMin,row,col,hyt);
                        optData.err_est(idxTarget) = sqrt( xDiff^2 + yDiff^2 );
                        optData.residuals(start+1:start+1,1) = optData.err_est(idxTarget);

                    else % interpolate at calibration points
                        val = interp1( ...
                            optData.MEAM_Object{idxResult,6}.Alloy.(xName)(:,row,col,hyt), ...
                            optData.MEAM_Object{idxResult,6}.Alloy.(varName)(:,row,col,hyt), ...
                            optData.MEAM_Object{targetObject,7}.(varName).(latticeName){row,col,hyt}.xdata(idxLeft:idxRight), 'linear', 0.0);
                        % Calculate residuals
                        residual = (optData.MEAM_Object{targetObject,7}.(varName).(latticeName){row,col,hyt}.ydata(idxLeft:idxRight) - val);
                        residual(isnan(residual)) = 0.0;
                        optData.err_est(idxTarget) = norm(residual);
                        optData.residuals(start+1:start+optData.nPoints(idxTarget),1) = residual;
                    end
                    start = start + optData.nPoints(idxTarget);

                else % 'E0', 'H', 'Nx'
                    yTarget = optData.MEAM_Object{targetObject,7}.(varName).(latticeName){row,col,hyt};
                    optData.residuals(start+1:start+1,1) = yTarget-optData.MEAM_Object{idxResult,6}.Alloy.(varName)(row,col,hyt);
                    optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
                    start = start + 1;
                end
                
            else % 'Substitution', 'ISubstitution'
                yTarget = optData.MEAM_Object{targetObject,7}.(varName){row,col};
                optData.residuals(start+1:start+1,1) = yTarget-optData.MEAM_Object{idxResult,6}.Alloy.(varName)(row,col);
                optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
                start = start + 1;
            end
            
        case 3
            yTarget = optData.MEAM_Object{targetObject,7}.(varName){row,col,hyt};
            optData.residuals(start+1:start+1,1) = yTarget-optData.MEAM_Object{idxResult,6}.Alloy.(varName)(row,col,hyt);
            optData.err_est(idxTarget) = abs( optData.residuals(start+1:start+1,1) );
            start = start + 1;
    end
    
    % apply weight
    optData.err_est(idxTarget) = optData.err_est(idxTarget)*optData.err_weight(idxTarget);
    
end

if optData.method==8 % gamultiobj
    y = optData.err_est;
    y'
else
    %y = norm(optData.residuals);
    y = sum(optData.err_est);
end





% --------------------------------------------------------------------
function File_LAMMPS_open_Callback(hObject, eventdata, handles)
% hObject    handle to File_LAMMPS_open (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

display('===== Re-open LAMMPS()')
        
options.Resize = 'on';
options.WindowStyle = 'normal';
options.Interpreter = 'none';
numlines = 1;
name = 'User input';
nArgs = 10;
prompt = cell(nArgs,1);
defaultanswer = cell(nArgs,1);
for i=1:nArgs
    prompt{i} = sprintf('Argument #%d', i);
    if i<=length(handles.LAMMPS_open_args)
        defaultanswer{i} = handles.LAMMPS_open_args{i};
    else
        defaultanswer{i} = '';
    end
end

prompt{1} = sprintf('Re-open LAMMPS with the following arguments:\n\n%s', prompt{1});
answer = inputdlg(prompt, name, numlines, defaultanswer, options);
if isempty(answer)
    display('User cancel: Re-open LAMMPS')
    return
end

% delete null strings
for i=nArgs:-1:1
    if isempty(answer{i}), answer(i) = []; end
end
answer

try
    
    if ~isempty(handles.LAMMPS_ptr)
        lammps_close(handles.LAMMPS_ptr);
    end
    
    switch size(answer,1)
        
        case 1
            handles.LAMMPS_ptr = lammps_open(answer{1});

        case 2
            handles.LAMMPS_ptr = lammps_open( answer{1}, answer{2});
        case 3
            handles.LAMMPS_ptr = lammps_open( answer{1}, answer{2}, answer{3});
        case 4
            handles.LAMMPS_ptr = lammps_open( ...
                answer{1}, answer{2}, answer{3}, answer{4});
        case 5
            handles.LAMMPS_ptr = lammps_open( ...
                answer{1}, answer{2}, answer{3}, answer{4}, answer{5});
        case 6
            handles.LAMMPS_ptr = lammps_open( ...
                answer{1}, answer{2}, answer{3}, answer{4}, answer{5}, answer{6});
        case 7
            handles.LAMMPS_ptr = lammps_open( ...
                answer{1}, answer{2}, answer{3}, answer{4}, answer{5}, answer{6}, ...
                answer{7});
        case 8
            handles.LAMMPS_ptr = lammps_open( ...
                answer{1}, answer{2}, answer{3}, answer{4}, answer{5}, answer{6}, ...
                answer{7}, answer{8});
        case 9
            handles.LAMMPS_ptr = lammps_open( ...
                answer{1}, answer{2}, answer{3}, answer{4}, answer{5}, answer{6}, ...
                answer{7}, answer{8}, answer{9});
        case 10
            handles.LAMMPS_ptr = lammps_open( ...
                answer{1}, answer{2}, answer{3}, answer{4}, answer{5}, answer{6}, ...
                answer{7}, answer{8}, answer{9}, answer{10} );

        otherwise
            display('Out of range')
            answer{1} = '-log';
            answer{2} = 'none';
            handles.LAMMPS_ptr = lammps_open( answer{1}, answer{2} );
    end
        
catch
    handles.LAMMPS_ptr = [];
    answer{1} = '(LAMMPS executable not available)';
end

handles.LAMMPS_open_args = answer;
guidata(hObject, handles)

msgbox(['Re-opened LAMMPS with the following arguments:'; ...
    handles.LAMMPS_open_args], ...
    get(hObject, 'Label'), 'none', 'modal')





function UIpositions = Remember_Positions(hObject)
% get positions of UI controls

UIpositions = [];

% the list of UI controls
objList = findobj( 'Style', 'edit', ...
    '-or', 'Style', 'pushbutton', ...
    '-or', 'Style', 'text', ...
    '-or', 'Style', 'slider', ...
    '-or', 'Style', 'popupmenu', ...
    '-or', 'Style', 'checkbox');

% add figure & plot panel
objList = [hObject; objList; findobj('Tag', 'panel_Plots')];

for i=1:length(objList)

    % remember Units
    oldUnits = get(objList(i), 'Units');   
    % set Units temporarily to characters
    set(objList(i), 'Units', 'characters');
    
    tag = get(objList(i), 'Tag');
    UIpositions.(tag).Position = get(objList(i), 'Position');
    % display( sprintf('0 - %s: [x=%g y=%g w=%g h=%g]', tag, UIpositions.(tag).Position) )

    % restore Units
    set(objList(i), 'Units', oldUnits);
end


% --- Executes when MPCv4 is resized.
function MPCv4_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to MPCv4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


if ~isfield(handles, 'UIpositions'), return, end

% figure's old position
tag = get(hObject, 'Tag');
oldPos = handles.UIpositions.(tag).Position;
% display( sprintf('Was: %s @[x=%g y=%g w=%g h=%g]', tag, oldPos) )

% figure's new Position
oldUnits = get(hObject, 'Units');
set(hObject, 'Units', 'characters')
newPos = get(hObject, 'Position');
% display( sprintf('Now: %s @ [x=%g y=%g w=%g h=%g]', tag, newPos) )

% reject smaller figure size
if newPos(3)<oldPos(3) || newPos(4)<oldPos(4)
    set(hObject, 'Position', oldPos)
    yOffset = 0;
else
    yOffset = newPos(4) - oldPos(4);
end
set(hObject, 'Units', oldUnits)
% display(yOffset)

objList = findobj( 'Style', 'edit', ...
    '-or', 'Style', 'pushbutton', ...
    '-or', 'Style', 'text', ...
    '-or', 'Style', 'slider', ...
    '-or', 'Style', 'popupmenu', ...
    '-or', 'Style', 'checkbox');


% UI controls
for i=1:length(objList)
    tag = get(objList(i), 'Tag');

    if isempty(tag), continue, end
    if ~isfield(handles.UIpositions, tag), continue, end
    if ~isfield(handles.UIpositions.(tag), 'Position'), continue, end
    
    % remember Units
    oldUnits = get(objList(i), 'Units');
    
    % set Units temporarily to characters
    set(objList(i), 'Units', 'characters');
 
    % re-position 
    current = handles.UIpositions.(tag).Position;    
    
    if strcmpi(tag, 'text_Display') || strcmpi(tag, 'text_Includes')
        % revise height of text_Display
        current(4) = current(4) + yOffset;
    else % revise y-coordinate
        current(2) = current(2) + yOffset;
    end
    
    set(objList(i), 'Position', current )
    
    % restore Units
    set(objList(i), 'Units', oldUnits);
end

% plot panel
tag = 'panel_Plots';
obj = findobj('Tag', tag);
oldUnits = get(obj, 'Units');
set(obj, 'Units', 'characters');

% re-position 
current = get(obj, 'Position');
xOffset = current(1) - handles.UIpositions.(tag).Position(1);
current(1) = handles.UIpositions.(tag).Position(1);
current(3) = current(3) + xOffset;

set(obj, 'Position', current )
set(obj, 'Units', oldUnits)


function Text_Display_Menu(hObject, eventdata, action)
% increase/decrease font size

handles = guidata(hObject);
current = get(handles.text_Display, 'FontSize');
switch action

    case 'Bigger'
        current = current + 1;
        
    case 'Smaller'
        current = current - 1;

    case 'Write'
        MEAM_Object = get(handles.label_Library, 'UserData');
        idxObject = get(handles.Library_Entry_Select, 'Value');
        if isempty(MEAM_Object) || idxObject<=0, return, end
        tStr = cellstr(get(handles.text_Display, 'String'));
        fname = [MEAM_Object{idxObject,2} '-Display.txt'];
        fid = fopen(fname, 'wt');
        fprintf(fid, '%s\n', tStr{:});
        fclose(fid);
        msgbox(['Wrote text display to ' fullfile(pwd, fname)], ...
            'Write to file', 'none', 'modal')

    otherwise
        
end
set([handles.text_Display,handles.text_Includes], 'FontSize', current)



function Text_Includes_Menu(hObject, eventdata, list)
% reset RUN/DISPLAY lists

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');
% numElements = size(MEAM_Object{end,1},2);
% elementIdx = MEAM_Object{idxObject,1};
% tag = MEAM_Object{idxObject,2};
% toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
% runData = MEAM_Object{idxObject,6};
% calibrationData = MEAM_Object{idxObject,7};


switch list

    case 'ALL'
        for idxObject=1:size(MEAM_Object,1)
            MEAM_Object{idxObject,3} = 0;
        end
        
    case 'RUN'
        for idxObject=1:size(MEAM_Object,1)
            toggleRunPlot = MEAM_Object{idxObject,3};
            switch toggleRunPlot
                case 1
                    toggleRunPlot = 0;
                case 3
                    toggleRunPlot = 2;
            end
            MEAM_Object{idxObject,3} = toggleRunPlot;
        end

    case 'DISPLAY'
        for idxObject=1:size(MEAM_Object,1)
            toggleRunPlot = MEAM_Object{idxObject,3};
            if toggleRunPlot>1
                toggleRunPlot = toggleRunPlot-2; 
            end
            MEAM_Object{idxObject,3} = toggleRunPlot;
        end

    otherwise
        
end

set(handles.label_Library, 'UserData', MEAM_Object)
idxObject = get(handles.Library_Entry_Select, 'Value');
Text_Display_Object(handles, MEAM_Object, idxObject)



function Toggle_Flag_RunPlot(hObject, eventdata, idxObject, action)
% toggle run & plot flags

handles = guidata(hObject);
MEAM_Object = get(handles.label_Library, 'UserData');
% numElements = size(MEAM_Object{end,1},2);
% elementIdx = MEAM_Object{idxObject,1};
% tag = MEAM_Object{idxObject,2};
toggleRunPlot = MEAM_Object{idxObject,3};
% libEntry = MEAM_Object{idxObject,4};
% lattice = MEAM_Object{idxObject,5};
% runData = MEAM_Object{idxObject,6};
% calibrationData = MEAM_Object{idxObject,7};

switch action

    case 'Run'
        switch toggleRunPlot
            case 0
                toggleRunPlot = 1;
            case 1
                toggleRunPlot = 0;
            case 2
                toggleRunPlot = 3;
            case 3
                toggleRunPlot = 2;
        end
        
    case 'Plot'
        switch toggleRunPlot
            case 0
                toggleRunPlot = 2;
            case 1
                toggleRunPlot = 3;
            case 2
                toggleRunPlot = 0;
            case 3
                toggleRunPlot = 1;
        end
        
    otherwise
        % unknown flag
        
end

MEAM_Object{idxObject,3} = toggleRunPlot;
set(handles.label_Library, 'UserData', MEAM_Object)

Text_Display_Object(handles, MEAM_Object, idxObject)


% --- Executes on button press in Run_calculations_Selected.
function Run_calculations_Callback(hObject, eventdata, handles)
% hObject    handle to Run_calculations_Selected (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

MEAM_Object = get(handles.label_Library, 'UserData');
numElements = max(MEAM_Object{end,1});
element_list = Elements_List(MEAM_Object);
action = get(hObject, 'Tag');
objectList = get(hObject, 'Userdata');
display(['===== ' action sprintf(' : %s', MEAM_Object{objectList,2})])
display(['Element(s): ' element_list]);

% calculation flags
SEflags = zeros(1,length(handles.SingleElementCalculation));
Bflags = zeros(1,length(handles.BinaryCalculation));
Tflags = zeros(1,length(handles.TernaryCalculation));
%     results_Y = {'rose_E', 'E1', 'E2', 'E3', ...
%         'Evac', 'Einterstitials', ...
%         'GSFEs', 'ESurfaces', ...
%         'Substitution', 'ISubstitution', 'BindingEnergy', 'E0', 'alpha', 'H', 'Nx', 'C'};

% 1) Primary EV curve
% 2) Secondary EV curve
% 4) Secondary2 EV curve
% 8) Elastic Constants Calculation
% 16) Vacancy Energy Calculation
% 32) Interstitital Energy Calculations
% 64) Surface Energy Calculations
% 128) Generalized Stacking Fault Energy Calculations
SEcalculation = {'E1', 'E2', 'E3','C','Evac', 'Einterstitials', 'ESurfaces', 'GSFEs'};

% 1) Binary EV Curves
% 2) Binary Elastic Constants Calculation
% 4) Substitution Energy
% 8) Interstitial Substitution Energy
Bcalculation = {'E1', 'C', 'Substitution', 'ISubstitution'};

% Binding Energy
Tcalculation = {'BindingEnergy'};

% collect objects for which the LAMMPS calculations can proceed because the
% primary, secondary1 & secondary2 structures are specified
tObjects = [];
calculationList = {};
for idx=objectList
    objectSize = size(MEAM_Object{idx,1},2);

    % check if the structures of component elements are specified
    definedLattices = true;
    tmpString = ''; % list of components not specified
    for i=MEAM_Object{idx,1}
        if MEAM_Object{i,5}(1)==0 || MEAM_Object{i,5}(2)==0 || MEAM_Object{i,5}(3)==0
            tmpString = [tmpString ' ' MEAM_Object{i,2}];
            definedLattices = false;
        end
    end
    if ~definedLattices
        display([MEAM_Object{idx,2} ' : structures NOT specified for' tmpString])
        continue
    end

    % for binaries, check if binary lattice is specified
    if objectSize==2 && isempty(MEAM_Object{idx,5})
        display([MEAM_Object{idx,2} ' : binary lattice  NOT specified'])
        continue
    end

    % calculation flags dictated by Plot_Result_*
    SEflags(:) = 0;
    Bflags(:) = 0;
    Tflags(:) = 0;
    sumFlags = 0;

    switch objectSize

        case 1
            calculateFlag = SEflags;
            for i=1:length(SEcalculation)
                calculateFlag(i) = strcmpi(get(handles.(['Plot_Result_' SEcalculation{i}]), 'Checked'), 'On');
            end

            % force Primary EV for 16+
            if sum(calculateFlag(4:end))>0 || calculateFlag(1)==0
                calculateFlag(1) = 1;
            end
            SEflags = calculateFlag;

            for i=1:length(handles.SingleElementCalculation)
                if calculateFlag(i)
                    sumFlags = sumFlags + 2^(i-1);
                end
            end

        case 2
            %runDesc = handles.BinaryCalculation;
            calculateFlag = Bflags;
            for i=1:length(Bcalculation)
                calculateFlag(i) = strcmpi(get(handles.(['Plot_Result_' Bcalculation{i}]), 'Checked'), 'On');
            end
            % force Binary EV Curves calculation if Binary Elastic Constants required
            if calculateFlag(2) || calculateFlag(1)==0
                calculateFlag(1) = 1;
            end
            Bflags = calculateFlag;        
            % force single element Primary EV Curve calculation dependencies
            if calculateFlag(1)+calculateFlag(3)+calculateFlag(4)>0
                SEflags(1) = 1;
            end

            for i=1:length(handles.BinaryCalculation)
                if calculateFlag(i)
                    sumFlags = sumFlags + 2^(i-1);
                end
            end
            

        otherwise
            if strcmpi(get(handles.(['Plot_Result_' Tcalculation{1}]), 'Checked'), 'On')
                Tflags     = 1; % Binding Energy
                Bflags(3)  = 1; % Substitution Energy
                Bflags(4)  = 1; % ISubstitution Energy
                Bflags(1)  = 1; % Binary EV
                SEflags(1) = 1; % Primary EV
                sumFlags = 1;
            else
                sumFlags = 0;
            end

    end

    if sumFlags>0 % add object to list
        tObjects(end+1) = idx;
        calculationList{end+1} = {SEflags, Bflags, Tflags};

        display([MEAM_Object{idx,2} ' : structures complete.'])
    end
    
end

if isempty(tObjects)
    display('Objects and/or structures not specified. LAMMPS calculations cannot proceed.')
    return
end

objectList = tObjects;
display(['Objects are: ' sprintf('%s ', MEAM_Object{objectList,2})] )

% expand binaries and ternaries in object list
expandedList = [];
calculationFlag = {};
for i=1:length(objectList)
    idx = objectList(i);
    SEflags = calculationList{i}{1};
    Bflags = calculationList{i}{2};
    Tflags = calculationList{i}{3};
    
    for j=MEAM_Object{idx,1} % for each element in object
        pos = find(expandedList==j,1);
        if pos % element is already in expandedList
            calculationFlag{pos}{1} = calculationFlag{pos}{1} + SEflags;
%             display(['A2. Element already in list: ' MEAM_Object{j,2}])
%             display(handles.SingleElementCalculation(calculationFlag{pos}{1}>0)')
            continue
        end
        expandedList(end+1) = j; % add element
        calculationFlag{end+1} = {SEflags, zeros(size(Bflags)), zeros(size(Tflags))};
%         display(['A1. Element added to list: ' MEAM_Object{j,2}])
%         display(handles.SingleElementCalculation(SEflags>0)')
    end
    
    if find(expandedList==idx), continue, end % object is already in expandedList
    
    if size(MEAM_Object{idx,1},2)>2 % object is a ternary? 
        Binary = nchoosek(MEAM_Object{idx,1},2); % make list of binaries in ternary object
        numBinaries = size(Binary,1); % how many binaries in ternary object
        for k=1:numBinaries % for each binary in ternary object
            for l=1:size(MEAM_Object,1) % examine all objects
                if size(MEAM_Object{l,1},2)~=2, continue, end % object is not a binary
                if MEAM_Object{l,1}==Binary(k,1:2) % object is a binary AND is in ternary under consideration

                    pos = find(expandedList==l,1);
                    if pos % element is already in expandedList
                        calculationFlag{pos}{2} = calculationFlag{pos}{2} + Bflags;
%                         display(['B2. Binary already in list: ' MEAM_Object{l,2}])
%                         display(handles.BinaryCalculation(calculationFlag{pos}{2}>0)')
                        continue
                    end

                    
                    expandedList(end+1) = l; % add binary
                    calculationFlag{end+1} = {zeros(size(SEflags)), Bflags, zeros(size(Tflags))};
%                     display(['B1. Binary added to list: ' MEAM_Object{l,2}])
%                     display(handles.BinaryCalculation(Bflags>0)')
                    break % move to next binary in ternary object
                end
            end
        end
    end
    
    expandedList(end+1) = idx; % add object
    switch size(MEAM_Object{idx,1},2)
        case 1
            calculationFlag{end+1} = {SEflags>0, zeros(size(Bflags)), zeros(size(Tflags))};
%             display(['A3. Element added to list: ' MEAM_Object{idx,2}])
%             display(handles.SingleElementCalculation(SEflags>0)')
        case 2
            calculationFlag{end+1} = {zeros(size(SEflags)), Bflags>0, zeros(size(Tflags))};
%             display(['B3. Binary added to list: ' MEAM_Object{idx,2}])
%             display(handles.BinaryCalculation(Bflags>0)')
        case 3
            calculationFlag{end+1} = {zeros(size(SEflags)), zeros(size(Bflags)), Tflags>0};
%             display(['C1. Ternary added to list: ' MEAM_Object{idx,2}])
%             display(handles.TernaryCalculation(Tflags>0)')
    end
    
end
[expandedList, IX] = sort(expandedList);
calculationFlag = calculationFlag(IX);

% calculations
for i=length(expandedList):-1:1
    idx = expandedList(i);
    display(['Calculations for ' MEAM_Object{idx,2}])
    switch size(MEAM_Object{idx,1},2)
        case 1
            display(handles.SingleElementCalculation(calculationFlag{i}{1}>0)')
        case 2
            display(handles.BinaryCalculation(calculationFlag{i}{2}>0)')
        case 3
            display(handles.TernaryCalculation(calculationFlag{i}{3}>0)')
    end

end


% synchronize binary lattices
lattice = [];
for j=1:length(expandedList)
    idxObject = expandedList(j);
    if size(MEAM_Object{idxObject,1},2)~=2, continue, end
    for i=MEAM_Object{idxObject,5}
        if find(lattice==i), continue, end
        lattice(end+1) = i;
    end
end
if ~isempty(lattice)
    display('Binary lattices')
    display(handles.BLattices(lattice)')
    % copy to individual objects
    for j=1:length(expandedList)
        idxObject = expandedList(j);
        if size(MEAM_Object{idxObject,1},2)~=2, continue, end
        MEAM_Object{idxObject,5} = lattice;
    end
end


% working directory name
multi_tag = 'Evaluate';
if strcmpi(get(handles.File_Use_tempname, 'Checked'), 'On')
    [~, timeStamp, ~] = fileparts(tempname);
else
    timeStamp = 'files';
end

% LAMMPS files
LAMMPS_dir = get(handles.File_LAMMPS_WorkDirectory_Select, 'UserData');
baseFileName = strrep(element_list, ' ', '');
libFile = [baseFileName '.library.meam'];
paramFile = [baseFileName '.parameter.meam'];

% working directory
run_dir = fullfile(LAMMPS_dir, multi_tag, timeStamp);
[~, ~, ~] = mkdir(run_dir);
display(['Scratch dir is ' fullfile(multi_tag, timeStamp)])

% write the library file to run directory
library = cell(1,numElements);
for idx=1:numElements
    library{idx} = MEAM_Object{idx,4};
end
meam_lib = fullfile(run_dir, libFile);
mesg = File_Library_Write(handles, meam_lib, ...
    library, [1:numElements], multi_tag);
if ~isempty(mesg)
    display(mesg)
    return
end
display(['Library file is ' libFile])

% copy the parameter file to run directory
parameters = get(handles.label_Parameters, 'UserData');
meam_param = fullfile(run_dir, paramFile);
mesg = File_Parameters_Write( meam_param, parameters );
% mesg = Parameter_File_Write_From_Display(handles, meam_param, '');
if ~isempty(mesg)
    display(mesg)
    return
end
display(['Parameter file is ' paramFile])

h = msgbox('Please wait until calculations are complete.', ...
    action, 'warn', 'modal');
MEAM_Object = MPC_Run_LAMMPS( handles, meam_lib, meam_param, ...
    MEAM_Object, expandedList, calculationFlag, true);
if ishandle(h), delete(h); end

set(handles.label_Library, 'UserData', MEAM_Object)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)



% --------------------------------------------------------------------
function Plot_Toggle(hObject, eventdata, handles)

% hObject    handle to Plot_Select_{Elements, Binaries, Ternaries} (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if strcmpi(get(hObject, 'Tag'), 'Plot_ALL')
    objList = findobj('-regexp', 'Tag', '^Plot_Result_');
    checkedStatus = 'On';
else
    objList = hObject;
    checkedStatus = get(hObject, 'Checked');
    if strcmpi(checkedStatus, 'On')
        checkedStatus = 'Off';
    else
        checkedStatus = 'On';
    end
end
set(objList, 'Checked', checkedStatus)

Parameter_Entries_Select_Callback(handles.Parameter_Entries_Select, eventdata, handles)




% --------------------------------------------------------------------
function Plot_Dimension_Callback(hObject, eventdata, handles)
% hObject    handle to Plot_Dimension (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% uncheck all Plot_Dimension_*
set(findobj('-regexp', 'Tag', 'Plot_Dimension*'), 'Checked', 'off')

% check selected Plot_Dimension
set(hObject, 'Checked', 'On')

% update choices and default selection for Plot_Position
switch get(hObject, 'Tag')
    
    case 'Plot_Dimension_111'
        set(handles.Plot_Position, 'Enable', 'On', 'Userdata', cell(1,1), ...
            'String', {'subplot(1,1,1)'}, 'Value', 1 )
        
    case 'Plot_Dimension_1x2'
        set(handles.Plot_Position, 'Enable', 'On', 'Userdata', cell(1,2), ...
            'String', {'subplot(1,2,1)', 'subplot(1,2,2)'}, 'Value', 1 )

    case 'Plot_Dimension_2x1'
        set(handles.Plot_Position, 'Enable', 'On', 'Userdata', cell(2,1), ...
            'String', {'subplot(2,1,1)', 'subplot(2,1,2)'}, 'Value', 1 )

    case 'Plot_Dimension_2x2'
        set(handles.Plot_Position, 'Enable', 'On', 'Userdata', cell(2,2), ...
            'String', {'subplot(2,2,1)', 'subplot(2,2,2)', ...
                       'subplot(2,2,3)', 'subplot(2,2,4)'}, 'Value', 1 )
end

% clear plot area
subplot(1, 1, 1)
plot(0,0)
cla reset
axis off



% --- Executes on selection change in Plot_control_selectY.
function Plot_control_selectVar_Callback(hObject, eventdata, handles)
% hObject    handle to Plot_control_select(X,Y) (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns Plot_control_selectY contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Plot_control_selectY

% automatically update if single plot
plotDim = size(get(handles.Plot_Position, 'Userdata'));
if plotDim(1)*plotDim(2)==1
    Plot_Position_Callback(handles.Plot_Position, eventdata, handles)
end


% --- Executes on selection change in Plot_Position.
function Plot_Position_Callback(hObject, eventdata, handles)
% hObject    handle to Plot_Position (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%
% associate "yValue vs. xValue" with selected plot position

% Hints: contents = cellstr(get(hObject,'String')) returns Plot_Position contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Plot_Position

% results_Y = {'rose_E', 'E1', 'E2', 'E3', ...
%     'Evac', 'Einterstitials', ...
%     'GSFEs', 'ESurfaces', ...
%     'Substitution', 'ISubstitution', 'BindingEnergy', 'E0', 'alpha', 'H', 'Nx', 'C'};
% results_X = {'(default)', 'E0', 'alpha', 'H', 'Nx'};

% which y-values, x-values?
strDefault = '(default)';
contents = cellstr(get(handles.Plot_control_selectY,'String'));
yIdx = get(handles.Plot_control_selectY,'Value');
if yIdx>length(contents), yIdx = 1; end
yValue = contents{yIdx};
set(handles.Plot_control_selectY,'Value',yIdx)

contents = cellstr(get(handles.Plot_control_selectX,'String'));
xIdx = get(handles.Plot_control_selectX,'Value');
if xIdx>length(contents), xIdx = 1; end
xValue = contents{xIdx};

% force certain yValue plots to have xValue=default
if strcmp(yValue, xValue) % same variable on x-axis and y-axis
    xValue = strDefault;
    xIdx = 1;
else
    switch yValue

%         case {'rose_E', 'E1', 'E2', 'E3'} % EV curves
%             xValue = strDefault;
%             xIdx = 1;
% 
%         case {'GSFEs'} % GSFE curves
%             xValue = strDefault;
%             xIdx = 1;

        case {'Substitution', 'ISubstitution', 'BindingEnergy'}
            xValue = strDefault;
            xIdx = 1;
    end
end
set(handles.Plot_control_selectX,'Value',xIdx)

% how many plots, plot on focus
plotList = get(hObject, 'Userdata');
plotDim = size(plotList);
plotIndex = get(hObject, 'Value');

% associate "yValue vs. xValue" plot with plotIndex
[row,col] = ind2sub(plotDim, plotIndex);
plotList{row,col} = {xValue,yValue};
set(hObject, 'Userdata', plotList)
% plotList

% update all plots
Plot_control_update_Callback(handles.Plot_control_update, eventdata, handles)


% --- Executes on button press in Plot_control_update.
function Plot_control_update_Callback(hObject, eventdata, handles)
% hObject    handle to Plot_control_update (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% how many plots
plotList = get(handles.Plot_Position, 'Userdata');
if isempty(plotList), return, end
plotDim = size(plotList);

% update all plots
for j=1:plotDim(2)
    for i=1:plotDim(1)
        plotIndex = sub2ind(plotDim,i,j);
        if isempty(plotList{i,j}), continue, end
        Plot_Update(handles, plotDim, plotIndex, plotList{i,j}{1}, plotList{i,j}{2})
    end
end


function Plot_Update(handles, plotDim, plotIndex, xValue, yValue)
% update subplot(plotDim(1), plotDim(2), plotIndex)

% collect indices to elements, binaries, ternaries to plot
MEAM_Object = get(handles.label_Library, 'UserData');
objectList = [];
nColors = 0; % how many colors will be needed?
colorIdx.temp = 0; % unique colors for each object+curve
idxIncr = 5;
strDefault = '(default)';

for idx=1:size(MEAM_Object,1)
    
    if isempty(MEAM_Object{idx,6}), continue, end % no results
    
    if MEAM_Object{idx,3} <= 1, continue, end % not plotted
    
    objectList(end+1) = idx;
    objType = size(MEAM_Object{idx,1},2);
    tag = strrep(MEAM_Object{idx,2}, '+', '_');
    lattice = MEAM_Object{idx,5};
    runData = MEAM_Object{idx,6};

    switch objType % what kind of object
        
        case 1 % an element
            
            switch yValue
                
                case {'rose_E', 'E1', 'E2', 'E3'} 
                    % one color each for Rose, E1, E2, E3
                    colorIdx.(tag).rose_E = nColors+idxIncr;
                    colorIdx.(tag).E1 = nColors+2*idxIncr;
                    colorIdx.(tag).E2 = nColors+3*idxIncr;
                    colorIdx.(tag).E3 = nColors+4*idxIncr;
                    nColors = nColors + 4*idxIncr;
                    
                    
                case {'GSFEs'}  
                    % one color per GSFE curve
                    for i=1:size(runData.SingleElement.GSFEs,1)
                        nColors = nColors + idxIncr;
                        colorIdx.(tag).(['GSFEs_' num2str(i)]) = nColors;
                    end
                    
                case {'Einterstitials', 'ESurfaces', 'E0', 'alpha', 'Evac', 'C'} 
                    % one color per tag
                    nColors = nColors + idxIncr;
                    colorIdx.(tag).(yValue) = nColors;
            end
            
        case 2 % a binary
            
            switch yValue
                
                case {'E1','H', 'Nx', 'E0', 'C'} % one color per Binary lattice
                    for i=1:size(lattice,2)
                        for j=1:objType
                            for k=1:objType % 1:(j-1)
                                if k>size(runData.Alloy.BLattices,3), continue, end
                                BLattices = runData.Alloy.BLattices{i, j, k};
                                if isempty(BLattices), continue, end
                                latticeName = strrep(BLattices, '-', '_');
                                nColors = nColors+idxIncr;
                                colorIdx.(latticeName).(yValue) = nColors;
                            end
                        end
                    end
                    
                case {'Substitution', 'ISubstitution', 'BindingEnergy'} 
                    % one color per tag
                    nColors = nColors+idxIncr;
                    colorIdx.(tag).Substitution = nColors;
                    colorIdx.(tag).ISubstitution = nColors;
            end

            
        case 3 % a ternary
            switch yValue
                case {'Substitution', 'ISubstitution', 'BindingEnergy'} 
                    % one color per tag
                    nColors = nColors + idxIncr;
                    colorIdx.(tag).BindingEnergy = nColors;
            end
            
    end
            
end

% font sizes [points, legend, axis, title]
% if plotDim(1)*plotDim(2)==1
%     fontSizes = [7, 7, 8, 8];
% else
    fontSizes = [6, 6, 7, 7];
% end

% clear plot area
subplot(plotDim(1), plotDim(2), plotIndex)
plot(0,0)
cla reset
axis off
set(gca, 'FontSize', fontSizes(3))

% anything to plot?
if isempty(objectList)
%     display('Nothing to plot?')
    return
end

if strcmp(xValue, strDefault)
    MPC_Plot_Default_xValue(handles, MEAM_Object, yValue, xValue, objectList, nColors, colorIdx, fontSizes)
else
    MPC_Plot_Scatter(handles, MEAM_Object, yValue, xValue, objectList, nColors, colorIdx, fontSizes)
end







